#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "pars.yacc"

/* $Id: pars.yacc,v 1.4 1995/06/30 22:32:11 pturner Exp pturner $
 * 
 * evaluate expressions, commands, parameter files
 * 
 */

#define PARS			

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <sys/param.h>

#include "globals.h"
#include "protos.h"

#ifndef M_PI
#     define M_PI  3.14159265358979323846
#endif

#ifndef TRUE
#     define TRUE 1
#endif

#ifndef FALSE
#     define FALSE 0
#endif

double result, resx, resy;	/* return value if expression */
double nonl_parms[10];

double drand48(void);
long lrand48(void);
double erf(double arg); /* doesn't seem to be in ANSI C */
double erfc(double arg); /* doesn't seem to be in ANSI C */
double rnorm(double mean, double sdev);
double fx(double x);
double normp(double b, double *s);
double invnorm(double p);
double invt(double p, int n);
double *getvptr(int gno, int setno, int v);
double vmin(double *x, int n);
double vmax(double *x, int n);
void yyerror(char *s);

static int interr;

static double *freelist[100]; 	/* temporary vectors */
static int fcnt;		/* number allocated */

int naxis = 0;	/* current axis */
int curline, curbox, curellipse, curstring, curleg, curgrid;

int gotbatch, gotparams, gotread; /* these guys attempt to avoid reentrancy problems */
int readtype, readsrc, readxformat;
char batchfile[256], paramfile[256], readfile[256];

static char f_string[512];	/* buffer for string to parse */
static int pos = 0;
static double *aa, *bb, *cc, *dd, *xx, *yy;
static int setindex, lxy, ls;
static int setsetno;
static int whichgraph;
static int whichset;

extern int change_gno;
extern int change_type;

#line 76 "pars.yacc"
typedef union {
    double val;
    long ival;
    double *ptr;
    long func;
    long pset;
    char *str;
} YYSTYPE;
#line 88 "y.tab.c"
#define ABS 257
#define ACOS 258
#define ASIN 259
#define ATAN 260
#define ATAN2 261
#define CEIL 262
#define COS 263
#define DEG 264
#define DX 265
#define DY 266
#define ERF 267
#define ERFC 268
#define EXP 269
#define FLOOR 270
#define HYPOT 271
#define INDEX 272
#define INT 273
#define INVN 274
#define INVT 275
#define IRAND 276
#define JDAY 277
#define JDAY0 278
#define LGAMMA 279
#define LN 280
#define LOG 281
#define LOGISTIC 282
#define MAXP 283
#define MINP 284
#define MOD 285
#define NORM 286
#define NORMP 287
#define PI 288
#define RAD 289
#define RAND 290
#define RNORM 291
#define SETNO 292
#define SIN 293
#define SQR 294
#define SQRT 295
#define TAN 296
#define INUM 297
#define VX1 298
#define VX2 299
#define VY1 300
#define VY2 301
#define WX1 302
#define WX2 303
#define WY1 304
#define WY2 305
#define DELAYP 306
#define DOUBLEBUFFER 307
#define DOWN 308
#define ABSOLUTE 309
#define ABORT 310
#define ACTIVATE 311
#define ACTIVE 312
#define ALT 313
#define ALTERNATE 314
#define ALTXAXIS 315
#define ALTYAXIS 316
#define ANGLE 317
#define ANNOTATE 318
#define APPEND 319
#define AREA 320
#define ARRANGE 321
#define ARROW 322
#define ASCENDING 323
#define AUTO 324
#define AUTOSCALE 325
#define AUTOTICKS 326
#define AVG 327
#define AXIS 328
#define AXES 329
#define BACKBUFFER 330
#define BACKGROUND 331
#define BAR 332
#define BATCH 333
#define BLOCK 334
#define BIN 335
#define BOTH 336
#define BOTTOM 337
#define BOX 338
#define BOXPLOT 339
#define CD 340
#define CELLS 341
#define CENTER 342
#define CHAR 343
#define CHRSTR 344
#define CLEAR 345
#define CLICK 346
#define CMAP 347
#define COLOR 348
#define COMMENT 349
#define COPY 350
#define CYCLE 351
#define DECIMAL 352
#define DEF 353
#define DEFAULT 354
#define DELETE 355
#define DEVICE 356
#define DESCENDING 357
#define DFT 358
#define DIFFERENCE 359
#define DISK 360
#define DRAW2 361
#define DROP 362
#define DXDX 363
#define DXP 364
#define DYDY 365
#define DYP 366
#define ECHO 367
#define EDIT 368
#define ELSE 369
#define END 370
#define ERRORBAR 371
#define EXIT 372
#define EXPONENTIAL 373
#define FALSEP 374
#define FFT 375
#define FILEP 376
#define FILL 377
#define FIND 378
#define FIXEDPOINT 379
#define FLUSH 380
#define FOCUS 381
#define FOLLOWS 382
#define FONTP 383
#define FOREGROUND 384
#define FORMAT 385
#define FRONTBUFFER 386
#define FRAMEP 387
#define GETP 388
#define GRAPH 389
#define GRAPHNO 390
#define GRAPHS 391
#define GRAPHTYPE 392
#define GRID 393
#define HARDCOPY 394
#define HBAR 395
#define HBOXPLOT 396
#define HGAP 397
#define HIDDEN 398
#define HORIZONTAL 399
#define HPGLL 400
#define HPGLP 401
#define HISTO 402
#define IF 403
#define IGNORE 404
#define IHL 405
#define IMAGE 406
#define IN 407
#define INIT 408
#define INOUT 409
#define INTEGRATE 410
#define INTERP 411
#define INVDFT 412
#define INVFFT 413
#define JUST 414
#define KILL 415
#define LABEL 416
#define LAYOUT 417
#define LEAVE 418
#define LEFT 419
#define LEGEND 420
#define LENGTH 421
#define LEVEL 422
#define LEVELS 423
#define LINE 424
#define LINESTYLE 425
#define LINETO 426
#define LINEWIDTH 427
#define LINK 428
#define LOAD 429
#define LOCATOR 430
#define LOCTYPE 431
#define LOGX 432
#define LOGY 433
#define LOGXY 434
#define MAJOR 435
#define MIFL 436
#define MIFP 437
#define MINOR 438
#define MISSINGP 439
#define MOVE 440
#define MOVE2 441
#define MOVETO 442
#define NEGATE 443
#define NO 444
#define NONE 445
#define NORMAL 446
#define NXY 447
#define OFF 448
#define OFFSETX 449
#define OFFSETY 450
#define ON 451
#define OP 452
#define ORIENT 453
#define OUT 454
#define PAGE 455
#define PARA 456
#define PARALLEL 457
#define PARAMETERS 458
#define PARAMS 459
#define PATTERN 460
#define PERIMETER 461
#define PERP 462
#define PERPENDICULAR 463
#define PIE 464
#define PIPE 465
#define PLACE 466
#define POINT 467
#define POLAR 468
#define POLY 469
#define POWER 470
#define PREC 471
#define PREPEND 472
#define PRINT 473
#define PS 474
#define PSCOLORP 475
#define PSMONOP 476
#define PSCOLORL 477
#define PSMONOL 478
#define PUSH 479
#define POP 480
#define PUTP 481
#define RAWSPICE 482
#define READ 483
#define REDRAW 484
#define REGRESS 485
#define REGNUM 486
#define REGIONS 487
#define RENDER 488
#define REVERSE 489
#define RIGHT 490
#define RISER 491
#define ROT 492
#define RUNAVG 493
#define RUNMED 494
#define RUNSTD 495
#define RUNMIN 496
#define RUNMAX 497
#define SAMPLE 498
#define SAVEALL 499
#define SCALE 500
#define SCIENTIFIC 501
#define SET 502
#define SETNUM 503
#define SETS 504
#define SIGN 505
#define SIZE 506
#define SKIP 507
#define SLEEP 508
#define SLICE 509
#define SMITH 510
#define SORT 511
#define SOURCE 512
#define SPEC 513
#define SPECIFIED 514
#define SPECTRUM 515
#define STACK 516
#define STACKEDBAR 517
#define STACKEDHBAR 518
#define STACKEDLINE 519
#define STAGGER 520
#define START 521
#define STARTTYPE 522
#define STATUS 523
#define STOP 524
#define STRING 525
#define SUBTITLE 526
#define SWAPBUFFER 527
#define SYMBOL 528
#define TICKP 529
#define TICKLABEL 530
#define TICKMARKS 531
#define TIME 532
#define TITLE 533
#define TO 534
#define TOP 535
#define TRUEP 536
#define TYPE 537
#define UP 538
#define VELOCITY 539
#define VERTICAL 540
#define VGAP 541
#define VIEW 542
#define WITH 543
#define WORLD 544
#define WRITE 545
#define X 546
#define X0 547
#define X1 548
#define XAXES 549
#define XAXIS 550
#define XCOR 551
#define XMAX 552
#define XMIN 553
#define XY 554
#define XYARC 555
#define XYBOX 556
#define XYBOXPLOT 557
#define XYFIXED 558
#define XYHILO 559
#define XYRT 560
#define XYSEG 561
#define XYSTRING 562
#define XYDX 563
#define XYDY 564
#define XYDXDX 565
#define XYDYDY 566
#define XYDXDY 567
#define XYX2Y2 568
#define XYXX 569
#define XYYY 570
#define XYZ 571
#define XYZW 572
#define XYUV 573
#define TSV 574
#define Y 575
#define Y0 576
#define Y1 577
#define Y2 578
#define Y3 579
#define Y4 580
#define Y5 581
#define YAXES 582
#define YAXIS 583
#define YES 584
#define YMAX 585
#define YMIN 586
#define ZEROXAXIS 587
#define ZEROYAXIS 588
#define ABOVE 589
#define BELOW 590
#define POLYI 591
#define POLYO 592
#define GENERAL 593
#define DDMMYY 594
#define YYMMDD 595
#define MMDDYY 596
#define MMYY 597
#define MMDD 598
#define MONTHDAY 599
#define DAYMONTH 600
#define MONTHS 601
#define MONTHSY 602
#define MONTHL 603
#define DAYOFWEEKS 604
#define DAYOFWEEKL 605
#define DAYOFYEAR 606
#define HMS 607
#define MMDDHMS 608
#define MMDDYYHMS 609
#define YYMMDDHMS 610
#define DEGREESLON 611
#define DEGREESMMLON 612
#define DEGREESMMSSLON 613
#define MMSSLON 614
#define DEGREESLAT 615
#define DEGREESMMLAT 616
#define DEGREESMMSSLAT 617
#define MMSSLAT 618
#define DOT 619
#define STAR 620
#define PLUS 621
#define CROSS 622
#define CIRCLE 623
#define SQUARE 624
#define DIAMOND 625
#define TRIANGLE1 626
#define TRIANGLE2 627
#define TRIANGLE3 628
#define TRIANGLE4 629
#define SPLINE 630
#define LANDSCAPE 631
#define PORTRAIT 632
#define FREE 633
#define FIXED 634
#define STATUSBAR 635
#define LOCATORBAR 636
#define TOOLBAR 637
#define VAR 638
#define NUMBER 639
#define FITPARM 640
#define OR 641
#define AND 642
#define GT 643
#define LT 644
#define LE 645
#define GE 646
#define EQ 647
#define NE 648
#define UMINUS 649
#define NOT 650
#define ELLIPSE 651
#define ACOSH 652
#define ASINH 653
#define ATANH 654
#define COSH 655
#define SINH 656
#define TANH 657
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   36,   36,   36,   36,   36,   36,   36,
   17,   17,   17,   17,   17,   17,   17,   17,   18,   18,
   18,   18,   18,   18,   18,   18,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   22,   22,   22,   22,   22,   22,   22,   27,
   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
   27,   27,   27,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   31,   31,   31,   31,
   19,   19,   19,   19,   19,   19,   35,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
   37,   37,   37,   37,   37,   37,   34,   34,   34,   34,
   34,   34,   38,   38,   38,   38,   38,   38,   40,   40,
   40,   41,   41,   41,   41,   41,   41,   41,   39,   39,
   39,   39,   39,   42,   42,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   43,   43,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
   47,   47,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   45,   45,   45,   45,   21,   21,   21,
   21,   21,   21,   24,   24,   24,   24,   24,    7,    7,
    8,    8,   28,   28,   28,   28,   28,   29,   29,   29,
   29,   26,   26,   25,   25,   25,   15,   15,   15,   15,
   15,   14,   14,   14,   30,   30,    9,    9,   12,   12,
   12,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   13,   13,   13,   16,   16,   16,   16,   16,   16,   10,
   10,   33,   33,   32,   32,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    3,    3,    3,    3,    3,    5,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    4,    3,    2,    3,    1,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    3,    3,    3,    9,    5,    4,    1,    3,    2,    2,
    1,    3,    8,    1,    3,    2,    2,    2,    4,    4,
    6,    2,    2,    2,    7,    2,    2,    3,    3,    2,
    2,    2,    1,    2,    2,    2,    2,    2,    2,    2,
    4,    6,    3,    5,    3,    5,    3,    5,    5,    7,
    5,    7,    4,    4,    8,    4,    8,    2,    2,    3,
    3,    2,    2,    1,    4,    7,    6,    6,    6,   10,
   10,    6,    4,    1,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    3,    3,    4,
    3,    3,    4,    3,    3,    5,    2,    4,    4,    6,
    2,    1,    1,    1,    2,   17,    2,    2,    2,    3,
    2,    2,    8,    3,    3,    3,    3,    3,    4,    4,
    2,    2,    2,    3,    2,    2,    8,    3,    3,    3,
    3,    3,    4,    4,    2,    2,    3,    2,    2,    2,
    8,    3,    3,    3,    3,    3,    4,    4,    2,    2,
    2,    3,    2,    2,    4,    3,    3,    3,    3,    3,
    3,    4,    3,    3,    4,    5,    4,    4,    5,    3,
    3,    3,    4,    3,    4,    4,    8,    3,    3,    3,
    3,    5,    8,    3,    3,    3,    3,    2,    3,    3,
    3,    3,    2,    3,    3,    3,    3,    4,    2,    3,
    3,    3,    3,    3,    3,    4,    5,    5,    4,    4,
    4,    4,    3,    3,    4,    3,    3,    3,    3,    4,
    2,    3,    3,    3,    3,    3,    4,    2,    3,    4,
    4,    3,    3,    3,    4,    4,    3,    5,    6,    6,
    4,    4,    3,    3,    3,    3,    3,    3,    4,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    1,    1,    2,
    2,    2,    2,    2,    3,    3,    3,    3,    3,    3,
    3,    3,    2,    2,    3,    3,    2,    3,    3,    3,
    3,    3,    4,    4,    4,    2,    1,    2,    1,    2,
    3,    2,    1,    1,    1,    1,    1,    1,    2,    2,
    2,    1,    2,    2,    2,    2,    3,    2,    2,    2,
    2,    2,    1,    1,    2,    1,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    1,    2,    2,    3,
    3,    2,    2,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    2,    2,    2,    3,    1,    2,    1,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    3,    3,    3,    3,    2,    2,    3,    2,    2,
    2,    3,    1,    2,    2,    2,    2,    4,    2,    3,
    2,    2,    2,    1,    2,    2,    2,    3,    1,    1,
    2,    2,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    6,    6,    8,    5,   10,    5,
    3,    3,    3,    5,    5,    7,    5,    7,    3,    3,
    5,    7,    1,    1,    3,    5,    1,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    4,    4,    4,
    4,    4,    4,    4,    4,    6,    4,    4,    4,    1,
    4,    4,    4,    4,    6,    6,    6,    6,    1,    1,
    4,    4,    6,    6,    4,    4,    4,    4,    8,    6,
    6,    6,    4,    4,    1,    1,    1,    6,    6,    6,
    6,    4,    4,    4,    4,    4,    4,    5,    3,    3,
    3,    3,    3,    3,    3,    3,    2,    3,    2,    1,
    1,    4,    3,    4,    6,    8,    5,    7,    3,    5,
    3,    3,    3,    3,    3,    3,    4,    4,    4,    4,
    4,    4,    4,    6,    4,    4,    4,    1,    4,    4,
    4,    4,    6,    3,    3,    3,    3,    3,    3,    3,
    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    4,    4,    6,    4,    8,   14,    4,
    4,    4,    8,    6,    6,    6,    4,    4,    1,    1,
    1,    6,    4,    4,    4,    4,    4,    4,    5,    3,
    3,    3,    3,    3,    3,    3,    3,    2,    3,    2,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  720,
  721,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  712,  713,  714,  715,  716,  717,  718,  719,    0,
    0,    0,    0,  365,  366,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  134,    0,
    0,  488,    0,    0,    0,   44,  489,   94,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  490,  491,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  132,  133,    0,    0,   37,    0,
    0,  483,  485,  484,  487,  486,    0,    0,  470,    0,
    0,    0,    0,   41,    0,    0,   63,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  556,  558,    0,  363,
  557,  559,  560,  561,  562,  563,  564,    0,  364,  367,
  368,    0,    0,    0,    0,    0,  670,  671,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  359,   13,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   65,
  508,  507,   60,   66,    0,    0,    0,    0,  107,  105,
  106,    0,    0,    0,    0,    0,    0,  480,  479,  372,
  369,   62,    0,  301,  300,  302,  303,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,    0,    0,    0,
    0,    0,    0,    0,    0,  698,    0,    0,    0,    0,
    0,  722,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  739,  740,  741,    0,  723,
    0,    0,    0,    0,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  141,   39,  138,  168,  137,
  180,  152,    0,   52,    0,    0,    0,    0,    0,    0,
    0,    0,   17,    0,    0,    0,   40,  113,  112,  109,
  111,  110,  512,  513,  514,  515,  516,  518,  517,  519,
  520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  116,   61,    0,    0,    0,    0,    0,    0,  251,
   67,    0,    0,    0,    0,    0,    0,  471,    0,    0,
    0,  258,    0,  473,  472,    0,  362,    0,    0,    0,
   92,   93,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  229,
    0,    0,  179,    0,    0,    0,    0,    0,  169,   54,
   53,    0,    0,    0,  108,    0,    0,    0,  545,  548,
    0,    0,  547,  549,  546,  544,   57,   56,    0,   28,
   27,   26,   25,   24,   23,   21,   22,    0,    0,    0,
   68,    0,    0,  117,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   29,  131,    0,    0,    0,    0,
    0,    0,   64,    0,  492,  493,  114,    0,  135,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  183,
  223,    0,    0,    0,    0,    0,    0,  218,    0,    0,
    0,    0,  115,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   69,    0,   70,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  370,
  371,    0,   46,   48,   47,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  165,    0,    0,
    0,    0,    0,    0,  155,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    5,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    6,    0,    2,    3,    4,    0,    0,    8,
  477,    0,    0,    0,  476,    0,  329,  474,  475,    0,
    0,  478,    0,    0,    0,    0,  328,    0,  327,   10,
    7,    0,    0,    9,   11,   12,    0,    0,    0,    0,
  383,  358,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   75,    0,   38,    0,  373,
  376,  378,  375,  374,   42,  121,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  147,    0,  496,    0,
  148,    0,  145,  146,  551,  550,  144,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  202,    0,  204,  200,  201,    0,    0,    0,    0,  255,
  256,  253,  254,  252,    0,    0,  262,    0,    0,    0,
    0,    0,  267,  263,  259,    0,  308,  314,  309,  315,
  305,  306,  307,  312,  316,  310,  311,  304,  313,  264,
  704,  705,  706,  707,  708,  709,  710,  711,    0,    0,
  361,   18,    0,    0,   90,   91,    0,    0,    0,    0,
  235,    0,  249,  246,  233,  231,  234,  247,  248,  230,
    0,  232,    0,    0,    0,    0,    0,  176,  175,  174,
  173,  172,    0,   59,    0,    0,    0,    0,    0,   58,
  318,  319,  317,  320,   45,    0,    0,   14,   20,  118,
  119,    0,  124,  122,    0,    0,   31,    0,   32,   33,
  323,  324,  321,  322,  325,  326,   30,    0,    0,    0,
   77,   73,    0,    0,    0,  573,  679,    0,    0,  554,
  555,    0,    0,    0,  188,  193,  190,  191,  187,  186,
  189,    0,  226,  224,  227,  225,    0,    0,    0,    0,
    0,    0,  194,  221,  219,  222,  220,    0,  277,  274,
  276,  275,  278,  273,  215,  214,  217,  216,    0,  140,
  167,  182,  154,    0,    0,    0,    0,    0,  125,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  161,
    0,    0,  162,  159,  160,  158,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  759,
  668,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  356,    0,    0,    0,    0,    0,
  481,  482,    0,  344,    0,  333,    0,  332,  347,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  330,    0,
  343,    0,    0,    0,    0,    0,  464,  382,    0,  453,
    0,    0,    0,    0,    0,    0,  381,    0,    0,    0,
    0,  511,    0,    0,  509,    0,    0,    0,    0,    0,
    0,  510,    0,    0,    0,    0,  386,  397,    0,  384,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  419,    0,  417,    0,  609,  688,  610,  690,
  612,  692,  614,    0,    0,  695,  617,  696,  618,  699,
  621,  700,  622,  701,  623,  702,  624,    0,    0,  103,
  724,  631,  725,  632,    0,    0,    0,    0,    0,  730,
  636,  731,  637,  732,  638,    0,    0,    0,    0,    0,
    0,    0,    0,  737,  643,  738,  644,    0,    0,  743,
  652,  745,  654,  746,  655,  747,  656,    0,   95,  377,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  149,  150,    0,  673,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   84,  203,  205,  206,    0,    0,  257,  272,  260,
  261,  265,    0,    0,  271,    0,  266,    0,    0,    0,
    0,    0,    0,  228,    0,    0,  239,    0,  236,    0,
  240,  241,  245,  250,    0,  177,  178,    0,   36,    0,
    0,   86,    0,    0,   15,  120,  123,    0,    0,    0,
    0,    0,   71,    0,    0,    0,    0,    0,    0,  552,
  553,   83,    0,  192,    0,    0,    0,  197,  195,  198,
    0,  279,    0,    0,    0,  128,    0,    0,    0,    0,
    0,  163,  164,    0,  689,  611,  691,  613,  693,  615,
  697,  619,  744,  653,  748,  657,    0,    0,    0,  348,
  351,  350,    0,    0,  352,  501,  498,  499,  500,  497,
  349,  345,  346,  336,  338,    0,  335,  342,  341,    0,
  339,    0,    0,    0,  465,  466,  467,    0,  462,  461,
  504,  503,  502,  459,  455,  454,  463,  456,  457,    0,
  398,    0,    0,  393,  402,  396,  403,    0,    0,    0,
    0,    0,    0,  387,    0,    0,    0,    0,    0,    0,
  388,    0,    0,  412,  399,  415,  413,  414,    0,  385,
  434,  425,    0,  450,  449,  424,  423,  447,  435,  427,
  429,  428,  451,  431,  432,  430,  433,  438,  422,  426,
  542,  543,  541,  439,  436,  437,    0,    0,    0,    0,
  420,  421,  446,    0,  418,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   76,  687,    0,
    0,  727,    0,    0,    0,  672,    0,  674,    0,    0,
    0,  268,    0,    0,    0,   78,   74,    0,    0,    0,
  574,    0,    0,  126,  237,  238,    0,    0,    0,    0,
    0,    0,    0,    0,   81,    0,  575,    0,    0,    0,
  506,  505,  680,  677,    0,    0,    0,  196,  199,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  354,  353,    0,    0,    0,  460,    0,  404,  410,  408,
  406,  400,  405,  411,  409,  407,  401,    0,  448,  443,
  442,  445,  444,  452,  694,  616,    0,  626,  627,  625,
    0,  634,    0,    0,    0,    0,  734,  640,  735,  641,
  736,  642,    0,  649,  650,  648,    0,    0,    0,    0,
    0,    0,    0,    0,  102,  269,    0,    0,   72,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   97,    0,
    0,    0,   51,    0,    0,  130,    0,    0,    0,    0,
    0,    0,   98,   99,  458,    0,    0,    0,    0,  703,
  726,  742,    0,  675,    0,    0,    0,   82,    0,  576,
    0,    0,  678,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   55,    0,    0,  728,    0,  733,  639,
    0,    0,   43,   85,    0,    0,    0,   87,    0,    0,
    0,    0,    0,    0,    0,    0,  676,    0,    0,    0,
    0,    0,    0,    0,  101,    0,  100,    0,    0,    0,
    0,    0,    0,  729,    0,    0,    0,    0,
};
short yydgoto[] = {                                     169,
 1022,  679,  172,  173,  174,  325,  240, 1055,  223,  767,
  382, 1108, 1444, 1384, 1361,  458,  469,  176,  907,  830,
  177,  178,  179,  638,  761,  497,  268,  180,  181, 1524,
  885,  922, 1312,  182,  183,  184,  639,  185,  652,  186,
  241, 1109, 1134, 1087, 1078, 1110, 1135,
};
short yysindex[] = {                                   5633,
   11,    8,   50,  119,  270,  275,  278,  280,    0,    0,
    0,  312,  340,  345,  349,  350,    0,  360,  366,  369,
  376,  382,  392,  401,  410,  413,  417,  423,  436,  443,
  446,  457,    0,    0,    0,  458,    0,  477,  495,  497,
  516,    0,    0,    0,    0,    0,    0,    0,    0, -270,
 -360, -360, -373,    0,    0, -194,   70, -498,  934, -360,
  200, 1876, 6685,  215, -284,  -77,  -75, -202,    0,  514,
  -74,    0,  527, 9108,  228,    0,    0,    0,  661, 8741,
 -360,  578,  230, 1881,  255,  219,  536,   47,    0,    0,
 -365, 6035, 7010,  -56,  -36, -424,  -33, -137, -157, 9108,
 -232,   74,  903,  181,    0,    0,  271,12804,    0,  577,
 1127,    0,    0,    0,    0,    0,  279,   21,    0,  -17,
  121, -294, -471,    0, 6360, -324,    0, 9108,  100,  -48,
 1876,  525, 8482,  -82, 8566, -177,    0,    0,  934,    0,
    0,    0,    0,    0,    0,    0,    0,  934,    0,    0,
    0,  586, -137, -137, -137,  184,    0,    0, 9163, 9163,
 7335,  588,  590,  592,  596,  615,  616, 9163,    0,   78,
 2914,  647,  648,  651,  238,  652,13032,  657,  660,  644,
  646,  677,  678,  680,    4,    0,    0, 9163, 9163, 9163,
 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9567,
 9163, 9163,   52,   53,   54, 9163, 9163, 9163, 9163, 9163,
 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9163,    0,
    0,    0,    0,    0,  649,   65,  650, -137,    0,    0,
    0,  221,  104,  123, -137,  133,  134,    0,    0,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  416,  673,  721,
  748,  749,  751,  752,  754,    0,  756,  758,  761,  762,
  763,    0,  767,  768,  775,  779,  782,  789,  791,  793,
  794,  805,  815,  818,  819,    0,    0,    0,  820,    0,
  821,  824,  827,  828,  170,    0,  -41,  777,  232,  233,
 -240,  829,  838,  795, 9108, 9108,  842,  845,  847,  848,
  855,  856, 9108, 1094,  809,    0,    0,    0,    0,    0,
    0,    0,  854,    0,  857,  377,  398,  273, -475,  297,
  298,  437,    0,  441,  777, 1462,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  598,  301, -137,  308,  310,  315,    0,
    0,  454, -363,  451,  405, -360, -137,    0,  459, 3100,
 -148,    0,  460,    0,    0,    4,    0,  324,  463,  351,
    0,    0,  469,  480,  641,  485,  353,  365,  367,  378,
  380,  381,  394, -240,  406,  408, 9108, 9108, 3528,    0,
 -494,  414,    0,  777,  425,  426, -240, 3657,    0,    0,
    0, -137,  487,  430,    0,  947,  498, 3908,    0,    0,
  431,  -92,    0,    0,    0,    0,    0,    0, 9108,    0,
    0,    0,    0,    0,    0,    0,    0,  998,  687,  432,
    0,  700, -174,    0,  705,  -51,  549,  433, 9108,  435,
  444, -165, 9108, 1063,    0,    0,  445,  447, -118, 9108,
  -95, 1012,    0, -181,    0,    0,    0, 9108,    0,  567,
  448,  711,  449,  777,  455,  456, -240,  464, 4227,    0,
    0,  466,  467,  468,  471, 4861, -200,    0,  472,  474,
  475,  479,    0,  548,  482, -137,  489,  493, -240,  494,
  496,  501,  503,  505, 5549,  507,    0,  509,    0,  519,
  523, 9108, 9108, 9108, 9108, 5581,  764, -372, 9108,    0,
    0,  593,    0,    0,    0, 9163, 9108, 1053, 1056, 1070,
  795, 1057, 1061,  809, 1057, 1061,  531,    0,   29,  777,
  537,  541, -240, 5701,    0, 9163, 9163, 9163, 9163, 9163,
 9163,  769, 3430, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
 9108, 9163, 9163, 9163, 9163, 9108, 9163,    0, 9108, 9163,
 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9163, 9163,
 9163, 9163,    0, 9163,    0,    0,    0, 9163, 9108,    0,
    0,  803,   69, -318,    0, 8741,    0,    0,    0, 9108,
  545,    0,  546, 7660, 1876, 9108,    0,  547,    0,    0,
    0,  623,  672,    0,    0,    0,  370,  879,12793,12884,
    0,    0, 5716, 5075, 5749, 7627, 5793, 8591, 6052,11506,
 6110, 8904, 6197,11561, 6361,11809, 6422,11904, 6435,11912,
 6447,11921, 6459,11936, 6481,12006,  138, 6505,11960, 6514,
11984, 6702,12476, 1078, 1120, 1147, 6725,12051, 6760,12061,
 6773,12128, 6784,12529, 6827,12546, 6838,12570, 7130,12592,
 7072,12169, 7149,12178, 7158,12616, 7397,12186, 7644,12195,
 7661,12203, 7685,12212,  689,    0,  554,    0,  555,    0,
    0,    0,    0,    0,    0,    0, 9108, 9108, 9108, 9108,
 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
 9108,  556, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
 9108, 9108, 9108, 9108, 9108, 9108,    0,  557,    0,  559,
    0,   58,    0,    0,    0,    0,    0, 1063,  481, 9108,
 1057, 1057, 9108, 9108, 9108, 9108, 9108, 9108, 7704, 9108,
 9108, 9108, 9108, 9108, 9108, 9108,  561,  694,  699,  569,
    0,  572,    0,    0,    0,  573, 1169, 9108,  576,    0,
    0,    0,    0,    0,  582, -279,    0,  587, 8741,  600,
  607, 9108,    0,    0,    0,  609,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   26,  612,
    0,    0, 1173, 1187,    0,    0,  614, -211,  618,  622,
    0,  626,    0,    0,    0,    0,    0,    0,    0,    0,
  923,    0,11824,11824, 9108,  629,  630,    0,    0,    0,
    0,    0, 9108,    0,  880, 1229,  771,  778, 9108,    0,
    0,    0,    0,    0,    0, 7972,  936,    0,    0,    0,
    0,  939,    0,    0,  942, 1234,    0, 7983,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 8297, 1226, 1245,
    0,    0,  946, 8431, 1246,    0,    0, 1237,  277,    0,
    0, -305, 8454,  670,    0,    0,    0,    0,    0,    0,
    0, 9108,    0,    0,    0,    0, 9108,  806,  674,  685,
  692, 1272,    0,    0,    0,    0,    0,  696,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 9108,    0,
    0,    0,    0,11824,11824,11824,11824, 9108,    0,  982,
  993, 8518, 1294,11836, 4343, 8158, 9163,  166,  481,    0,
  703,  704,    0,    0,    0,    0, 9108, 8529,12236, 8546,
12245, 8604,12253, 8890,12262, 8932,12270, 8945,12279,    0,
    0, 1440, 1080, 1399, 1399, 1399, 1399, 1399, 1399, 1177,
  453, 1177,  453,  180,  249,  180,  249,  259,  180,  249,
 5226,11836,  339, 1835,  836,  836,  836,  836,  836,  836,
 1177,  453, 1177,  453,   41,  249,   41,  249,   41,  249,
 1916,11836, 4343, 9086,    0,  707,  715,  718,   34, -309,
    0,    0, -120,    0,  723,    0,11824,    0,    0, -360,
  724, 9108,  725,  726,  728, 9108,  729,11824,    0, 8977,
    0, 1316, 1325,  731,  736,  737,    0,    0,  871,    0,
  741,  745, -214, -367,  755, -289,    0, -137, 9108, 9108,
 -137,    0,  757,  766,    0,  770, 7832, 8157, 9108, 9108,
 -309,    0,  784,  799, -277, 1353,    0,    0,12793,    0,
  804, 1059,  894,  808,  817,12124,  822, -214, -221,  831,
 -196, -309,  834, 1062, -299,  839,  840, 8621, 9025, -267,
  850, 1357,    0,12884,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 9108, 9163,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 9163, 9163,    0,
    0,    0,    0,    0,  851,  852,    0,  858,  859,    0,
    0,    0,    0,    0,    0, 9108, 9108, 9108, 9163, 9108,
 9163, 9108, 9163,    0,    0,    0,    0, 9163, 9163,    0,
    0,    0,    0,    0,    0,    0,    0,  861,    0,    0,
 9432, 9445, 9460, 9522, 9596, 9605, 9655, 9674, 9729, 9836,
 9845, 9858, 9869, 9881, 9898, 1366, 9913, 9925, 9936, 9953,
 9966, 9978, 9989,10001,10078,10087,10114,10137,10151,10217,
    0,    0, 1362,    0,   33,10230,10241,10289,10300,10317,
10344,10355, 1486, 1486,  259,  259,  259,10372,10613, 1374,
  887,    0,    0,    0,    0,  872,11824,    0,    0,    0,
    0,    0, 8741, 1378,    0,10400,    0,  873,  874, -118,
 9108,  -85, 1063,    0, 9108,  875,    0, -120,    0,  876,
    0,    0,    0,    0,11824,    0,    0,10413,    0, 9108,
  911,    0,11824, 9108,    0,    0,    0,  878, 9108, 9108,
 9108,  881,    0, 9108,  954, 9108, 9163, -215, 9108,    0,
    0,    0, 9108,    0,11824,10622,  882,    0,    0,    0,
  883,    0,10645,10654, 1075,    0, 9108, 9108, 1407, 1478,
   33,    0,    0,10707,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 9108, 9163, 1465,    0,
    0,    0,  888,  890,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,11824,    0,    0,    0,11824,
    0, 9108,  891,  896,    0,    0,    0,  900,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1502,
    0,11824,11824,    0,    0,    0,    0,  905, -137,  909,
  914,  918,11824,    0,  921, -137,  922,  925,  926,11824,
    0,11824,11824,    0,    0,    0,    0,    0, 9108,    0,
    0,    0,  927,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -266,11824, -263,11824,
    0,    0,    0, 1206,    0,10726,12303,10763,12312,10772,
12320, 1521, 1526, 1524, 1525,10785,10807,10855,12329,10930,
12337,10986,12366,11025,12444,11034,12467,    0,    0, 9108,
  931,    0, 9108, 1063, 9108,    0, 9108,    0,  932, 1182,
 1532,    0,  935, 9108, 1535,    0,    0, 1238,11047, 1537,
    0,  568,11058,    0,    0,    0, 9108,11069, 1194,11824,
 1540,11080,11824,11824,    0,11824,    0,11824,11836, 4343,
    0,    0,    0,    0,11092,11103,  956,    0,    0, 9108,
 9108, 1241,11114,11125, 9108, 1063, 9108,11824, 4343, 9108,
    0,    0,11824, 1545, 1555,    0,  958,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,11824,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  959,  960, 9108, 9108,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,11153, 1559,11168,  207,
11136,11180, 1558, 1566,    0,    0,11824,  965,    0, 9108,
 1111, 9163, -203, 9108, 9108,11266, 9108, 1569,    0, 9108,
 1556, 9108,    0,11281,11293,    0, 1274, 9108,11824,  207,
11349,11824,    0,    0,    0, 1575, 1577,11397,11420,    0,
    0,    0, 9108,    0, 9108,  983, 1121,    0,11824,    0,
11836, 4343,    0,11429,11442, 9108,11824, 1122,11474, 9108,
11487, 9108, 9108,    0,11496, 9108,    0,  984,    0,    0,
11519,11824,    0,    0, 1565,  989,11824,    0, 9108,11824,
 9108,11824,11824,  992,11824, 1588,    0, 9108, 1592,11824,
11551, 1594, 1006,11824,    0, 9108,    0, 1593,11542, 1007,
 9108, 1607,11792,    0, 9108,11801, 9108,11824,
};
short yyrindex[] = {                                   1649,
    0,    0,    0,    0,    0,    0,    0,    0,   -3,    0,
    0,    0,    0,    0,    0,    0,   55,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  329,  354,  393,    0,  783,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1640,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1642,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,13039,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 3175,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3256,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1645,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1646,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1648,    0,    0,    0,    0,
    0,    0, 1650, 1652,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1576,    0,    0,
    0,    0,    0, 1656,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1658,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1659,    0, 1661,    0, 1665,
 1666,    0,    0,    0,    0,    0,    0, 1667,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   64, 1191, 2741, 1308, 1986, 2804,    0,    0,    0, 1668,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1670,    0, 1673,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1346, 1664,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,13092,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1674, 1675,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1676,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  368,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 3273,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1678, 1680, 1681, 1683,    0,    0,    0,
    0,    0,    0, 1685, 1687,    0,    0,    0,    0,    0,
 1670, 1673,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 4661, 3673, 3712, 3925, 4074, 4287, 4326, 4500,  122,
  434,  508, 1289, 1422, 2478, 2629, 2942, 1813, 2843, 3002,
    0,  558,    5,   -8,   12,   73,   75,  194,  287,  293,
 1735, 2752, 2820, 2953, 3024, 3043, 3146, 3154, 3184, 3205,
    0, 1689, 1692,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1693,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1694,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1700,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1702,    0,  807,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1124,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2645, 2897, 2080, 2229, 2496,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1703,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1704,    0,    0,    0,    0,    0,
    0,    0, 1705,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1706,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1708,    0,    0,    0, 1500,    0,
 2328,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2857,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1709,    0,    0,    0, 1710,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 4983, 5022,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 5094,    0,    0,    0,    0,    0,    0, 5133,
    0, 5202, 5241,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3460,    0, 4804,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3296,    0,    0,    0,    0,    0,    0,    0, 1711,
    0,    0, 1720, 1722,    0, 1723,    0, 1724, 1734, 1736,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4843,  563,    0,
    0,    0, 1737,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 5349,    0,    0,
    0,    0,    0,    0,    0,    0, 1162,    0,    0,    0,
 1200,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1278,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1738,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2872,    0,    0,    0,    0,    0,    0,    0, 1739, 2731,
    0, 1740,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1741,    0,
 1742, 1744,    0,    0,    0,    0, 1745,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1746,    0,    0, 3065,    0, 1749,    0,    0, 1751,
    0, 1752, 1754,    0, 1764,    0,    0,    0,    0, 1765,
    0,    0,    0, 1772,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1773,
};
short yygindex[] = {                                      0,
    1,  313,    0,    0,    0,   71,  869, -832,  -52, -180,
 -603,    0,    0,  667, -747,    0, 1318,    0,    0,    0,
    0,    0,    0,    0, 1218, -470,  -99,    0,    0,  185,
    0,    0,    0,    0,    0,    0,    0, 1707, 1383, 1714,
  -62,    0,    0,    0,    0,  681,  668,
};
#define YYTABLESIZE 13663
short yytable[] = {                                     224,
  170,  665,  892,  970,  229,  895,  620,  242,  476, 1441,
  221,  866,  971,  221,  666, 1280,  225, 1310,  913,  511,
  187,  659, 1056,  512,  411,  412, 1356, 1357,  383, 1051,
  442,  523,  665,  698, 1388,  665,  792,  620,  620,  620,
  620,  620,  867,  620, 1260,  666, 1417,  188,  666,  665,
  230, 1311,  659,  328,  620,  659, 1451, 1560,  513,  620,
 1562,  443,  666,  324,  629,  495,  492, 1521, 1522,  659,
  175, 1273,  498,  583,  346,  449,  550,  596, 1308, 1521,
 1522,  491,  660,  231,  661,  551, 1272,  598, 1385,  189,
  620,  722,  429,  438, 1386,  629,  629,  629,  629,  629,
  448,  629,  514,  599,  583,  583,  583,  583,  583, 1358,
  583, 1523,  629,  660,  596,  661,  660,  629,  661,  594,
  592,  583,  593, 1485,  595,  509,  583, 1381,  516,  226,
  660,  587,  661,  535,  597,  546, 1051,  413,  414,  329,
  599, 1052,  938, 1442,  868, 1434, 1443,  939,  629,  831,
  832,  833,  834,  835,  836,  837,  838,  583,  190,  562,
  565,  574,  587,  793,  588,  587,  588,  499,  582,  891,
  496,  597,  222,  806,  450,  222,  451, 1430, 1160,  587,
 1359,  515,  940,  979,  452,  495,  453,  335,  653,  655,
  657,  659,  661,  663,  665,  667,  669,  671,  673,  675,
  678,  680,  682,  662, 1382, 1263,  687,  689,  691,  693,
  695,  697,  699,  701,  703,  705,  707,  709,  711,  713,
 1362,  454, 1435, 1389, 1053, 1360,  941, 1051,  547,  564,
  564,  330,  446, 1261,  662, 1418,  238,  662,  564,  239,
  331,  495,  599,  860,  556, 1452, 1561,  238, 1052, 1563,
  239,  662, 1603,  901, 1436,  536,  872,  455,  564,  564,
  564,  564,  564,  564,  564,  564,  564,  564,  564,  564,
  564,  564,  564,  597,  557, 1383,  564,  564,  564,  564,
  564,  564,  564,  564,  564,  564,  564,  564,  564,  564,
  496, 1431,  894, 1437,  915,  518,  663, 1633,  618,  519,
  336,  765,  664,  766, 1500,  456,  758,  537,  495,  191,
  238,  614,  171,  239,  192,  771,  772,  193, 1432,  194,
 1054,  599, 1308,  779,  902,  548,  930,  663,  619,  238,
  663, 1278,  239,  664,  520,  647,  664, 1307,  645, 1052,
  807,  538,  612,  814,  663,  447,  496,  549,  953, 1390,
  664,  195,  784, 1414,  839,  831,  832,  833,  834,  835,
  836,  837,  838,  646,  920,  739,  332, 1309,  220,  645,
  645,  645,  645,  645, 1438,  645,  981,  673,  521,  196,
  610,  608,  487,  609,  197,  611,  645, 1268,  198,  199,
  740,  645,  986,  921,  646,  646,  646,  646,  646,  200,
  646,  614,  647,  759,  673,  201,  457,  916,  202,  673,
  673,  646,  673,  496,  673,  203,  646, 1501,  760,  648,
  539,  204,  645,  903,  904,  905,  906,  863,  864,  741,
  673,  205,  612,  647,  647,  647,  647,  647,  942,  647,
  206,  488,  540,  590,  227, 1505, 1269,  646,  489,  207,
  647,  238,  208, 1270,  239,  647,  209,  522, 1353,  886,
 1354,  673,  210,  831,  832,  833,  834,  835,  836,  837,
  838,  563,  566,  759,  590,  211,  590,  590,  590,  898,
  583,  238,  212,  908,  239,  213,  647,  490,  982, 1046,
  914,  590, 1271, 1047,  610, 1048,  214,  215,  923,  611,
  654,  656,  658,  660,  662,  664,  666,  668,  670,  672,
  674,  676, 1427,  681,  683,  614,  216,  587,  688,  690,
  692,  694,  696,  698,  700,  702,  704,  706,  708,  710,
  712,  714,  649,  650,  217, 1069,  218,  403,  881,  882,
  883,  884,  964,  965,  966,  967,  612,  243,  587,  972,
  592,  587,  592,  228,  909,  219,  974,  976,  327, 1049,
 1233,  333,  919,  334,  343,  587,  344,  587,  541,   54,
   55,  347,  658,  391,  408,  409,  988,  990,  992,  994,
  996,  998,  440,   59, 1002, 1003, 1004, 1005, 1006, 1007,
 1008, 1009, 1010, 1012, 1014, 1016, 1018, 1019,  587, 1021,
  410,  587,  441,  658,  444, 1050,  658,  470, 1031, 1033,
 1035, 1037, 1039, 1603,  471,  587,  477,  459, 1042, 1044,
  658,  493,  486,  494,  517,  552,  564,  576, 1602,  577,
 1057,  578,  665,  665, 1068,  579, 1070,  620,  620,  620,
  620,  620,  620,  620,  620,  666,  564,  564,  564,  564,
  564,  564,  659,  659,  580,  581,  615,  616, 1604, 1492,
  617,  620,  564,  564,  564,  564,  640,  564, 1330,  641,
  564,  564,  564,  564,  564,  564,  564,  564,  564,  564,
  564,  564,  564,  642,  564,  643,  644,  645,  564,  646,
  684,  685,  686,  717,  715,  629,  629,  629,  629,  629,
  629,  629,  629,  716,  583,  583,  583,  583,  583,  583,
  583,  583,  727,  660,  660,  661,  661, 1074,  584,  585,
  586,  587,  588,  589,  590,  591,  719, 1201, 1202, 1203,
 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213,
 1214, 1215,  720, 1217, 1218, 1219, 1220, 1221, 1222, 1223,
 1224, 1225, 1226, 1227, 1228, 1229, 1230,  404,  405,  726,
  728,  721,  588,  588,  588,  588,  588,  588,  588,  588,
 1236,  723,  724, 1237, 1238, 1239, 1240, 1241, 1242,  725,
 1243, 1244, 1245, 1246, 1247, 1248, 1249,  729,  730,  809,
  731,  732,  630,  733, 1075,  734, 1076,  735, 1257, 1498,
  736,  737,  738,  139,  140,  596,  739,  740,  757, 1000,
  594,  592, 1266,  593,  741,  595,  608,  238,  742,  723,
  239,  743,  762,  630,  630,  630,  630,  630,  744,  630,
  745,  599,  746,  747,  662,  662,  148,  149, 1234, 1235,
  630,  150,  151,  687,  748,  630,  524,  608,  608,  608,
  608,  608,  238,  608,  749,  239,  337,  750,  751,  752,
  753,  338,  597,  754,  608, 1285,  755,  756,  975,  608,
  763,  764,  525, 1288,  768,  810,  630,  610,  608, 1293,
  609,  773,  611,  769,  774,  770,  775,  776,  989,  991,
  993,  995,  997,  999,  777,  778,  339,  787,  614,  786,
  608,  917,  788,  790, 1011, 1013, 1015, 1017,  384, 1020,
  789,  791, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030,
 1032, 1034, 1036, 1038, 1040,  385, 1041,  663,  663,  612,
 1043,  326, 1315,  664,  664,  794,  795, 1316,  340,  800,
  341,  811,  796,  797,  526,  799,  802,  352,  803,  527,
  390,  528,  402,  804,  386,  529,  808,  805,  812, 1323,
  430,  439,  842,  840,  816,  843,  445,  845, 1324,  645,
  645,  645,  645,  645,  645,  645,  645,  678,  846,  485,
  601,  602,  603,  604,  605,  606,  607, 1334,  847,  844,
  852,  853,  877,  510,  646,  646,  646,  646,  646,  646,
  646,  646,  387,  854,  388,  855,  348, 1364,  673,  673,
  673,  673,  673,  673,  673,  673,  856,  848,  857,  858,
  875,  553,  554,  555,  530,  238,  137,  138,  239,  575,
  888,  878,  859,  647,  647,  647,  647,  647,  647,  647,
  647,  342,  349,  890,  861,  637,  862,  564,  893, 1331,
  350,  896,  869,  651,  926,  141,  142,  143,  144,  145,
  146,  147, 1366,  870,  871,  849, 1370,  850,  876,  880,
  889,  897,  924,  899,  590,  590,  590,  590,  590,  590,
  590,  590,  900,  910,  948,  911,  925,  927,  238, 1392,
 1393,  239,  977,  928,  929,  973,  718, 1403, 1410, 1412,
 1413,  978,  931,  722,  933,  934,  935,  969,  238,  936,
  944,  239,  945,  946,  389,  979,  596,  947, 1167,  599,
  949,  782,  780,  614,  781, 1072,  783,  951, 1448, 1450,
  596,  952,  954,  635,  955,  782,  780,  785,  781,  956,
  783,  957,  599,  958, 1456,  960, 1045,  961,  592,  592,
  592,  592,  592,  592,  592,  592,  599,  962, 1458, 1460,
  727,  963,  351, 1168,  635,  635,  635,  635,  635,  980,
  635,  628,  484,  784, 1073,  984, 1466, 1467, 1468,  985,
 1470,  635, 1472, 1058, 1059, 1071,  635,  784, 1474, 1476,
 1169, 1198, 1199, 1200, 1216, 1231, 1251, 1232,  703, 1250,
  587, 1252,  628,  628,  628,  628,  628, 1253,  628,  633,
 1254, 1255, 1256,  596, 1258,  564, 1275,  635,  594,  628,
 1259, 1079, 1080,  595,  628, 1262, 1081,  760,  564,  564,
 1276,  587,  760,  760,  587,  760,  726,  760, 1264,  599,
  633,  633,  633,  633,  633, 1265,  633, 1267,  587,  564,
 1274,  564, 1277,  564,  801,  628, 1281,  633,  564,  564,
 1282, 1082,  633,  813, 1283,  815, 1284, 1286, 1287, 1289,
  597, 1499, 1290, 1291,  651, 1503,  232, 1298,  460, 1295,
 1292,  233, 1296,  851,  760, 1297, 1301,  651, 1302, 1303,
 1508, 1305, 1083,  633, 1510, 1084,  461, 1306,  594, 1512,
 1513, 1514,  462,  463, 1516, 1085, 1518, 1519, 1314, 1525,
  874, 1317, 1318, 1526,  742, 1321,  234,  584,  651,  651,
  651,  651,  651, 1319,  651, 1325,  235, 1533, 1534,  594,
 1320,  594,  594,  594, 1322,  651, 1326, 1328,  464,  465,
  651, 1332, 1333, 1502, 1086, 1350,  594, 1538,  584,  584,
  584,  584,  584, 1351,  584,  760, 1352,  912,  236, 1373,
  237, 1363, 1365, 1367, 1368,  584, 1369, 1371, 1374, 1375,
  584,  651, 1543,  460, 1376, 1377, 1378,  564,  466, 1379,
  467,  238,  760, 1380,  239,  943,  760,  760,  760,  760,
  760,  461,  760, 1387,  950, 1395, 1419,  462,  463, 1423,
 1454,  584, 1422,  760, 1396, 1440, 1482, 1484, 1397,  584,
  585,  586,  587,  588,  589,  590,  591, 1489,  564, 1558,
 1490, 1493, 1415,  630,  630,  630,  630,  630,  630,  630,
  630,  587,  917,  464,  465,  596,  468, 1416,  760,  760,
  782,  780, 1421,  781, 1509,  783, 1424,  608,  608,  608,
  608,  608,  608,  608,  608, 1425, 1517, 1457,  683, 1532,
 1428,  599,  587,  596,  596,  587,  596, 1535,  596, 1433,
 1459, 1461, 1439,  466,  478,  467,  596, 1445, 1446,  587,
 1587,  782,  780, 1589,  781, 1591,  783, 1592, 1453, 1462,
 1463, 1469,  784, 1471, 1597, 1473, 1464, 1465,  596, 1478,
 1475, 1477,  599,  782,  780,  798,  781, 1606,  783,  672,
 1491, 1495, 1496, 1504, 1506, 1077, 1511, 1107, 1133, 1515,
 1528, 1529,  596, 1536,  599, 1540, 1541,  782, 1542, 1544,
 1614, 1615,  783,  784, 1545, 1619,  672, 1621, 1546,  918,
 1622,  672,  672, 1548,  672, 1547,  672, 1550,  599, 1564,
  479,  480, 1551,  481, 1590,  784, 1552,  137,  138, 1553,
 1555, 1571,  672, 1556, 1557, 1559, 1572, 1573, 1574, 1588,
 1593, 1594, 1595, 1596,  238, 1628, 1629,  239, 1598,  784,
 1609, 1599, 1601, 1608, 1616, 1623,  141,  142,  143,  144,
  145,  146,  147,  672, 1613, 1624, 1625, 1626, 1627, 1631,
 1639, 1636, 1641, 1638, 1644, 1645, 1620, 1647,  137,  138,
 1649, 1637, 1651, 1640, 1648, 1657, 1650, 1654, 1655, 1520,
 1658, 1663, 1676, 1664, 1668, 1678,  760, 1679,  760,  760,
 1682, 1683, 1685, 1661, 1687, 1662, 1690,  141,  142,  143,
  144,  145,  146,  147, 1688, 1692, 1667, 1694,    1,  104,
 1670,   19, 1672, 1673,  357,  142, 1675,  360,  760,   88,
 1539,   89,  760,  482,  760,  170,  560,  184,  139, 1680,
  166, 1681,  564,  758,  181,  153,  127,  156, 1684,  495,
  483,  760,  494,  243,  244,   16, 1689,  209,  760,  208,
  211, 1693,  210,  760,  579, 1696,  571, 1698,  580,  760,
  758,  572,  331,  334,  758,  758,  758,  758,  758,  379,
  758,  380,   49,  242,   50,  185, 1279,  129,  340,  337,
  212,  758,  586,  587,  588,  589,  590,  591,  760,   35,
  760,  570,   79,  568,  584,  585,  586,  587,  588,  589,
  590,  591,  760,  581,  587,  577,  355,  270,  565,  566,
   80,  582,  760,  578,   96,  143,  758,  758,  171,  760,
  567,  213,  760,  207,  635,  635,  635,  635,  635,  635,
  635,  635,  760,  157,   34,  587,  760,  591,  587,  591,
  760,  569,  136,  760, 1429,  887,  983, 1643,  841, 1420,
    0,  406,  587,  760,  760,  760,  760,  760,  407,  760,
    0, 1455,  628,  628,  628,  628,  628,  628,  628,  628,
    0,    0,    0,    0,    0,    0,  760,  760,    0,    0,
    0,    0,  685,    0,    0,    0,    0,    0,    0,    0,
    0,  760,  760,  760,  760,  760,  760,  760,  760,    0,
  633,  633,  633,  633,  633,  633,  633,  633,    0,  685,
  760,  760,  760,  685,  685,  685,  685,  685,  760,  685,
    0,    0,    0,    0,    0,  760,  760,    0,    0,  760,
  685,    0,    0,    0,  760,    0,  610,  608,    0,  609,
    0,  611,  760,    0,    0,    0,  760,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  614,    0,    0,
    0,    0,    0,    0,    0,  685,    0,    0,    0,    0,
    0,    0,    0,    0, 1642,    0,    0, 1355,  651,  651,
  651,  651,  651,  651,  651,  651,  401,    0,  612,  594,
  594,  594,  594,  594,  594,  594,  594,    0,    0,    0,
    0,    0,    0,    0,  758,    0,  758,  758,  584,  584,
  584,  584,  584,  584,  584,  584, 1391,  610,  608, 1394,
  609,    0,  611,    0,    0, 1404, 1411,    0,    0,    0,
    0,    0,    0, 1348,    0,    0,  758, 1107,  614,    0,
  758,    0,  758,    0,  760,    0,  760,  760,  760,  760,
  760,  760,  760,  760,    0,  587,    0,    0,    0,  758,
    0,    0, 1133,    0,    0,    0,  758,    0,    0,  612,
    0,  758,    0,    0,    0,    0,    0,  758,    0,    0,
    0,    0,  758,    0,    0,    0,  587,  758,  758,  587,
  758,    0,  758,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  587,    0,    0,  758,    0,  758,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  758,    0,  596,  596,  596,  596,  596,  596,  596,  596,
  758,    0,    0,    0,    0,    0,    0,  758,    0,  758,
  758,  585,  586,  587,  588,  589,  590,  591,    0,  683,
  758,    0,    0,  685,  758,  685,  685,    0,  758,    0,
    0,  758,  584,  585,  586,  587,  588,  589,  590,  591,
    0,  758,  758,  758,  758,  758,  683,  758,    0,    0,
  683,  683,  683,  683,  683,  685,  683,    0,    0,  685,
    0,  685,    0,    0,  758,  758,    0,  683, 1497,    0,
  672,  672,  672,  672,  672,  672,  672,  672,  685,    0,
    0,    0,    0,    0,    0,  685,    0,    0,    0,    0,
  685,    0,    0,  392,    0,    0,  685,    0,  758,  758,
  758,    0,  683,    0,    0,    0,  758,    0,    0,    0,
    0,    0,    0,  758,  758,    0,    0,  758,    0,    0,
    0,    0,  758,    0,    0,  685,    0,  685,    0,    0,
  758,    0,    0,    0,  758,  393,    0,    0,    0,  685,
  244,    0,  394,    0,    0,    0,    0,    0,    0,  685,
    0,    0,    0,    0,    0,    0,  685,    0,    0,  685,
    0,    0,    0,    0,    0,    0,    0,    0,  684,  685,
    0,    0,    0,  685,    0,    0,    0,  685,    0,    0,
  685,    0,    0,    0,    0,    0,    0,    0,    0,  395,
  685,  685,  685,  685,  685,  684,  685, 1549,    0,  684,
  684,  684,  684,  684, 1554,  684,    0,    0,  396,    0,
    0,    0,    0,  685,  685,    0,  684,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  397,    0,    0,    0,
    0,    0,  758,    0,  758,  758,  758,  758,  758,  758,
  758,  758,    0,    0,    0,    0,    0,  685,  685,  685,
    0,  684,  245,    0,    0,  685,    0,    0,  238,    0,
    0,  239,  685,  685,    0,    0,  685,  585,    0,    0,
    0,  685,    0,    0,  246,    0,    0,    0,    0,  685,
    0,    0,    0,  685,    0,    0,    0,  247,    0,    0,
  683,    0,  683,  683,    0,    0,    0,    0,  585,  585,
  585,  585,  585,    0,  585,  591,  591,  591,  591,  591,
  591,  591,  591,    0,  398,  585,    0,    0,    0,    0,
  585,    0,  683,    0,    0,    0,  683,  399,  683,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  683,    0,  400,    0,    0,
    0,  585,  683,    0,    0,    0,    0,  683,    0,  248,
  249,  250,  251,  683,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
    0,  685,    0,  685,  685,  685,  685,  685,  685,  685,
  685,    0,  683,    0,  683,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  683,  602,  603,  604,
  605,  606,  607,    0,    0,    0,  683,  598,    0,    0,
    0,    0,    0,  683,    0,    0,  683,    0,    0,    0,
    0,    0,    0,    0,    0,  686,  683,    0,    0,  684,
  683,  684,  684,    0,  683,    0,    0,  683,  598,  598,
  598,  598,  598,    0,  598,    0,    0,  683,  683,  683,
  683,  683,  686,  683,    0,  598,  686,  686,  686,  686,
  686,  684,  686,    0,    0,  684,    0,  684,    0,    0,
  683,  683,    0,  686,    0,    0,  600,  601,  602,  603,
  604,  605,  606,  607,  684,    0,    0,    0,    0,    0,
    0,  684,    0,    0,    0,    0,  684,    0,    0,    0,
    0,    0,  684,    0,  683,  683,  683,    0,  686,    0,
    0,    0,  683,    0,    0,    0,    0,    0,    0,  683,
  683,    0,    0,  683,    0,    0,    0,    0,  683,    0,
    0,  684,    0,  684,    0,    0,  683,    0,    0,    0,
  683,    0,    0,    0,    0,  684,  758,  758,  758,  758,
  758,  758,  758,  758,    0,  684,    0,    0,  587,    0,
    0,    0,  684,    0,    0,  684,    0,    0,    0,    0,
    0,    0,    0,    0,  681,  684,    0,    0,    0,  684,
    0,    0,    0,  684,    0,  684,  684,    0,    0,  587,
  600,  600,  587,  600,    0,  600,  684,  684,  684,  684,
  684,    0,  684,    0,    0,  681,  587,  681,  681,  681,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  684,
  684,    0,  681,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  683,    0,
  683,  683,  683,  683,  683,  683,  683,  683,    0,    0,
    0,    0,    0,  684,  684,  684,    0,  681,    0,    0,
  586,  684,    0,    0,    0,    0,    0,    0,  684,  684,
  669,    0,  684,    0,    0,    0,    0,  684,    0,    0,
    0,  589,    0,    0,    0,  684,    0,    0,    0,  684,
    0,  586,  586,  586,  586,  586,  686,  586,  686,  686,
    0,  669,  669,  669,  669,  669,    0,  669,  586,    0,
    0,    0,  589,  586,  589,  589,  589,    0,  669,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  686,  589,
    0,    0,  686,  667,  686,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  586,    0,    0,    0,    0,  587,
    0,  686,    0,    0,  669,    0,    0,    0,  686,    0,
    0,    0,    0,  686,  667,  667,  667,  667,  667,  686,
  667,    0,  587,    0,    0,    0,    0,    0,    0,    0,
  587,  667,  595,  587,  595,    0,  674,  684,    0,  684,
  684,  684,  684,  684,  684,  684,  684,  587,  686,  686,
  686,  675,    0,  587,  604,  604,  587,  604,    0,  604,
    0,    0,  686,  674,    0,    0,    0,  667,  674,  674,
  587,  674,  686,  674,    0,    0,  682,    0,  675,  686,
    0,    0,  686,  675,  675,    0,  675,    0,  675,  674,
    0,    0,  686,  613,    0,  681,  686,  681,  681,    0,
  686,    0,    0,  686,  675,    0,    0,  682,    0,  682,
  682,  682,    0,  686,  686,  686,  686,  686,    0,  686,
  674,  602,    0,    0,  682,  610,  608,  681,  609,    0,
  611,  681,  593,  681,    0,  675,  686,  686,  585,  585,
  585,  585,  585,  585,  585,  585,  614,    0,    0,    0,
  681,    0,  602,  602,  602,  602,  602,  681,  602,  682,
    0,    0,  681,  593,    0,  593,  593,  593,  681,  602,
  686,  686,  686,    0,    0,    0,    0,  612,  686,    0,
  593,  605,    0,    0,    0,  686,  686,    0,    0,  686,
    0,    0,    0,    0,  686,    0,    0,  681,    0,  681,
    0,    0,  686,  587,    0,    0,  686,    0,    0,    0,
    0,  681,  605,  605,  605,  605,  605,    0,  605,    0,
    0,  681,  597,    0,    0,    0,    0,    0,  681,  605,
    0,  681,    0,    0,  587,  599,  599,  587,  599,    0,
  599,  681,    0,    0,  676,  681,    0,    0,    0,  681,
    0,  587,  681,  597,  597,  597,  597,  597,    0,  597,
    0,    0,  681,  681,  681,  681,  681,    0,  681,    0,
  597,  676,    0,    0,    0,    0,  676,  676,    0,  676,
    0,  676,    0,    0,    0,  681,  681,    0,  598,  598,
  598,  598,  598,  598,  598,  598,    0,  676,    0,    0,
    0,    0,    0,    0,  686,    0,  686,  686,  686,  686,
  686,  686,  686,  686,    0,    0,    0,    0,    0,  681,
  681,  681,    0,    0,    0,  587,    0,  681,  676,    0,
    0,    0,    0,  601,  681,  681,    0,    0,  681,    0,
    0,    0,    0,  681,    0,    0,    0,  682,    0,  682,
  682,  681,    0,    0,  583,  681,  587,  603,  603,  587,
  603,    0,  603,  587,  601,  601,  601,  601,  601,    0,
  601,    0,    0,  587,    0,    0,    0,    0,    0,  682,
    0,  601,    0,  682,  607,  682,  583,  583,    0,  583,
    0,  583,    0,    0,  587,  606,  606,  587,  606,    0,
  606,    0,  682,    0,    0,    0,    0,  583,    0,  682,
    0,  587,    0,    0,  682,  607,  607,  607,  607,  607,
  682,  607,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  607,    0,    0,  584,    0,    0,  583,  600,
  600,  600,  600,  600,  600,  600,  600,    0,    0,  682,
    0,  682,  585,  681,    0,  681,  681,  681,  681,  681,
  681,  681,  681,  682,    0,    0,    0,  584,  584,    0,
  584,    0,  584,  682,    0,  586,    0,    0,    0,    0,
  682,    0,    0,  682,  585,  585,    0,  585,  584,  585,
    0,    0,    0,  682,    0,    0,    0,  682,    0,    0,
    0,  682,    0,    0,  682,  585,    0,  586,  586,    0,
  586,    0,  586,    0,  682,  682,  682,  682,  682,  584,
  682,    0,    0,    0,    0,    0,    0,    0,  586,    0,
    0,    0,    0,    0,    0,    0,  585,  682,  682,    0,
    0,  586,  586,  586,  586,  586,  586,  586,  586,    0,
    0,  669,  669,  669,  669,  669,  669,  669,  669,  586,
    0,    0,  589,  589,  589,  589,  589,  589,  589,  589,
    0,  682,  682,  682,    0,    0,    0,    0,    0,  682,
    0,    0,    0,    0,    0,    0,  682,  682,    0,    0,
  682,    0,    0,    0,    0,  682,    0,    0,    0,    0,
    0,  817,    0,  682,    0,    0,    0,  682,  818,    0,
    0,    0,    0,    0,  667,  667,  667,  667,  667,  667,
  667,  667,    0,    0,    0,    0,    0,    0,    0,    0,
  595,  595,  595,  595,  595,  595,  595,  595,    0,  440,
 1001,  610,  608,    0,  609,    0,  611,    0,    0,    0,
    0,    0,    0,  604,  604,  604,  604,  604,  604,  604,
  604,    0,  614,    0,  819,  820,    0,  674,  674,  674,
  674,  674,  674,  674,  674,    0,    0,    0,    0,    0,
    0,    0,  675,  675,  675,  675,  675,  675,  675,  675,
    0,    0,    0,  612,    0,    0,    0,    0,    0,    0,
    0,  821,  822,  823,    0,  682,    0,  682,  682,  682,
  682,  682,  682,  682,  682,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  600,  601,  602,  603,  604,  605,
  606,  607,    0,    0,  596,    0,    0,  824,    0,  782,
  780,  865,  781,    0,  783,    0,    0,    0,    0,    0,
    0,    0,  602,  602,  602,  602,  602,  602,  602,  602,
  599,    0,    0,  593,  593,  593,  593,  593,  593,  593,
  593,    0,    0,    0,    0,    0,    0,    0,    0,  825,
    0,    0,    0,    0,    0,    0,  826,  827,    0,    0,
    0,  784,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  605,  605,  605,  605,  605,  605,  605,  605,
    0,    0,    0,  828,    0,    0,    0,  829,    0,    0,
    0,    0,    0,    0,  599,  599,  599,  599,  599,  599,
  599,  599,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  756,  597,  597,  597,  597,  597,  597,  597,
  597,    0,    0,  596,    0,    0,    0,    0,  782,  780,
  873,  781,    0,  783,    0,  676,  676,  676,  676,  676,
  676,  676,  676,  756,    0,    0,  756,    0,    0,  599,
    0,  750,    0,    0,    0,    0,    0,    0,    0,    0,
  756,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  784,    0,  750,    0,    0,  750,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  756,    0,    0,    0,  750,
    0,    0,    0,    0,    0,    0,  440,    0,  440,    0,
    0,    0,    0,    0,    0,    0,  603,  603,  603,  603,
  603,  603,  603,  603,  601,  601,  601,  601,  601,  601,
  601,  601,  440,    0,  750,    0,    0,  440,    0,    0,
    0,    0,    0,    0,    0,  583,  583,  583,  583,  583,
  583,  583,  583,    0,  606,  606,  606,  606,  606,  606,
  606,  606,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  440,    0,  440,  607,  607,  607,  607,  607,
  607,  607,  607,    0,    0,    0,  440,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  440,    0,    0,  440,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  440,    0,    0,    0,
  440,    0,    0,    0,    0,    0,  584,  584,  584,  584,
  584,  584,  584,  584,    0,    0,    0,  440,    0,    0,
  440,  440,    0,  585,  585,  585,  585,  585,  585,  585,
  585,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  440,  440,    0,    0,  751,    0,  586,  586,  586,  586,
  586,  586,  586,  586,  596,    0,    0,    0,    0,  782,
  780,  879,  781,  756,  783,  756,  756,    0,    0,    0,
    0,    0,    0,    0,  440,  751,  440,    0,  751,    0,
  599,    0,    0,    0,    0,    0,    0,    0,    0,  440,
  440,    0,  751,  440,    0,  756,    0,    0,    0,  756,
    0,  756,  750,    0,  750,  750,  440,    0,    0,    0,
  440,  784,    0,    0,    0,    0,    0,    0,  756,    0,
    0,    0,    0,    0,    0,  756,    0,  751,    0,    0,
  756,    0,    0,    0,  750,    0,  756,    0,  750,    0,
  750,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  750,    0,    0,
    0,    0,    0,    0,  750,  756,    0,  756,    0,  750,
    0,    0,    0,    0,    0,  750,    0,    0,    0,  756,
  600,  601,  602,  603,  604,  605,  606,  607,    0,  756,
    0,    0,    0,  752,    0,    0,  756,    0,    0,  756,
    0,    0,    0,    0,  750,    0,  750,    0,  440,  756,
    0,    0,    0,  756,    0,    0,    0,  756,  750,    0,
  756,    0,    0,    0,  752,    0,    0,  752,  750,    0,
  756,  756,  756,  756,  756,  750,  756,    0,  750,    0,
    0,  752,    0,    0,    0,    0,    0,    0,  750,    0,
    0,    0,  750,  756,  756,    0,  750,    0,    0,  750,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  750,
  750,  750,  750,  750,    0,  750,  752,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,  756,  756,  756,
    0,    0,  750,  750,    0,  756,    0,    0,    0,    0,
    0,    0,  756,  756,    0,    0,  756,    0,    0,    0,
    0,  756,    0,    0,    0,  751,    0,  751,  751,  756,
    0,    0,    0,  756,    0,    0,  750,  750,  750,    0,
    0,    0,    0,    0,  750,    0,    0,    0,    0,    0,
    0,  750,  750,    0,    0,  750,    0,  751,    0,    0,
  750,  751,    0,  751,    0,    0,    0,    0,  750,    0,
    0,    0,  750,    0,    0,    0,    0,    0,    0,    0,
  751,    0,    0,  596,    0,    0,    0,  751,  782,  780,
  932,  781,  751,  783,    0,    0,    0,    0,  751,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  599,
    0,    0,    0,    0,    0,    0,  753,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,  751,    0,  751,
    0,  756,    0,  756,  756,    0,    0,    0,    0,    0,
  784,  751,    0,    0,    0,    0,    0,  753,    0,    0,
  753,  751,    0,    0,    0,  754,    0,    0,  751,    0,
    0,  751,    0,    0,  753,    0,    0,    0,    0,    0,
  750,  751,  750,  750,  752,  751,  752,  752,    0,  751,
    0,    0,  751,    0,    0,    0,  754,    0,    0,  754,
    0,    0,  751,  751,  751,  751,  751,    0,  751,  753,
    0,    0,    0,  754,  610,  608,  752,  609,    0,  611,
  752,    0,  752,    0,    0,  751,  751,    0,    0,    0,
    0,    0,    0,    0,    0,  614,    0,    0,    0,  752,
    0,    0,    0,    0,    0,    0,  752,    0,  754,    0,
    0,  752,    0,    0,    0,    0,    0,  752,    0,  751,
  751,  751,    0,    0,    0,    0,  612,  751,    0,    0,
    0,    0,    0,    0,  751,  751,    0,    0,  751,    0,
    0,    0,    0,  751,    0,    0,  752,    0,  752,    0,
    0,  751,    0,    0,    0,  751,    0,    0,    0,    0,
  752,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  752,    0,    0,    0,    0,    0,    0,  752,    0,    0,
  752,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  752,    0,    0,    0,  752,    0,    0,    0,  752,  755,
    0,  752,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  752,  752,  752,  752,  752,    0,  752,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  755,    0,    0,  755,  752,  752,    0,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,  755,    0,    0,
    0,    0,    0,  751,    0,  751,  751,  753,    0,  753,
  753,    0,    0,    0,    0,    0,    0,    0,  752,  752,
  752,    0,    0,    0,    0,    0,  752,    0,    0,    0,
    0,    0,  755,  752,  752,    0,    0,  752,    0,  753,
    0,    0,  752,  753,    0,  753,  754,    0,  754,  754,
  752,    0,    0,    0,  752,    0,    0,    0,    0,    0,
    0,    0,  753,    0,    0,    0,    0,    0,    0,  753,
    0,    0,    0,    0,  753,    0,    0,    0,  754,    0,
  753,    0,  754,    0,  754,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  754,    0,    0,    0,    0,    0,    0,  754,  753,
  757,  753,    0,  754,    0,    0,    0,    0,    0,  754,
    0,    0,    0,  753,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  753,    0,    0,    0,    0,    0,    0,
  753,  757,    0,  753,  757,    0,    0,    0,  754,    0,
  754,    0,  752,  753,  752,  752,    0,  753,  757,    0,
    0,  753,  754,    0,  753,    0,    0,    0,    0,    0,
    0,    0,  754,    0,  753,  753,  753,  753,  753,  754,
  753,    0,  754,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  754,  757,    0,    0,  754,  753,  753,    0,
  754,    0,    0,  754,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  754,  754,  754,  754,  754,    0,  754,
  755,    0,  755,  755,    0,    0,    0,    0,    0,    0,
    0,  753,  753,  753,    0,    0,  754,  754,    0,  753,
    0,    0,    0,    0,    0,    0,  753,  753,    0,    0,
  753,    0,  755,  441,    0,  753,  755,    0,  755,    0,
    0,    0,    0,  753,    0,    0,    0,  753,    0,    0,
  754,  754,  754,    0,    0,  755,    0,    0,  754,    0,
    0,    0,  755,    0,    0,  754,  754,  755,    0,  754,
    0,    0,  749,  755,  754,    0,    0,    0,    0,    0,
    0,    0,  754,    0,    0,    0,  754,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,    0,    0,    0,
    0,    0,  755,  749,  755,    0,  749,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  755,  596,    0,    0,
  749,    0,  782,  780,  937,  781,  755,  783,    0,    0,
    0,    0,    0,  755,    0,    0,  755,    0,    0,    0,
    0,    0,    0,  599,    0,  753,  755,  753,  753,    0,
  755,    0,    0,    0,  755,  749,    0,  755,    0,    0,
    0,  757,    0,  757,  757,    0,    0,  755,  755,  755,
  755,  755,    0,  755,  784,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  754,    0,  754,  754,    0,    0,
  755,  755,    0,  757,    0,    0,    0,  757,    0,  757,
    0,    0,    0,  600,  601,  602,  603,  604,  605,  606,
  607,    0,  395,    0,    0,    0,  757,    0,    0,    0,
    0,    0,    0,  757,  755,  755,  755,    0,  757,    0,
    0,    0,  755,    0,  757,    0,    0,    0,    0,  755,
  755,    0,    0,  755,    0,    0,    0,    0,  755,    0,
    0,  394,    0,    0,    0,    0,  755,    0,    0,    0,
  755,    0,    0,  757,    0,  757,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  757,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  757,    0,    0,
    0,    0,    0,    0,  757,    0,    0,  757,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  757,    0,    0,
    0,  757,    0,    0,    0,  757,    0,    0,  757,    0,
    0,    0,    0,  389,    0,    0,    0,    0,  757,  757,
  757,  757,  757,    0,  757, 1137,  610,  608,    0,  609,
  441,  611,  441,  749,    0,  749,  749,    0,    0,    0,
    0,  757,  757,    0,    0,    0,    0,  614,  755,    0,
  755,  755,  390,    0,    0,    0,  441,    0,    0,    0,
    0,  441,    0,    0,    0,  749,    0,    0,    0,  749,
    0,  749,    0,    0,    0,  757,  757,  757,  612,    0,
    0,    0,    0,  757,    0,    0,    0,    0,  749,    0,
  757,  757,    0,    0,  757,  749,  441,    0,  441,  757,
  749,    0,    0,    0,    0,    0,  749,  757,    0,    0,
  441,  757,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  391,    0,    0,    0,    0,    0,  441,    0,    0,
  441,    0,    0,    0,    0,  749,    0,  749,    0,    0,
  441,    0,    0,    0,  441,    0,    0,    0,    0,  749,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  749,
  392,  441,    0,    0,  441,  441,  749,    0,    0,  749,
    0,    0,  596,  395,    0,  395,  395,  782,  780,  749,
  781,    0,  783,  749,  441,  441,    0,  749,    0,    0,
  749,    0,    0, 1347,    0,    0,    0,    0,  599,    0,
  749,  749,  749,  749,  749,  395,  749,    0,    0,  757,
    0,  757,  394,    0,  394,  394,    0,    0,  441,    0,
  441,    0,    0,  749,  749,    0,    0,    0,  395,  784,
    0,    0,    0,  441,  441,    0,    0,  441,    0,    0,
  395,    0,    0,    0,  394,    0,  395,    0,    0,    0,
  441,    0,    0,    0,  441,    0,    0,  749,  749,  749,
    0,    0,    0,    0,    0,  749,    0,  394,  416,    0,
    0,    0,  749,  749,    0,    0,  749,    0,    0,  394,
    0,  749,    0,    0,  389,  394,  389,  389,    0,  749,
    0,    0,    0,  749,    0,    0,    0,    0,    0,  395,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  389,    0,    0,  395,
    0,    0,    0,  390,    0,  390,  390,  395,    0,    0,
  395,    0,    0,    0,    0,    0,    0,    0,  394,  389,
  395,  395,  395,  395,  395,    0,  395,    0,    0,    0,
    0,  389,  441,    0,    0,  390,    0,  389,  394,    0,
    0,    0,    0,    0,    0,    0,  394,    0,    0,  394,
    0,    0,    0,    0,    0,    0,    0,    0,  390,  394,
  394,  394,  394,  394,    0,  394,    0,    0,    0,    0,
  390,  749,  391,    0,  391,  391,  390,    0,  395,    0,
    0,    0,    0,    0,    0,  395,    0,    0,    0,    0,
  389,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,    0,    0,    0,  391,    0,    0,    0,    0,  395,
  389,  392,    0,  392,  392,    0,    0,  394,  389,    0,
    0,  389,    0,    0,  394,    0,    0,  391,    0,  390,
    0,  389,  389,  389,  389,  389,    0,  389,    0,  391,
    0,    0,    0,  392,    0,  391,    0,    0,  394,  390,
    0,    0,    0,    0,    0,    0,    0,  390,    0,    0,
  390,    0,    0,    0,    0,    0,  392,    0,    0,    0,
  390,  390,  390,  390,  390,  596,  390,    0,  392,    0,
  782,  780,  959,  781,  392,  783,    0,    0,    0,  389,
    0,    0,    0,    0,    0,    0,  389,    0,  391,    0,
    0,  599,    0,    0,    0,    0,    0,  596,    0,    0,
    0,  395,  782,  780,  968,  781,    0,  783,  391,  416,
  389,  416,  416,    0,    0,    0,  391,    0,  390,  391,
    0,    0,  784,  599,    0,  390,    0,  392,    0,  391,
  391,  391,  391,  391,    0,  391,    0,    0,    0,    0,
  394,  416,    0,    0,    0,    0,    0,  392,    0,  390,
    0,    0,  168,    0,  784,  392,    0,  159,  392,    0,
    0,    0,    0,    0,  416,    0,    0,    0,  392,  392,
  392,  392,  392,    0,  392,    0,  416,    0,    0,    0,
    0,    0,  416,    0,    0,    0,    0,  391,    0,    0,
    0,    0,    0,    0,  391,  600,  601,  602,  603,  604,
  605,  606,  607,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  389,    0,    0,    0,    0,  596,  391,    0,
    0,    0,  782,  780,  987,  781,  392,  783,    0,    0,
    0,    0,  596,  392,    0,  416, 1136,  594,  592,    0,
  593,    0,  595,  599,    0,    0,    0,    0,    0,    0,
    0,  390,    0,    0,    0,  416,    0,  392,  599,    0,
    0,    0,    0,  416,    0,  596,  416,    0,    0, 1138,
  594,  592,    0,  593,  784,  595,  416,  416,  416,  416,
  416,    0,  416,    0,    0,    0,    0,    0,    0,  597,
    0,  599,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  596,
    0,    0,    0, 1140,  594,  592,    0,  593,    0,  595,
  391,    0,  597,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  416,  599,    0,    0,    0,    0,
    0,  416,    0,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,    0,    0,    0,    0,  392,
    0,    0,    0,    0,    0,  416,  597,    0,    1,    2,
    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,   41,    0,
   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
    0,    0,   52,   53,    0,    0,    0,   54,   55,    0,
    0,    0,    0,   56,    0,    0,   57,   58,    0,    0,
    0,   59,   60,   61,    0,    0,   62,    0,    0,    0,
   63,    0,   64,    0,    0,    0,    0,   65,    0,   66,
   67,    0,   68,   69,    0,    0,   70,  416,   71,    0,
   72,   73,    0,   74,    0,    0,    0,    0,    0,   75,
    0,    0,    0,    0,   76,    0,    0,   77,    0,    0,
    0,    0,   78,   79,    0,    0,    0,   80,   81,   82,
   83,    0,   84,   85,    0,    0,   86,    0,    0,    0,
    0,    0,    0,    0,   87,    0,    0,    0,   88,    0,
    0,    0,    0,    0,   89,   90,    0,   91,    0,    0,
    0,    0,   92,    0,    0,    0,   93,   94,    0,   95,
   96,   97,   98,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   99,  100,  323,    0,    0,    0,    0,  315,
    0,    0,    0,    0,    0,    0,    0,  101,  596,    0,
    0,    0, 1142,  594,  592,    0,  593,    0,  595,    0,
  102,    0,    0,    0,    0,  103,  104,    0,    0,    0,
    0,  105,  106,  107,  599,  108,  109,  110,  111,    0,
    0,    0,    0,    0,    0,  112,  113,  114,  115,  116,
    0,  117,    0,    0,    0,  118,  119,    0,    0,    0,
  120,    0,    0,  121,  122,  597,  596,    0,  123,    0,
    0,  594,  592, 1144,  593,  124,  595,  125,  126,  127,
  128,    0,    0,    0,  129,  130,    0,    0,    0,  131,
    0,  132,  599,    0,  133,  134,  135,  136,  137,  138,
    0,  139,  140,    0,    0,    0,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0,    0,    0,
    0,    0,    0,  597,    0,    0,    0,  141,  142,  143,
  144,  145,  146,  147,  148,  149,    0,    0,    0,  150,
  151,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,    0,    0,  596,    0,    0,    0, 1146,  594,  592,
    0,  593,    0,  595,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  599,
    0,    0,  152,    0,    0,    0,    0,  153,  154,  155,
  156,  157,  158,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  160,  161,  162,  163,  164,  165,  166,  167,
  597,  269,  270,  271,  272,  273,  274,  275,  276,   10,
   11,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,   22,   23,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,    0,   42,   43,   44,   45,   46,   47,   48,   49,
    0,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,    0,    0,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,    0,    0,    0,    0,    0,
    0,    0,  415,    0,    0,    0,    0,  416,    0,    0,
    0,    0,  417,    0,    0,    0,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,  596,    0,  323,
    0, 1148,  594,  592,  315,  593,    0,  595,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  418,    0,    0,
    0,    0,    0,  599,  345,    0,    0,    0,    0,    0,
    0,  419,    0,  584,  585,  586,  587,  588,  589,  590,
  591,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  420,    0,    0,  597,  421,    0,    0,  596,  422,
    0,  423, 1150,  594,  592,  424,  593,    0,  595,    0,
    0,  596,    0,    0,    0, 1152,  594,  592,    0,  593,
    0,  595,  238,  596,  599,  239,    0, 1154,  594,  592,
    0,  593,    0,  595,    0,  596,    0,  599,    0, 1156,
  594,  592,    0,  593,    0,  595,    0,    0,    0,  599,
    0,    0,    0,    0,    0,  597,    0,  596,    0,    0,
  312,  599,  594,  592, 1158,  593,    0,  595,  597,    0,
    0,    0,    0,    0,    0,    0,    0,  313,    0,    0,
  597,  596,    0,  599,    0, 1161,  594,  592,    0,  593,
  596,  595,  597,    0, 1163,  594,  592,    0,  593,  425,
  595,    0,    0,    0,    0,    0,    0,  599,    0,    0,
    0,    0,    0,    0,  597,  426,  599,    0,    0,    0,
  137,  138,  427,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  597,    0,
    0,    0,    0,    0,    0,    0,    0,  597,    0,  141,
  142,  428,  144,  145,  146,  147,  269,  270,  271,  272,
  273,  274,  275,  276,   10,   11,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,   22,   23,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,    0,    0,
    0,    0,  314,  157,  158,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  316,    0,  317,  318,  319,  320,
  321,  322,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,  500,    0,    0,    0,    0,  501,    0,    0,
    0,    0,  502,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  323,    0,    0,    0,    0,  315,
    0,    0,    0,    0,    0,    0,    0,    0,  596,    0,
    0,    0,  503,  594,  592, 1165,  593,    0,  595,  504,
  584,  585,  586,  587,  588,  589,  590,  591,    0,    0,
    0,  596,    0,    0,  599, 1170,  594,  592,    0,  593,
    0,  595,    0,  505,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  506,  599,    0,    0,
  507,    0,    0,    0,    0,  597,  596,    0,    0,    0,
 1172,  594,  592,    0,  593,    0,  595,  238,    0,  596,
  239,    0,    0, 1174,  594,  592,    0,  593,  597,  595,
  596,    0,  599,    0,    0,  594,  592, 1176,  593,    0,
  595,    0,    0,    0,    0,  599,    0,  584,  585,  586,
  587,  588,  589,  590,  591,  312,  599,    0,    0,    0,
    0,  508,    0,  597,    0,    0,    0,    0,    0,    0,
    0,    0,  313,  596,    0,    0,  597,    0,  594,  592,
 1178,  593,    0,  595,  596,    0,    0,  597,    0,  594,
  592, 1180,  593,    0,  595,    0,    0,    0,    0,  599,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  599,    0,    0,    0,    0,  137,  138,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  597,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  597,    0,    0,  141,  142,  143,  144,  145,  146,
  147,  269,  270,  271,  272,  273,  274,  275,  276,   10,
   11,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,   22,   23,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,    0,   42,   43,   44,   45,   46,   47,   48,   49,
    0,    0,    0,    0,    0,    0,    0,  314,  157,  158,
    0,  584,  585,  586,  587,  588,  589,  590,  591,  316,
    0,  317,  318,  319,  320,  321,  322,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  305,    0,    0,    0,    0,  306,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  323,
    0,    0,    0,    0,  315,    0,    0,    0,    0,    0,
    0,  307,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,    0,    0,  308,  584,  585,  586,  587,  588,
  589,  590,  591,    0,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0,  596,  309,
    0,  310, 1184,  594,  592,  311,  593,    0,  595,    0,
    0,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,    0,  238,    0,  599,  239,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,  597,  596,    0,    0,    0,
  312,  594,  592, 1182,  593,    0,  595,    0,    0,    0,
    0,    0,    0,    0,    0,  596,    0,  313,    0, 1186,
  594,  592,  599,  593,  596,  595,    0,    0,    0,  594,
  592, 1188,  593,    0,  595,    0,    0,    0,    0,    0,
    0,  599,    0,    0,    0,    0,    0,    0,    0,    0,
  599,    0,    0,  597,    0,    0,    0,    0,    0,    0,
  137,  138,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  597,    0,    0,    0,    0,    0,    0,    0,
    0,  597,    0,    0,    0,    0,    0,    0,    0,  141,
  142,  143,  144,  145,  146,  147,  269,  270,  271,  272,
  273,  274,  275,  276,   10,   11,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,   22,   23,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,    0,    0,
    0,    0,  314,  157,  158,    0,    0,    0,    0,    0,
    0,  431,    0,    0,  316,    0,  317,  318,  319,  320,
  321,  322,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,    0,    0,    0,    0,    0,  432,    0,    0,
    0,    0,  433,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,  323,    0,    0,    0,    0,  315,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  434,
  584,  585,  586,  587,  588,  589,  590,  591,    0,    0,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,    0,    0,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,  596,  435,    0,  436, 1190,  594,  592,
  437,  593,    0,  595,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  238,    0,  599,
  239,    0,    0,    0,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,    0,    0,    0,
  597,    0,    0,    0,    0,  312,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  313,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  137,  138,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  141,  142,  143,  144,  145,  146,
  147,  269,  270,  271,  272,  273,  274,  275,  276,   10,
   11,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,   22,   23,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,    0,   42,   43,   44,   45,   46,   47,   48,   49,
    0,    0,    0,    0,    0,    0,    0,  314,  157,  158,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  316,
    0,  317,  318,  319,  320,  321,  322, 1139,  610,  608,
    0,  609,    0,  611,    0,    0,    0,    0,    0,    0,
  596,    0,  567,    0, 1192,  594,  592,  568,  593,  614,
  595,    0,    0,    0,    0,    0,    0,  596,    0,  323,
    0, 1194,  594,  592,  315,  593,  599,  595,    0,    0,
    0,  569,  584,  585,  586,  587,  588,  589,  590,  591,
  612,  596,    0,  599,  570, 1196,  594,  592,    0,  593,
    0,  595,    0,    0,    0,    0,    0,  597,    0,    0,
  596,    0,    0,    0, 1000,  782,  780,  599,  781,    0,
  783,    0,    0,    0,  597,    0,    0,    0,    0,  571,
    0,  572,    0,    0,    0,  573,  599,    0,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,  597,    0,
    0,    0,  238,    0,    0,  239,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,  784,  584,  585,
  586,  587,  588,  589,  590,  591,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  313,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  323,    0,    0,    0,    0,  315,    0,    0,    0,
  137,  138,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  141,
  142,  143,  144,  145,  146,  147,  269,  270,  271,  272,
  273,  274,  275,  276,   10,   11,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,   22,   23,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,    0,   42,   43,   44,
   45,   46,   47,   48,   49,    0,    0,    0,    0,    0,
    0,    0,  314,  157,  158,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  316,    0,  317,  318,  319,  320,
  321,  322,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1060, 1061,    0,    0,    0,    0, 1062,  596,    0,
    0,    0,    0,  782,  780, 1294,  781,    0,  783,  596,
    0,    0,    0,    0,  782,  780, 1299,  781,    0,  783,
    0,    0,    0,    0,  599,    0, 1063,  584,  585,  586,
  587,  588,  589,  590,  591,  599,    0,    0,    0,  345,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  784,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  784,    0,    0,    0,
    0,    0,    0,    0, 1064,    0, 1065,    0,  269,  270,
  271,  272,  273,  274,  275,  276,   10,   11,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,   22,   23,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,    0,   42,
   43,   44,   45,   46,   47,   48,   49,    0,    0,    0,
    0,    0,    0,    0,    0,  312,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  313,    0,    0, 1066, 1067,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1398,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  596,    0,  323,    0,    0,  782,
  780,  315,  781,    0,  783,  137,  138,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  599,  345,    0,    0, 1399,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  141,  142,  143,  144,  145,  146,
  147,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1329,  784,    0,    0,    0,    0, 1400,    0, 1401,    0,
    0,    0,    0,    0,    0,    0,    0,  600,  601,  602,
  603,  604,  605,  606,  607,    0,    0,    0,    0,  238,
    0,    0,  239,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,    0,    0,  314,  157,  158,
    0,  584,  585,  586,  587,  588,  589,  590,  591,  316,
    0,  317,  318,  319,  320,  321,  322,  312,    0,    0,
    0,    0,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,  596,  313,    0,    0, 1402,  782,  780,
 1300,  781,    0,  783,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,    0,    0,    0,    0,  599,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  137,  138,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  784,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  141,  142,  143,  144,
  145,  146,  147,  269,  270,  271,  272,  273,  274,  275,
  276,   10,   11,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,   22,   23,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,    0,   42,   43,   44,   45,   46,   47,
   48,   49,    0,    0,    0,    0,    0,  596,    0,  314,
  157,  158,  782,  780, 1304,  781,    0,  783,    0,    0,
    0,  316,    0,  317,  318,  319,  320,  321,  322,    0,
  596,    0,    0,  599,    0,  782,  780, 1313,  781,    0,
  783,    0,    0,    0, 1405,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  599,    0,    0,    0,
    0,  323,    0,    0,  784,    0,  315,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  345,  784,    0, 1406,
    0,    0,    0,    0,  596,    0,    0,    0,    0,  782,
  780, 1327,  781,    0,  783,  596,    0,    0,    0, 1335,
  594,  592,    0,  593,    0,  595,    0,    0,    0,    0,
  599, 1407,  596, 1408,    0,    0, 1337,  594,  592,    0,
  593,  599,  595,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  238,  323,    0,  239,  599,    0,
  315,  784,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,  597,  584,  585,  586,  587,  588,  589,  590,
  591, 1141,  610,  608,    0,  609,    0,  611,    0,  597,
  596,    0,  312,    0, 1339,  594,  592,    0,  593,    0,
  595,    0,    0,  614,    0,    0,    0,    0,    0,  313,
  323,    0, 1409,    0,    0,  315,  599,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  612,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  597,    0,    0,
    0,    0,  137,  138,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  141,  142,  143,  144,  145,  146,  147,  269,  270,
  271,  272,  273,  274,  275,  276,   10,   11,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,   22,   23,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,    0,   42,
   43,   44,   45,   46,   47,   48,   49,    0,    0,    0,
    0,    0,    0,    0,  314,  157,  158,    0,  584,  585,
  586,  587,  588,  589,  590,  591,  316,    0,  317,  318,
  319,  320,  321,  322,    0,    0,    0,    0,    0,    0,
    0,    0,  269,  270,  271,  272,  273,  274,  275,  276,
   10,   11,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,   22,   23,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
  303,  304,    0,   42,   43,   44,   45,   46,   47,   48,
   49,  345,    0,    0,    0,    0,    0,  269,  270,  271,
  272,  273,  274,  275,  276,   10,   11,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,   22,   23,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,    0,   42,   43,
   44,   45,   46,   47,   48,   49,  596,    0,    0,    0,
 1341,  594,  592,    0,  593,    0,  595,  584,  585,  586,
  587,  588,  589,  590,  591,  610,  608, 1145,  609,    0,
  611,    0,  599,    0,    0,  345,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  614,  312,  596,    0,
    0,    0, 1343,  594,  592,    0,  593,    0,  595,    0,
    0,  596,    0,  597,  313, 1345,  594,  592,    0,  593,
    0,  595,    0,    0,  599,    0,    0,  612,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  599,    0,    0,
  345,    0,    0,  596,    0,    0,    0,    0,  782,  780,
 1372,  781,    0,  783,    0,  597,    0,  137,  138,    0,
    0,    0,    0,  531,  532,    0,    0,    0,  597,  599,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  312,    0,    0,    0,    0,  141,  142,  143,  144,
  145,  146,  147,    0,  323,    0,  533,  534,  313,  315,
  784,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  353,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,    0,  312,    0,    0,    0,
    0,  137,  138,  354,    0,    0,    0,  542,  543,  314,
  157,  158,  596,  313,    0,    0,    0,  782,  780,    0,
  781,  316,  783,  317,  318,  319,  320,  321,  322,    0,
  141,  142,  143,  144,  145,  146,  147,  323,  599,    0,
  544,  545,  315,    0,    0,    0,    0, 1447,  584,  585,
  586,  587,  588,  589,  590,  591,  137,  138,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0, 1349,  784,
    0,    0,    0,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,  141,  142,  143,  144,  145,
  146,  147,  168,  314,  157,  158,    0,  159,    0,    0,
  355,    0,    0,    0,    0,  316,    0,  317,  318,  319,
  320,  321,  322,    0,    0,    0,    0,    0,    0,    0,
    0,  600,  601,  602,  603,  604,  605,  606,  607,    0,
    0,    0,    0,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,    0,    0,    0,  314,  157,
  158,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  316,    0,  317,  318,  319,  320,  321,  322,    0,    0,
    0,  269,  270,  271,  272,  273,  274,  275,  276,   10,
   11,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,   22,   23,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,    0,   42,   43,   44,   45,   46,   47,   48,   49,
    0,    0,    0,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,  375,  376,  377,  378,  379,  380,  381,    0,
    0,    0,    0,    0,  269,  270,  271,  272,  273,  274,
  275,  276,   10,   11,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,   22,   23,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,    0,   42,   43,   44,   45,   46,
   47,   48,   49,    0,  345,    0,    0,    0,    0,    2,
    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,   16,   17,  558,   19,   20,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,   41,    0,
   42,   43,   44,   45,   46,   47,   48,   49,  596,    0,
    0,    0, 1479,  782,  780,    0,  781,    0,  783,    0,
    0,  596,    0,    0,    0, 1138,  782,  780,    0,  781,
    0,  783,    0,    0,  599,    0,  596,  345,    0,    0,
 1140,  782,  780,    0,  781,    0,  783,  599,    0,    0,
  312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  599,    0,    0,  784,    0,  313,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,  784,    0,
    0,    0,    0,    0,  600,  601,  602,  603,  604,  605,
  606,  607,  559,  784,    0,    0,    0,    0,  596,    0,
    0, 1449, 1142,  782,  780,    0,  781,    0,  783,    0,
  137,  138,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,    0,    0,  599,  584,  585,  586,  587,  588,
  589,  590,  591,  312,    0,    0,    0,    0,    0,  141,
  142,  143,  144,  145,  146,  147,  168,    0,    0,    0,
  313,  159,    0,    0,    0,  784,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,    0,    0,    0,
    0,    0,  596,    0,    0,    0,    0,  782,  780, 1144,
  781,  596,  783,    0,    0, 1146,  782,  780,  312,  781,
    0,  783,    0,  137,  138,    0,    0,    0,  599,    0,
    0,    0,  314,  157,  158,  560,    0,  599,    0,    0,
    0,    0,    0,    0,  316,    0,  317,  318,  319,  320,
  321,  322,  141,  142,  143,  144,  145,  146,  147,  784,
    0,  596,    0,    0,    0, 1148,  782,  780,  784,  781,
    0,  783,    0,    0,    0,    0,    0,    0,  137,  138,
  596,    0,    0,    0, 1150,  782,  780,  599,  781,    0,
  783,    0,    0,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,    0,  599,  141,  142,  143,
  144,  145,  146,  147,    0,  314,  157,  158,  784,    0,
    0,    0,    0,    0,    0,    0,    0,  316,    0,  317,
  318,  319,  320,  321,  322,  596,    0,  784,    0, 1152,
  782,  780,    0,  781,    0,  783,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  599,    0,    0,    0,    0,    0,    0,    0,    0,
  561,  157,  158,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  160,    0,  162,  163,  164,  165,  166,  167,
    0,    0,  784,    2,    3,    4,    5,    6,    7,    8,
    9,   10,   11,   12,   13,   14,   15,   16,   17,  558,
   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,   41,    0,   42,   43,   44,   45,   46,   47,
   48,   49,  596,    0,    0,    0, 1154,  782,  780,    0,
  781,  596,  783,    0,    0, 1156,  782,  780,    0,  781,
    0,  783,    0,    0,  596,    0,    0,    0,  599,  782,
  780, 1480,  781,    0,  783,  596,    0,  599,    0, 1161,
  782,  780,    0,  781,    0,  783,    0,  596,    0,    0,
  599, 1163,  782,  780,    0,  781,    0,  783,    0,  784,
    0,  599,    0,    0,  596,    0,    0,    0,  784,  782,
  780, 1481,  781,  599,  783,    0,    0,    0,    0,  596,
    0,  784,    0, 1170,  782,  780,  559,  781,    0,  783,
  599,  596,  784,    0,    0, 1172,  782,  780,    0,  781,
    0,  783,  596,    0,  784,  599, 1174,  782,  780,    0,
  781,    0,  783,    0,    0,    0,    0,  599,    0,  596,
    0,  784,    0,    0,  782,  780, 1176,  781,  599,  783,
    0,    0,  596,    0,    0,    0,  784,  782,  780, 1178,
  781,    0,  783,    0,  596,  599,    0,    0,  784,  782,
  780, 1180,  781,    0,  783,  596,    0,    0,  599,  784,
  782,  780, 1182,  781,    0,  783,    0,  596,    0,    0,
  599, 1184,  782,  780,    0,  781,  784,  783,    0,    0,
    0,  599,  312,    0,    0,    0,    0,    0,    0,  784,
    0,    0,    0,  599,    0,    0,    0,    0,    0,  677,
    0,  784,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,  784,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,  784,    0,    0,    0,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,    0,    0,
    0,    0,  137,  138,  596,    0,    0,    0, 1186,  782,
  780,    0,  781,  596,  783,    0,    0,    0,  782,  780,
 1483,  781,    0,  783,    0,    0,    0,    0,    0,    0,
  599,  141,  142,  143,  144,  145,  146,  147,    0,  599,
  596,    0,    0,    0, 1190,  782,  780,    0,  781,    0,
  783,    0,  584,  585,  586,  587,  588,  589,  590,  591,
    0,  784,    0,  596,    0,    0,  599, 1192,  782,  780,
  784,  781,    0,  783,    0,    0,    0,  596,    0,    0,
    0, 1194,  782,  780,    0,  781,    0,  783,    0,  599,
    0,    0,    0,    0,  561,  157,  158,  784,    0,    0,
    0,    0,    0,  599,    0,    0,  160,    0,  162,  163,
  164,  165,  166,  167,    0,    0,    0,    0,    0,    0,
  784,    0,    0,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,  784,  584,  585,  586,  587,  588,
  589,  590,  591,  596,    0,    0,    0, 1196,  782,  780,
    0,  781,    0,  783,    0,    0,  596,    0,    0,    0,
    0,  782,  780,    0,  781,    0,  783,  596,    0,  599,
    0, 1335,  782,  780,    0,  781,    0,  783,    0,    0,
    0,    0,  599,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,  599,    0,    0,    0,    0,    0,    0,
  784,    0,    0,    0,  584,  585,  586,  587,  588,  589,
  590,  591, 1486,  784,    0,  596,    0,    0,    0, 1337,
  782,  780,    0,  781,  784,  783,  596,    0,    0,    0,
 1339,  782,  780,    0,  781,    0,  783,    0,    0,    0,
    0,  599,    0,  596,    0,    0,    0, 1341,  782,  780,
    0,  781,  599,  783,    0,    0,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0,    0,  599,
  596,    0,  784,    0, 1343,  782,  780,    0,  781,    0,
  783,  596,    0,  784,    0, 1345,  782,  780,    0,  781,
    0,  783,    0,    0,    0,    0,  599,    0,  596,    0,
  784,    0,    0,  782,  780, 1487,  781,  599,  783,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  599,    0,  596,  784,    0,    0,
    0,  782,  780, 1494,  781,    0,  783,    0,  784,  596,
    0,    0,    0,    0,  782,  780, 1507,  781,    0,  783,
    0,    0,  599,    0,    0,  784,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  599,  584,  585,  586,  587,
  588,  589,  590,  591,    0,  584,  585,  586,  587,  588,
  589,  590,  591,  784,    0,    0,    0,    0,  584,  585,
  586,  587,  588,  589,  590,  591,  784,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0,    0,    0,
    0,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,    0,    0,    0,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,    0,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,    0,    0,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,    0,    0,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0,    0,    0,
    0,  584,  585,  586,  587,  588,  589,  590,  591,  596,
    0,    0,    0,    0,  782,  780,    0,  781,  596,  783,
    0,    0,    0,  782,  780, 1527,  781,    0,  783,    0,
    0,    0,    0,    0,    0,  599,    0,    0,    0,    0,
    0,  596,    0,    0,  599,    0,  782,  780, 1530,  781,
  596,  783,    0,    0,    0,  782,  780, 1531,  781,    0,
  783,    0,    0,    0,    0, 1488,  784,  599,    0,    0,
    0,    0,    0,    0,    0,  784,  599,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,    0,  784,    0,
    0,    0,    0,  596,    0,    0,    0,  784,  782,  780,
 1537,  781,    0,  783,  584,  585,  586,  587,  588,  589,
  590,  591,  596,    0,    0,    0, 1565,  782,  780,  599,
  781,    0,  783,    0,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,    0,  599,    0,
    0,  584,  585,  586,  587,  588,  589,  590,  591,  596,
  784,    0,    0, 1567,  594,  592,    0,  593,  596,  595,
    0,    0, 1569,  594,  592,    0,  593,    0,  595,  784,
    0,  596,    0,    0,    0,  599,  782,  780, 1575,  781,
    0,  783,    0,    0,  599,    0,    0,    0,    0,    0,
    0,    0,    0,  596,    0,    0,    0,  599,  782,  780,
 1576,  781,    0,  783,    0,    0,  597,  584,  585,  586,
  587,  588,  589,  590,  591,  597,    0,    0,    0,  599,
  584,  585,  586,  587,  588,  589,  590,  591,  784,    0,
    0,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,  596,    0,    0,    0, 1577,  782,  780,    0,  781,
  784,  783,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  599,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,  784,    0,
    0,    0,    0,    0,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,  596,    0,    0,    0,
 1579,  782,  780,    0,  781,    0,  783,    0,    0,    0,
    0,    0,    0,    0,  584,  585,  586,  587,  588,  589,
  590,  591,  599,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,  596,  784,    0,    0, 1581,  782,  780,    0,
  781,    0,  783,    0,    0,    0,    0,    0,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,  599,    0,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,  596,    0,    0,    0, 1583,  594,  592,    0,  593,
  596,  595,    0,    0, 1585,  594,  592,    0,  593,  784,
  595,    0,    0,  596,    0,    0,    0,  599,  782,  780,
 1600,  781,    0,  783,  596,    0,  599,    0,    0,  782,
  780, 1605,  781,    0,  783,  596,    0,    0,    0,  599,
  782,  780, 1607,  781,    0,  783,  596,    0,  597,    0,
  599,  782,  780, 1610,  781,    0,  783,  597,  596,    0,
    0,  599,    0,  782,  780,    0,  781,    0,  783,  596,
  784,    0,  599,    0,  782,  780, 1612,  781,    0,  783,
  596,  784,    0,    0,  599,  782,  780, 1617,  781,    0,
  783,  596,  784,    0,    0,  599,  782,  780, 1618,  781,
    0,  783,  596,  784,    0,    0,  599,  782,  780,    0,
  781,    0,  783,    0, 1611,  784,    0,  599,    0,  596,
    0,    0,    0, 1630,  782,  780,  784,  781,  599,  783,
    0,    0,    0,    0,  596,    0,    0,  784, 1632,  782,
  780,    0,  781,    0,  783,  599,  596,    0,  784,    0,
    0,  782,  780, 1635,  781,    0,  783,    0, 1634,  784,
  599,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  599,    0,    0,    0,  784,    0,    0,    0,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,  784,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,    0,  784,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,  584,  585,  586,  587,  588,  589,
  590,  591,  596,    0,    0,    0,    0,  782,  780, 1646,
  781,    0,  783,    0,    0,    0,    0,  596,    0,    0,
    0,    0,  782,  780, 1652,  781,    0,  783,  599,  596,
    0,    0,    0,    0,  782,  780, 1653,  781,    0,  783,
    0,    0,    0,  599,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,  599,    0,    0,    0,  784,
    0,    0,    0,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,  784,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  596,  784,    0,    0,    0,
  782,  780, 1656,  781,    0,  783,    0,    0,    0,    0,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,  599,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,  596,    0,    0,    0, 1659,  782,  780,
    0,  781,  784,  783,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,  596,    0,    0,  599,
 1660,  782,  780,    0,  781,  596,  783,    0,    0,    0,
  782,  780,    0,  781,    0,  783,    0,    0,  596,    0,
    0,    0,  599,  782,  780, 1666,  781,    0,  783,    0,
  784,  599,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,  599,    0,    0,    0,    0,    0,
  596,    0,    0,  784,    0,  782,  780, 1669,  781,    0,
  783, 1665,  784,  596,    0,    0,    0,    0,  782,  780,
 1671,  781,  596,  783,    0,  784,  599,  782,  780, 1674,
  781,    0,  783,    0,    0,    0, 1143,  610,  608,  599,
  609,    0,  611,    0,    0,  596,    0,    0,  599,    0,
  782,  780,    0,  781,    0,  783,    0,  784,  614,    0,
  584,  585,  586,  587,  588,  589,  590,  591,  596,    0,
  784,  599,    0,  782,  780, 1691,  781,  596,  783,  784,
    0,    0,  782,  780,    0,  781,    0,  783,    0,  612,
    0, 1147,  610,  608,  599,  609,    0,  611,    0,    0,
    0, 1677,  784,  599,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  614,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,  784,    0,    0,    0,    0,
    0,    0,    0,    0,  784,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  612,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,    0,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,    0,    0,
    0,    0,  584,  585,  586,  587,  588,  589,  590,  591,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,    0,    0,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,  584,  585,  586,  587,  588,
  589,  590,  591,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,    0,    0,    0,    0,    0,    0,    0,  584,  585,
  586,  587,  588,  589,  590,  591,    0,    0,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,  596,    0,
    0,    0,    0,  782,  780, 1695,  781,  596,  783,    0,
    0,    0,  782,  780, 1697,  781,    0,  783,    0, 1149,
  610,  608,    0,  609,  599,  611,    0,    0,    0,    0,
  596,    0,    0,  599,    0,  782,  780,    0,  781,    0,
  783,  614,  596,    0,    0,    0,    0,  594,  592,    0,
  593,    0,  595,    0,    0,  784,  599,    0,    0,    0,
    0,    0,    0,    0,  784,    0,    0,    0,  599,    0,
    0,    0,  612,    0,    0,    0,  584,  585,  586,  587,
  588,  589,  590,  591,    0,    0,    0,  784,    0,    0,
    0,  584,  585,  586,  587,  588,  589,  590,  591,  597,
    0,    0,    0,  584,  585,  586,  587,  588,  589,  590,
  591,    0,    0,    0, 1151,  610,  608,    0,  609,    0,
  611,    0, 1153,  610,  608,    0,  609,    0,  611,    0,
    0, 1155,  610,  608,    0,  609,  614,  611,    0,    0,
    0,    0,    0,    0,  614,    0, 1157,  610,  608,    0,
  609,    0,  611,  614,    0,    0,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,  612,  614,    0,
 1162,  610,  608,    0,  609,  612,  611,    0,    0,    0,
    0,    0,    0,    0,  612,    0,    0,    0,    0,    0,
    0,    0,  614,    0, 1164,  610,  608,    0,  609,  612,
  611,    0,    0,    0,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,  614,  610,  608, 1159,
  609,    0,  611,  612,    0,    0,    0,    0,    0,    0,
  584,  585,  586,  587,  588,  589,  590,  591,  614,  584,
  585,  586,  587,  588,  589,  590,  591,  612,    0, 1686,
    0,    0,  584,  585,  586,  587,  588,  589,  590,  591,
    0, 1171,  610,  608,    0,  609,    0,  611,    0,  612,
    0, 1173,  610,  608,    0,  609,    0,  611,    0,    0,
    0,    0,    0,  614,  584,  585,  586,  587,  588,  589,
  590,  591,    0,  614,    0,    0,    0,  584,  585,  586,
  587,  588,  589,  590,  591,    0,  584,  585,  586,  587,
  588,  589,  590,  591,  612,    0,  600,  601,  602,  603,
  604,  605,  606,  607,  612,    0,    0,    0,    0,  584,
  585,  586,  587,  588,  589,  590,  591,    0, 1175,  610,
  608,    0,  609,    0,  611,    0,    0,    0,    0,    0,
    0,    0,  584,  585,  586,  587,  588,  589,  590,  591,
  614,  584,  585,  586,  587,  588,  589,  590,  591,    0,
    0,  600,  601,  602,  603,  604,  605,  606,  607, 1185,
  610,  608,    0,  609,    0,  611,    0,    0, 1187,  610,
  608,  612,  609,    0,  611,    0, 1191,  610,  608,    0,
  609,  614,  611,    0,    0, 1193,  610,  608,    0,  609,
  614,  611,    0, 1195,  610,  608,    0,  609,  614,  611,
    0,    0, 1197,  610,  608,    0,  609,  614,  611,    0,
    0,    0,  612,    0,    0,  614,    0,    0,    0,    0,
    0,  612,    0,    0,  614,    0, 1336,  610,  608,  612,
  609,    0,  611,    0,    0, 1338,  610,  608,  612,  609,
    0,  611,    0, 1340,  610,  608,  612,  609,  614,  611,
    0,    0, 1342,  610,  608,  612,  609,  614,  611,    0,
 1344,  610,  608,    0,  609,  614,  611,    0,    0, 1346,
  610,  608,    0,  609,  614,  611,    0,    0,    0,  612,
    0,    0,  614,    0,    0,    0,    0,    0,  612,    0,
    0,  614,    0, 1566,  610,  608,  612,  609,    0,  611,
    0,    0, 1568,  610,  608,  612,  609,    0,  611,    0,
 1570,  610,  608,  612,  609,  614,  611,    0,    0, 1578,
  610,  608,  612,  609,  614,  611,    0, 1580,  610,  608,
    0,  609,  614,  611,    0,    0,    0,    0,    0,    0,
    0,  614,    0,    0,    0,    0,  612,    0,    0,  614,
    0,    0,    0,    0,    0,  612, 1582,  610,  608,    0,
  609,    0,  611,  612,    0,    0,    0,    0,    0,    0,
    0,    0,  612,    0,    0,    0,    0,    0,  614,    0,
  612,    0,  584,  585,  586,  587,  588,  589,  590,  591,
    0,  584,  585,  586,  587,  588,  589,  590,  591,  600,
  601,  602,  603,  604,  605,  606,  607,    0,    0,  612,
    0,    0,    0,    0,  584,  585,  586,  587,  588,  589,
  590,  591,    0,    0,    0,  353,  584,  585,  586,  587,
  588,  589,  590,  591, 1584,  610,  608,    0,  609,    0,
  611,    0,    0,    0,    0,    0,  354,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  614, 1586,  610,  608,
    0,  609,    0,  611,    0,    0,    0,  610,  608, 1166,
  609,    0,  611,    0,    0,    0,    0,    0,    0,  614,
    0,    0,    0,    0,    0,    0,    0,  612,  614,    0,
    0,    0,    0,    0,  600,  601,  602,  603,  604,  605,
  606,  607,  600,  601,  602,  603,  604,  605,  606,  607,
  612,  600,  601,  602,  603,  604,  605,  606,  607,  612,
  610,  608, 1177,  609,    0,  611,  600,  601,  602,  603,
  604,  605,  606,  607,    0,    0,    0,  610,  608, 1179,
  609,  614,  611,  355,    0,    0,    0,    0,    0,    0,
  600,  601,  602,  603,  604,  605,  606,  607,  614,    0,
    0,  610,  608, 1181,  609,    0,  611,    0,    0,    0,
    0,    0,  612,    0,  600,  601,  602,  603,  604,  605,
  606,  607,  614,  610,  608, 1183,  609,    0,  611,  612,
    0,    0,    0,    0,    0,    0,  600,  601,  602,  603,
  604,  605,  606,  607,  614,    0,    0,  610,  608, 1189,
  609,    0,  611,  612,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  614,    0,
    0,    0,    0,    0,    0,  612,    0,    0,    0,    0,
    0,  600,  601,  602,  603,  604,  605,  606,  607,    0,
    0,  600,  601,  602,  603,  604,  605,  606,  607,  612,
    0,    0,    0,    0,    0,    0,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1426,    0,    0,    0,    0,    0,  600,  601,
  602,  603,  604,  605,  606,  607,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  600,
  601,  602,  603,  604,  605,  606,  607,    0,  600,  601,
  602,  603,  604,  605,  606,  607,  600,  601,  602,  603,
  604,  605,  606,  607,    0,  600,  601,  602,  603,  604,
  605,  606,  607,  600,  601,  602,  603,  604,  605,  606,
  607,    0,  600,  601,  602,  603,  604,  605,  606,  607,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  600,  601,  602,  603,
  604,  605,  606,  607,    0,  600,  601,  602,  603,  604,
  605,  606,  607,  600,  601,  602,  603,  604,  605,  606,
  607,    0,  600,  601,  602,  603,  604,  605,  606,  607,
  600,  601,  602,  603,  604,  605,  606,  607,    0,  600,
  601,  602,  603,  604,  605,  606,  607,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  600,  601,  602,  603,  604,  605,  606,
  607,    0,  600,  601,  602,  603,  604,  605,  606,  607,
  600,  601,  602,  603,  604,  605,  606,  607,    0,  600,
  601,  602,  603,  604,  605,  606,  607,  600,  601,  602,
  603,  604,  605,  606,  607,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  600,  601,  602,  603,
  604,  605,  606,  607,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1088,    0, 1089, 1090,    0,    0,    0,
    0,    0,    0,    0,  600,  601,  602,  603,  604,  605,
  606,  607,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1091,    0,  600,  601,  602,
  603,  604,  605,  606,  607,    0,  600,  601,  602,  603,
  604,  605,  606,  607,    0,    0,    0,    0, 1092,    0,
    0,    0,    0,    0,    0,    0,  472,  473,  244,    0,
 1093,    0,    0,    0,    0,    0, 1094,  474,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  600,
  601,  602,  603,  604,  605,  606,  607,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  600,  601,  602,  603,
  604,  605,  606,  607,    0,    0,    0,    0,    0, 1095,
 1111,    0, 1112,    0,    0,    0,    0,    0,    0,  475,
  600,  601,  602,  603,  604,  605,  606,  607,    0, 1096,
    0,    0,    0,    0,    0,    0, 1113, 1097,    0,    0,
 1098, 1114,  600,  601,  602,  603,  604,  605,  606,  607,
  238, 1099, 1100,  239, 1101,    0, 1102,    0,    0,    0,
  245,    0,    0,    0,    0,    0,  600,  601,  602,  603,
  604,  605,  606,  607,    0,    0, 1115,    0, 1116,    0,
    0,    0,  246,    0,    0,    0,    0,    0,    0,    0,
 1117,    0,    0,    0,    0,  247,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1118, 1103,    0,
 1119,    0,    0,    0,    0, 1104,    0,    0,    0,    0,
 1120,    0,    0,    0, 1121,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1105,
    0,  238,    0,    0,  239, 1122,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1123, 1124,    0,  248,  249,  250,
  251,    0,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,    0,  621,
  622,    0,    0,    0,    0,    0,  469,  469, 1125,    0,
 1126,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  623, 1127, 1128,    0,    0, 1129,  624,  469,
    0,    0,    0,    0,  625,  469,  626,    0,    0,    0,
 1130,  469,    0,  469, 1131,    0,    0,    0,    0,    0,
    0, 1106,    0,    0,    0,  627,    0,    0,    0,  468,
  468,    0,  469,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  628,    0,  629,    0,
    0,    0,  468,  469,    0,  469,    0,    0,  468,    0,
  630,    0,    0,    0,  468,    0,  468,  469,    0,  238,
    0,    0,  239,    0,    0,    0,  469,    0,    0,  469,
    0,    0,    0,    0,    0,  468,    0,    0,    0,    0,
    0,    0,  631,    0,    0,    0,    0,    0,    0,  469,
    0,    0,    0,    0,    0,    0,  468,    0,  468,    0,
    0,    0, 1132,    0,    0,    0,    0,    0,    0,    0,
  468,    0,    0,    0,    0,    0,    0,  632,  633,  468,
    0,    0,  468,    0,  469,  469,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  634,
    0,    0,  468,    0,    0,    0,  469,    0,  635,    0,
    0,    0,    0,    0,    0,  469,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  468,  468,    0,
    0,    0,  636,    0,    0,    0,    0,    0,    0,  469,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  468,
    0,    0,    0,    0,    0,    0,    0,    0,  468,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  468,
};
short yycheck[] = {                                      52,
    0,   10,  473,  376,  503,  476,   10,   60,  108,  309,
  374,  506,  385,  374,   10,  848,  390,  323,  489,  344,
   10,   10,  626,  348,  390,  391,  336,  337,   81,  348,
  455,  131,   41,   37,  324,   44,  512,   41,   42,   43,
   44,   45,  537,   47,  324,   41,  324,   40,   44,   58,
  549,  357,   41,  338,   58,   44,  324,  324,  383,   63,
  324,  486,   58,   63,   10,  360,   46,  283,  284,   58,
    0,   46,  544,   10,   74,  308,  139,   37,   46,  283,
  284,   61,   10,  582,   10,  148,   61,   10,  456,   40,
   94,   37,   92,   93,  462,   41,   42,   43,   44,   45,
  100,   47,  427,   63,   41,   42,   43,   44,   45,  419,
   47,  327,   58,   41,   37,   41,   44,   63,   44,   42,
   43,   58,   45,   91,   47,  125,   63,  342,  128,  503,
   58,   10,   58,  133,   94,  135,  348,  503,  504,  424,
   63,  460,  343,  443,  639,  342,  446,  348,   94,  298,
  299,  300,  301,  302,  303,  304,  305,   94,   40,  159,
  160,  161,   41,  639,   43,   44,   45,  639,  168,  344,
  465,   94,  536,  537,  407,  536,  409,  399,   41,   58,
  490,  506,  383,   46,  417,  360,  419,  390,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,  202,   10,  419,  809,  206,  207,  208,  209,
  210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
 1053,  454,  419,  513,  543,  535,  427,  348,  406,  159,
  160,  516,  390,  513,   41,  513,  448,   44,  168,  451,
  525,  360,   63,  424,   61,  513,  513,  448,  460,  513,
  451,   58,   46,  419,  451,  338,  437,  490,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,  202,   94,   91,  490,  206,  207,  208,  209,
  210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
  465,  513,  344,  490,  390,  344,   10,   91,   61,  348,
  503,  542,   10,  544,  390,  538,  348,  390,  360,   40,
  448,   63,    0,  451,   40,  315,  316,   40,  540,   40,
  639,   63,   46,  323,  490,  503,  507,   41,   91,  448,
   44,  543,  451,   41,  383,  332,   44,   61,   10,  460,
  393,  424,   94,  396,   58,  503,  465,  525,  529,  639,
   58,   40,   94, 1101,  503,  298,  299,  300,  301,  302,
  303,  304,  305,   10,  546,   37,  651,   91,  639,   41,
   42,   43,   44,   45, 1122,   47,  348,   10,  427,   40,
   42,   43,  362,   45,   40,   47,   58,  362,   40,   40,
   37,   63,  573,  575,   41,   42,   43,   44,   45,   40,
   47,   63,   10,  445,   37,   40,  639,  503,   40,   42,
   43,   58,   45,  465,   47,   40,   63,  503,  460,  416,
  503,   40,   94,  589,  590,  591,  592,  427,  428,   37,
   63,   40,   94,   41,   42,   43,   44,   45,  639,   47,
   40,  421,  525,   10,  639, 1278,  421,   94,  428,   40,
   58,  448,   40,  428,  451,   63,   40,  506,  425,  459,
  427,   94,   40,  298,  299,  300,  301,  302,  303,  304,
  305,  159,  160,  445,   41,   40,   43,   44,   45,  479,
  168,  448,   40,  483,  451,   40,   94,  467,  460,  421,
  490,   58,  467,  425,   42,  427,   40,   40,  498,   47,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199, 1116,  201,  202,   63,   40,   10,  206,  207,
  208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  529,  530,   40,  635,   40,  283,  631,  632,
  633,  634,  542,  543,  544,  545,   94,  348,   41,  549,
   43,   44,   45,  484,  484,   40,  556,  557,  344,  491,
  503,  639,  492,  639,  639,   58,   40,   10,  651,  315,
  316,  344,   10,  344,  356,   40,  576,  577,  578,  579,
  580,  581,  639,  329,  584,  585,  586,  587,  588,  589,
  590,  591,  592,  593,  594,  595,  596,  597,   41,  599,
  554,   44,  639,   41,  638,  537,   44,  427,  608,  609,
  610,  611,  612,   46,  344,   58,   40,  544,  618,  619,
   58,  639,  344,  503,  525,   40,  556,   40,   61,   40,
  630,   40,  641,  642,  634,   40,  636,  641,  642,  643,
  644,  645,  646,  647,  648,  641,  576,  577,  578,  579,
  580,  581,  641,  642,   40,   40,   10,   10,   91, 1263,
   10,   10,  592,  593,  594,  595,   10,  597,  503,   10,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,   40,  614,   40,   10,   10,  618,   10,
  639,  639,  639,   44,   46,  641,  642,  643,  644,  645,
  646,  647,  648,  639,  641,  642,  643,  644,  645,  646,
  647,  648,   40,  641,  642,  641,  642,  348,  641,  642,
  643,  644,  645,  646,  647,  648,  506,  727,  728,  729,
  730,  731,  732,  733,  734,  735,  736,  737,  738,  739,
  740,  741,  639,  743,  744,  745,  746,  747,  748,  749,
  750,  751,  752,  753,  754,  755,  756,  503,  504,  344,
   40,  639,  641,  642,  643,  644,  645,  646,  647,  648,
  770,  639,  639,  773,  774,  775,  776,  777,  778,  639,
  780,  781,  782,  783,  784,  785,  786,   40,   40,  385,
   40,   40,   10,   40,  425,   40,  427,   40,  798, 1270,
   40,   40,   40,  549,  550,   37,   40,   40,  639,   41,
   42,   43,  812,   45,   40,   47,   10,  448,   40,   37,
  451,   40,   46,   41,   42,   43,   44,   45,   40,   47,
   40,   63,   40,   40,  641,  642,  582,  583,  768,  769,
   58,  587,  588,   37,   40,   63,  322,   41,   42,   43,
   44,   45,  448,   47,   40,  451,  343,   40,   40,   40,
   40,  348,   94,   40,   58,  865,   40,   40,  556,   63,
  639,  639,  348,  873,   46,  471,   94,   42,   43,  879,
   45,   40,   47,   46,   40,   91,   40,   40,  576,  577,
  578,  579,  580,  581,   40,   40,  383,   44,   63,   91,
   94,  421,   46,  506,  592,  593,  594,  595,  331,  597,
  534,  639,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  348,  614,  641,  642,   94,
  618,   63,  932,  641,  642,  639,  639,  937,  425,  639,
  427,  537,  506,  503,  420,  348,  639,   79,  639,  425,
   82,  427,   84,  639,  377,  431,  506,  504,  554,  959,
   92,   93,  639,  504,  506,  503,   98,  499,  968,  641,
  642,  643,  644,  645,  646,  647,  648,  977,  499,  111,
  642,  643,  644,  645,  646,  647,  648,  987,  348,  639,
  506,  639,   46,  125,  641,  642,  643,  644,  645,  646,
  647,  648,  425,  639,  427,  639,  346, 1060,  641,  642,
  643,  644,  645,  646,  647,  648,  639,  377,  639,  639,
  534,  153,  154,  155,  500,  448,  546,  547,  451,  161,
  344,  534,  639,  641,  642,  643,  644,  645,  646,  647,
  648,  528,  382,  344,  639,  177,  639,  977,  344,  979,
  390,  503,  639,  185,  344,  575,  576,  577,  578,  579,
  580,  581, 1062,  639,  639,  425, 1066,  427,  639,  639,
  639,  639,  506,  639,  641,  642,  643,  644,  645,  646,
  647,  648,  639,  639,  537,  639,  639,  639,  448, 1089,
 1090,  451,   40,  639,  639,  503,  228, 1097, 1098, 1099,
 1100,   46,  639,  235,  639,  639,  639,  344,  448,  639,
  639,  451,  639,  639,  537,   46,   37,  639,   41,   63,
  639,   42,   43,   63,   45,  503,   47,  639, 1128, 1129,
   37,  639,  639,   10,  639,   42,   43,   44,   45,  639,
   47,  639,   63,  639, 1144,  639,  344,  639,  641,  642,
  643,  644,  645,  646,  647,  648,   63,  639, 1158, 1159,
   37,  639,  502,   44,   41,   42,   43,   44,   45,  639,
   47,   10,   46,   94,  503,  639, 1176, 1177, 1178,  639,
 1180,   58, 1182,  639,  639,  639,   63,   94, 1188, 1189,
   44,  503,  639,  639,  639,  639,  503,  639,   37,  639,
   10,  503,   41,   42,   43,   44,   45,  639,   47,   10,
  639,  639,   44,   37,  639, 1145,   44,   94,   42,   58,
  639,  343,  344,   47,   63,  639,  348,   37, 1158, 1159,
   44,   41,   42,   43,   44,   45,   37,   47,  639,   63,
   41,   42,   43,   44,   45,  639,   47,  639,   58, 1179,
  639, 1181,  639, 1183,  386,   94,  639,   58, 1188, 1189,
  639,  383,   63,  395,  639,  397,  344,  639,  639,  390,
   94, 1271,   44,  503,  406, 1275,  343,   44,  376,  344,
  503,  348,  344,  415,   94,  344,   61,   10,   44,  344,
 1290,   46,  414,   94, 1294,  417,  394,   61,   10, 1299,
 1300, 1301,  400,  401, 1304,  427, 1306, 1307,  639, 1309,
  442,  506,  639, 1313,   37,   44,  383,   10,   41,   42,
   43,   44,   45,  639,   47,  344,  393, 1327, 1328,   41,
  639,   43,   44,   45,  639,   58,  344,   44,  436,  437,
   63,  639,  639, 1273,  466,  639,   58, 1347,   41,   42,
   43,   44,   45,  639,   47,   10,  639,  489,  425,   44,
  427,  639,  639,  639,  639,   58,  639,  639,   44,  639,
   63,   94, 1372,  376,  639,  639,  506, 1307,  476,  639,
  478,  448,   37,  639,  451,  517,   41,   42,   43,   44,
   45,  394,   47,  639,  526,  639,   44,  400,  401,  506,
   44,   94,  344,   58,  639,  344,   41,   46,  639,  641,
  642,  643,  644,  645,  646,  647,  648,   44, 1348, 1419,
  534,   44,  639,  641,  642,  643,  644,  645,  646,  647,
  648,   10,  421,  436,  437,   37,  534,  639,   93,   94,
   42,   43,  639,   45,  534,   47,  639,  641,  642,  643,
  644,  645,  646,  647,  648,  639,  503, 1145,   37,  385,
  639,   63,   41,   42,   43,   44,   45,   61,   47,  639,
 1158, 1159,  639,  476,  348,  478,   37,  639,  639,   58,
 1480,   42,   43, 1483,   45, 1485,   47, 1487,  639,  639,
  639, 1179,   94, 1181, 1494, 1183,  639,  639,   37,  639,
 1188, 1189,   63,   42,   43,   44,   45, 1507,   47,   10,
  639,  639,  639,  639,  639,  647,  639,  649,  650,  639,
  639,  639,   37,   46,   63,   61,  639,   42,  639,  639,
 1530, 1531,   47,   94,  639, 1535,   37, 1537,  639,  528,
 1540,   42,   43,  639,   45,   44,   47,  639,   63,  344,
  424,  425,  639,  427, 1484,   94,  639,  546,  547,  639,
  639,   41,   63,  639,  639,  639,   41,   44,   44,  639,
  639,  390,   41,  639,  448, 1575, 1576,  451,   44,   94,
   41,  344,   46,  390,  344,   41,  575,  576,  577,  578,
  579,  580,  581,   94,  639,   41,  639,  639,  639,   41,
 1600,   44, 1602,  639, 1604, 1605, 1536, 1607,  546,  547,
 1610,   46, 1612,  503,   46,   41,   61,  344, 1618, 1307,
   44,  639,  639,  503,  503,   61,  281,  639,  283,  284,
  639,   44,   41, 1633,   41, 1635,   44,  575,  576,  577,
  578,  579,  580,  581,  639,  639, 1646,   41,    0,   10,
 1650,   10, 1652, 1653,   10,   10, 1656,   10,  313,   10,
 1348,   10,  317,  537,  319,   10,   91,   10,   10, 1669,
   10, 1671, 1602,   10,   10,   10,   10,   10, 1678,   10,
  554,  336,   10,   10,   10,   10, 1686,   10,  343,   10,
   10, 1691,   10,  348,   10, 1695,   10, 1697,   10,  354,
   37,   10,   10,   10,   41,   42,   43,   44,   45,   10,
   47,   10,   10,   10,   10,   10,  848,   10,   10,   10,
   10,   58,  643,  644,  645,  646,  647,  648,  383,   10,
  385,   10,   10,   10,  641,  642,  643,  644,  645,  646,
  647,  648,  397,   10,   10,   10,   10,   10,   10,   10,
   10,   10,  407,   10,   10,   10,   93,   94,   10,  414,
   10,   10,  417,   10,  641,  642,  643,  644,  645,  646,
  647,  648,  427,   10,   10,   41,  431,   43,   44,   45,
  435,   10,   10,  438, 1118,  468,  569, 1603,  406, 1109,
   -1,   85,   58,  448,  449,  450,  451,  452,   85,  454,
   -1, 1134,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,  471,  472,   -1,   -1,
   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   37,
  505,  506,  507,   41,   42,   43,   44,   45,  513,   47,
   -1,   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,
   58,   -1,   -1,   -1,  529,   -1,   42,   43,   -1,   45,
   -1,   47,  537,   -1,   -1,   -1,  541,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1, 1602,   -1,   -1, 1049,  641,  642,
  643,  644,  645,  646,  647,  648,   46,   -1,   94,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  281,   -1,  283,  284,  641,  642,
  643,  644,  645,  646,  647,  648, 1088,   42,   43, 1091,
   45,   -1,   47,   -1,   -1, 1097, 1098,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   -1,   -1,  313, 1109,   63,   -1,
  317,   -1,  319,   -1,  639,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   10,   -1,   -1,   -1,  336,
   -1,   -1, 1134,   -1,   -1,   -1,  343,   -1,   -1,   94,
   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   37,   -1,   -1,   -1,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   -1,   -1,  383,   -1,  385,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  397,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
  407,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,   94,
  417,  642,  643,  644,  645,  646,  647,  648,   -1,   10,
  427,   -1,   -1,  281,  431,  283,  284,   -1,  435,   -1,
   -1,  438,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  448,  449,  450,  451,  452,   37,  454,   -1,   -1,
   41,   42,   43,   44,   45,  313,   47,   -1,   -1,  317,
   -1,  319,   -1,   -1,  471,  472,   -1,   58, 1270,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,  336,   -1,
   -1,   -1,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
  348,   -1,   -1,  283,   -1,   -1,  354,   -1,  505,  506,
  507,   -1,   93,   -1,   -1,   -1,  513,   -1,   -1,   -1,
   -1,   -1,   -1,  520,  521,   -1,   -1,  524,   -1,   -1,
   -1,   -1,  529,   -1,   -1,  383,   -1,  385,   -1,   -1,
  537,   -1,   -1,   -1,  541,  325,   -1,   -1,   -1,  397,
  335,   -1,  332,   -1,   -1,   -1,   -1,   -1,   -1,  407,
   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,  417,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,  435,   -1,   -1,
  438,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  379,
  448,  449,  450,  451,  452,   37,  454, 1399,   -1,   41,
   42,   43,   44,   45, 1406,   47,   -1,   -1,  398,   -1,
   -1,   -1,   -1,  471,  472,   -1,   58,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,   -1,   -1,
   -1,   -1,  639,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,  505,  506,  507,
   -1,   93,  447,   -1,   -1,  513,   -1,   -1,  448,   -1,
   -1,  451,  520,  521,   -1,   -1,  524,   10,   -1,   -1,
   -1,  529,   -1,   -1,  469,   -1,   -1,   -1,   -1,  537,
   -1,   -1,   -1,  541,   -1,   -1,   -1,  482,   -1,   -1,
  281,   -1,  283,  284,   -1,   -1,   -1,   -1,   41,   42,
   43,   44,   45,   -1,   47,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  504,   58,   -1,   -1,   -1,   -1,
   63,   -1,  313,   -1,   -1,   -1,  317,  517,  319,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  336,   -1,  537,   -1,   -1,
   -1,   94,  343,   -1,   -1,   -1,   -1,  348,   -1,  554,
  555,  556,  557,  354,  559,  560,  561,  562,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
   -1,  639,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  383,   -1,  385,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  397,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  407,   10,   -1,   -1,
   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   10,  427,   -1,   -1,  281,
  431,  283,  284,   -1,  435,   -1,   -1,  438,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,  448,  449,  450,
  451,  452,   37,  454,   -1,   58,   41,   42,   43,   44,
   45,  313,   47,   -1,   -1,  317,   -1,  319,   -1,   -1,
  471,  472,   -1,   58,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  336,   -1,   -1,   -1,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,
   -1,   -1,  354,   -1,  505,  506,  507,   -1,   93,   -1,
   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,  520,
  521,   -1,   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,
   -1,  383,   -1,  385,   -1,   -1,  537,   -1,   -1,   -1,
  541,   -1,   -1,   -1,   -1,  397,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  407,   -1,   -1,   10,   -1,
   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,  435,   -1,   37,  438,   -1,   -1,   41,
   42,   43,   44,   45,   -1,   47,  448,  449,  450,  451,
  452,   -1,  454,   -1,   -1,   41,   58,   43,   44,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  471,
  472,   -1,   58,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  639,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,  505,  506,  507,   -1,   93,   -1,   -1,
   10,  513,   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,
   10,   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,   -1,
   -1,   10,   -1,   -1,   -1,  537,   -1,   -1,   -1,  541,
   -1,   41,   42,   43,   44,   45,  281,   47,  283,  284,
   -1,   41,   42,   43,   44,   45,   -1,   47,   58,   -1,
   -1,   -1,   41,   63,   43,   44,   45,   -1,   58,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  313,   58,
   -1,   -1,  317,   10,  319,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   10,
   -1,  336,   -1,   -1,   94,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,  348,   41,   42,   43,   44,   45,  354,
   47,   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   58,   43,   44,   45,   -1,   10,  639,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   58,  383,   37,
  385,   10,   -1,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,  397,   37,   -1,   -1,   -1,   94,   42,   43,
   58,   45,  407,   47,   -1,   -1,   10,   -1,   37,  414,
   -1,   -1,  417,   42,   43,   -1,   45,   -1,   47,   63,
   -1,   -1,  427,   10,   -1,  281,  431,  283,  284,   -1,
  435,   -1,   -1,  438,   63,   -1,   -1,   41,   -1,   43,
   44,   45,   -1,  448,  449,  450,  451,  452,   -1,  454,
   94,   10,   -1,   -1,   58,   42,   43,  313,   45,   -1,
   47,  317,   10,  319,   -1,   94,  471,  472,  641,  642,
  643,  644,  645,  646,  647,  648,   63,   -1,   -1,   -1,
  336,   -1,   41,   42,   43,   44,   45,  343,   47,   93,
   -1,   -1,  348,   41,   -1,   43,   44,   45,  354,   58,
  505,  506,  507,   -1,   -1,   -1,   -1,   94,  513,   -1,
   58,   10,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,
   -1,   -1,   -1,   -1,  529,   -1,   -1,  383,   -1,  385,
   -1,   -1,  537,   10,   -1,   -1,  541,   -1,   -1,   -1,
   -1,  397,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,  407,   10,   -1,   -1,   -1,   -1,   -1,  414,   58,
   -1,  417,   -1,   -1,   41,   42,   43,   44,   45,   -1,
   47,  427,   -1,   -1,   10,  431,   -1,   -1,   -1,  435,
   -1,   58,  438,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,   -1,
   58,   37,   -1,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,  471,  472,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,  639,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  505,
  506,  507,   -1,   -1,   -1,   10,   -1,  513,   94,   -1,
   -1,   -1,   -1,   10,  520,  521,   -1,   -1,  524,   -1,
   -1,   -1,   -1,  529,   -1,   -1,   -1,  281,   -1,  283,
  284,  537,   -1,   -1,   10,  541,   41,   42,   43,   44,
   45,   -1,   47,   10,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   58,   -1,   -1,   -1,   -1,   -1,  313,
   -1,   58,   -1,  317,   10,  319,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   41,   42,   43,   44,   45,   -1,
   47,   -1,  336,   -1,   -1,   -1,   -1,   63,   -1,  343,
   -1,   58,   -1,   -1,  348,   41,   42,   43,   44,   45,
  354,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   -1,   -1,   10,   -1,   -1,   94,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,  383,
   -1,  385,   10,  639,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,  397,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,  407,   -1,   10,   -1,   -1,   -1,   -1,
  414,   -1,   -1,  417,   42,   43,   -1,   45,   63,   47,
   -1,   -1,   -1,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,  435,   -1,   -1,  438,   63,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,  448,  449,  450,  451,  452,   94,
  454,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,  471,  472,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   94,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  505,  506,  507,   -1,   -1,   -1,   -1,   -1,  513,
   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,
  524,   -1,   -1,   -1,   -1,  529,   -1,   -1,   -1,   -1,
   -1,  332,   -1,  537,   -1,   -1,   -1,  541,  339,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   10,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   63,   -1,  395,  396,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  432,  433,  434,   -1,  639,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   37,   -1,   -1,  468,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   63,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  510,
   -1,   -1,   -1,   -1,   -1,   -1,  517,  518,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,  554,   -1,   -1,   -1,  558,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   10,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   41,   -1,   -1,   44,   -1,   -1,   63,
   -1,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   58,
   -1,   -1,   -1,   -1,   -1,   -1,  317,   -1,  319,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,  641,  642,  643,  644,  645,  646,
  647,  648,  343,   -1,   93,   -1,   -1,  348,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  383,   -1,  385,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  397,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,  448,   -1,   -1,
  451,  452,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  471,  472,   -1,   -1,   10,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   37,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,  281,   47,  283,  284,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  505,   41,  507,   -1,   44,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  520,
  521,   -1,   58,  524,   -1,  313,   -1,   -1,   -1,  317,
   -1,  319,  281,   -1,  283,  284,  537,   -1,   -1,   -1,
  541,   94,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,
   -1,   -1,   -1,   -1,   -1,  343,   -1,   93,   -1,   -1,
  348,   -1,   -1,   -1,  313,   -1,  354,   -1,  317,   -1,
  319,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,
   -1,   -1,   -1,   -1,  343,  383,   -1,  385,   -1,  348,
   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,  397,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  407,
   -1,   -1,   -1,   10,   -1,   -1,  414,   -1,   -1,  417,
   -1,   -1,   -1,   -1,  383,   -1,  385,   -1,  639,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,  435,  397,   -1,
  438,   -1,   -1,   -1,   41,   -1,   -1,   44,  407,   -1,
  448,  449,  450,  451,  452,  414,  454,   -1,  417,   -1,
   -1,   58,   -1,   -1,   -1,   -1,   -1,   -1,  427,   -1,
   -1,   -1,  431,  471,  472,   -1,  435,   -1,   -1,  438,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,   -1,  454,   93,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  505,  506,  507,
   -1,   -1,  471,  472,   -1,  513,   -1,   -1,   -1,   -1,
   -1,   -1,  520,  521,   -1,   -1,  524,   -1,   -1,   -1,
   -1,  529,   -1,   -1,   -1,  281,   -1,  283,  284,  537,
   -1,   -1,   -1,  541,   -1,   -1,  505,  506,  507,   -1,
   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,
   -1,  520,  521,   -1,   -1,  524,   -1,  313,   -1,   -1,
  529,  317,   -1,  319,   -1,   -1,   -1,   -1,  537,   -1,
   -1,   -1,  541,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  336,   -1,   -1,   37,   -1,   -1,   -1,  343,   42,   43,
   44,   45,  348,   47,   -1,   -1,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   10,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,  383,   -1,  385,
   -1,  639,   -1,  641,  642,   -1,   -1,   -1,   -1,   -1,
   94,  397,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,
   44,  407,   -1,   -1,   -1,   10,   -1,   -1,  414,   -1,
   -1,  417,   -1,   -1,   58,   -1,   -1,   -1,   -1,   -1,
  639,  427,  641,  642,  281,  431,  283,  284,   -1,  435,
   -1,   -1,  438,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,   93,
   -1,   -1,   -1,   58,   42,   43,  313,   45,   -1,   47,
  317,   -1,  319,   -1,   -1,  471,  472,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,  336,
   -1,   -1,   -1,   -1,   -1,   -1,  343,   -1,   93,   -1,
   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,   -1,  505,
  506,  507,   -1,   -1,   -1,   -1,   94,  513,   -1,   -1,
   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,  524,   -1,
   -1,   -1,   -1,  529,   -1,   -1,  383,   -1,  385,   -1,
   -1,  537,   -1,   -1,   -1,  541,   -1,   -1,   -1,   -1,
  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  407,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,
  417,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,  435,   10,
   -1,  438,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,   -1,  454,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,  471,  472,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   58,   -1,   -1,
   -1,   -1,   -1,  639,   -1,  641,  642,  281,   -1,  283,
  284,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  505,  506,
  507,   -1,   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,
   -1,   -1,   93,  520,  521,   -1,   -1,  524,   -1,  313,
   -1,   -1,  529,  317,   -1,  319,  281,   -1,  283,  284,
  537,   -1,   -1,   -1,  541,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,  313,   -1,
  354,   -1,  317,   -1,  319,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,   -1,   -1,   -1,   -1,   -1,   -1,  343,  383,
   10,  385,   -1,  348,   -1,   -1,   -1,   -1,   -1,  354,
   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  407,   -1,   -1,   -1,   -1,   -1,   -1,
  414,   41,   -1,  417,   44,   -1,   -1,   -1,  383,   -1,
  385,   -1,  639,  427,  641,  642,   -1,  431,   58,   -1,
   -1,  435,  397,   -1,  438,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  407,   -1,  448,  449,  450,  451,  452,  414,
  454,   -1,  417,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  427,   93,   -1,   -1,  431,  471,  472,   -1,
  435,   -1,   -1,  438,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,   -1,  454,
  281,   -1,  283,  284,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  505,  506,  507,   -1,   -1,  471,  472,   -1,  513,
   -1,   -1,   -1,   -1,   -1,   -1,  520,  521,   -1,   -1,
  524,   -1,  313,   10,   -1,  529,  317,   -1,  319,   -1,
   -1,   -1,   -1,  537,   -1,   -1,   -1,  541,   -1,   -1,
  505,  506,  507,   -1,   -1,  336,   -1,   -1,  513,   -1,
   -1,   -1,  343,   -1,   -1,  520,  521,  348,   -1,  524,
   -1,   -1,   10,  354,  529,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  537,   -1,   -1,   -1,  541,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  383,   41,  385,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  397,   37,   -1,   -1,
   58,   -1,   42,   43,   44,   45,  407,   47,   -1,   -1,
   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,   -1,
   -1,   -1,   -1,   63,   -1,  639,  427,  641,  642,   -1,
  431,   -1,   -1,   -1,  435,   93,   -1,  438,   -1,   -1,
   -1,  281,   -1,  283,  284,   -1,   -1,  448,  449,  450,
  451,  452,   -1,  454,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  639,   -1,  641,  642,   -1,   -1,
  471,  472,   -1,  313,   -1,   -1,   -1,  317,   -1,  319,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   10,   -1,   -1,   -1,  336,   -1,   -1,   -1,
   -1,   -1,   -1,  343,  505,  506,  507,   -1,  348,   -1,
   -1,   -1,  513,   -1,  354,   -1,   -1,   -1,   -1,  520,
  521,   -1,   -1,  524,   -1,   -1,   -1,   -1,  529,   -1,
   -1,   10,   -1,   -1,   -1,   -1,  537,   -1,   -1,   -1,
  541,   -1,   -1,  383,   -1,  385,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,   -1,
   -1,   -1,   -1,   -1,  414,   -1,   -1,  417,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,  435,   -1,   -1,  438,   -1,
   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,   -1,  454,   41,   42,   43,   -1,   45,
  317,   47,  319,  281,   -1,  283,  284,   -1,   -1,   -1,
   -1,  471,  472,   -1,   -1,   -1,   -1,   63,  639,   -1,
  641,  642,   10,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,  348,   -1,   -1,   -1,  313,   -1,   -1,   -1,  317,
   -1,  319,   -1,   -1,   -1,  505,  506,  507,   94,   -1,
   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,  336,   -1,
  520,  521,   -1,   -1,  524,  343,  383,   -1,  385,  529,
  348,   -1,   -1,   -1,   -1,   -1,  354,  537,   -1,   -1,
  397,  541,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   10,   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,
  417,   -1,   -1,   -1,   -1,  383,   -1,  385,   -1,   -1,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,  397,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,
   10,  448,   -1,   -1,  451,  452,  414,   -1,   -1,  417,
   -1,   -1,   37,  281,   -1,  283,  284,   42,   43,  427,
   45,   -1,   47,  431,  471,  472,   -1,  435,   -1,   -1,
  438,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,
  448,  449,  450,  451,  452,  313,  454,   -1,   -1,  639,
   -1,  641,  281,   -1,  283,  284,   -1,   -1,  505,   -1,
  507,   -1,   -1,  471,  472,   -1,   -1,   -1,  336,   94,
   -1,   -1,   -1,  520,  521,   -1,   -1,  524,   -1,   -1,
  348,   -1,   -1,   -1,  313,   -1,  354,   -1,   -1,   -1,
  537,   -1,   -1,   -1,  541,   -1,   -1,  505,  506,  507,
   -1,   -1,   -1,   -1,   -1,  513,   -1,  336,   10,   -1,
   -1,   -1,  520,  521,   -1,   -1,  524,   -1,   -1,  348,
   -1,  529,   -1,   -1,  281,  354,  283,  284,   -1,  537,
   -1,   -1,   -1,  541,   -1,   -1,   -1,   -1,   -1,  407,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  313,   -1,   -1,  427,
   -1,   -1,   -1,  281,   -1,  283,  284,  435,   -1,   -1,
  438,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,  336,
  448,  449,  450,  451,  452,   -1,  454,   -1,   -1,   -1,
   -1,  348,  639,   -1,   -1,  313,   -1,  354,  427,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  435,   -1,   -1,  438,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,  448,
  449,  450,  451,  452,   -1,  454,   -1,   -1,   -1,   -1,
  348,  639,  281,   -1,  283,  284,  354,   -1,  506,   -1,
   -1,   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,
  407,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,  313,   -1,   -1,   -1,   -1,  537,
  427,  281,   -1,  283,  284,   -1,   -1,  506,  435,   -1,
   -1,  438,   -1,   -1,  513,   -1,   -1,  336,   -1,  407,
   -1,  448,  449,  450,  451,  452,   -1,  454,   -1,  348,
   -1,   -1,   -1,  313,   -1,  354,   -1,   -1,  537,  427,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  435,   -1,   -1,
  438,   -1,   -1,   -1,   -1,   -1,  336,   -1,   -1,   -1,
  448,  449,  450,  451,  452,   37,  454,   -1,  348,   -1,
   42,   43,   44,   45,  354,   47,   -1,   -1,   -1,  506,
   -1,   -1,   -1,   -1,   -1,   -1,  513,   -1,  407,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   -1,  639,   42,   43,   44,   45,   -1,   47,  427,  281,
  537,  283,  284,   -1,   -1,   -1,  435,   -1,  506,  438,
   -1,   -1,   94,   63,   -1,  513,   -1,  407,   -1,  448,
  449,  450,  451,  452,   -1,  454,   -1,   -1,   -1,   -1,
  639,  313,   -1,   -1,   -1,   -1,   -1,  427,   -1,  537,
   -1,   -1,   40,   -1,   94,  435,   -1,   45,  438,   -1,
   -1,   -1,   -1,   -1,  336,   -1,   -1,   -1,  448,  449,
  450,  451,  452,   -1,  454,   -1,  348,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,   -1,   -1,  506,   -1,   -1,
   -1,   -1,   -1,   -1,  513,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  639,   -1,   -1,   -1,   -1,   37,  537,   -1,
   -1,   -1,   42,   43,   44,   45,  506,   47,   -1,   -1,
   -1,   -1,   37,  513,   -1,  407,   41,   42,   43,   -1,
   45,   -1,   47,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  639,   -1,   -1,   -1,  427,   -1,  537,   63,   -1,
   -1,   -1,   -1,  435,   -1,   37,  438,   -1,   -1,   41,
   42,   43,   -1,   45,   94,   47,  448,  449,  450,  451,
  452,   -1,  454,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
  639,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  506,   63,   -1,   -1,   -1,   -1,
   -1,  513,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  639,
   -1,   -1,   -1,   -1,   -1,  537,   94,   -1,  256,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
   -1,   -1,  310,  311,   -1,   -1,   -1,  315,  316,   -1,
   -1,   -1,   -1,  321,   -1,   -1,  324,  325,   -1,   -1,
   -1,  329,  330,  331,   -1,   -1,  334,   -1,   -1,   -1,
  338,   -1,  340,   -1,   -1,   -1,   -1,  345,   -1,  347,
  348,   -1,  350,  351,   -1,   -1,  354,  639,  356,   -1,
  358,  359,   -1,  361,   -1,   -1,   -1,   -1,   -1,  367,
   -1,   -1,   -1,   -1,  372,   -1,   -1,  375,   -1,   -1,
   -1,   -1,  380,  381,   -1,   -1,   -1,  385,  386,  387,
  388,   -1,  390,  391,   -1,   -1,  394,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,  406,   -1,
   -1,   -1,   -1,   -1,  412,  413,   -1,  415,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,  424,  425,   -1,  427,
  428,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  455,   37,   -1,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
  468,   -1,   -1,   -1,   -1,  473,  474,   -1,   -1,   -1,
   -1,  479,  480,  481,   63,  483,  484,  485,  486,   -1,
   -1,   -1,   -1,   -1,   -1,  493,  494,  495,  496,  497,
   -1,  499,   -1,   -1,   -1,  503,  504,   -1,   -1,   -1,
  508,   -1,   -1,  511,  512,   94,   37,   -1,  516,   -1,
   -1,   42,   43,   44,   45,  523,   47,  525,  526,  527,
  528,   -1,   -1,   -1,  532,  533,   -1,   -1,   -1,  537,
   -1,  539,   63,   -1,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,  575,  576,  577,
  578,  579,  580,  581,  582,  583,   -1,   -1,   -1,  587,
  588,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,
   -1,   -1,  630,   -1,   -1,   -1,   -1,  635,  636,  637,
  638,  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  650,  651,  652,  653,  654,  655,  656,  657,
   94,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  338,   -1,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   37,   -1,   40,
   -1,   41,   42,   43,   45,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  383,   -1,   -1,
   -1,   -1,   -1,   63,  390,   -1,   -1,   -1,   -1,   -1,
   -1,  397,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  417,   -1,   -1,   94,  421,   -1,   -1,   37,  425,
   -1,  427,   41,   42,   43,  431,   45,   -1,   47,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,  448,   37,   63,  451,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   37,   -1,   63,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   37,   -1,   -1,
  486,   63,   42,   43,   44,   45,   -1,   47,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  503,   -1,   -1,
   94,   37,   -1,   63,   -1,   41,   42,   43,   -1,   45,
   37,   47,   94,   -1,   41,   42,   43,   -1,   45,  525,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   94,  541,   63,   -1,   -1,   -1,
  546,  547,  548,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,  575,
  576,  577,  578,  579,  580,  581,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  638,  639,  640,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  650,   -1,  652,  653,  654,  655,
  656,  657,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,  343,   -1,   -1,   -1,   -1,  348,   -1,   -1,
   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,
   -1,   -1,  383,   42,   43,   44,   45,   -1,   47,  390,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   37,   -1,   -1,   63,   41,   42,   43,   -1,   45,
   -1,   47,   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  427,   63,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   94,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,  448,   -1,   37,
  451,   -1,   -1,   41,   42,   43,   -1,   45,   94,   47,
   37,   -1,   63,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   63,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,  486,   63,   -1,   -1,   -1,
   -1,  492,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  503,   37,   -1,   -1,   94,   -1,   42,   43,
   44,   45,   -1,   47,   37,   -1,   -1,   94,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,  546,  547,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,  639,  640,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  650,
   -1,  652,  653,  654,  655,  656,  657,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,   -1,   -1,   -1,  353,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,  377,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,  390,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   37,  425,
   -1,  427,   41,   42,   43,  431,   45,   -1,   47,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,  448,   -1,   63,  451,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   94,   37,   -1,   -1,   -1,
  486,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   -1,  503,   -1,   41,
   42,   43,   63,   45,   37,   47,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  575,
  576,  577,  578,  579,  580,  581,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  638,  639,  640,   -1,   -1,   -1,   -1,   -1,
   -1,  322,   -1,   -1,  650,   -1,  652,  653,  654,  655,
  656,  657,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,   -1,
   -1,   -1,  353,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   37,  425,   -1,  427,   41,   42,   43,
  431,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,   -1,   63,
  451,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,  486,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  503,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  546,  547,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  638,  639,  640,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,
   -1,  652,  653,  654,  655,  656,  657,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   37,   -1,  348,   -1,   41,   42,   43,  353,   45,   63,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,   40,
   -1,   41,   42,   43,   45,   45,   63,   47,   -1,   -1,
   -1,  377,  641,  642,  643,  644,  645,  646,  647,  648,
   94,   37,   -1,   63,  390,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   37,   -1,   -1,   -1,   41,   42,   43,   63,   45,   -1,
   47,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,  425,
   -1,  427,   -1,   -1,   -1,  431,   63,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   94,   -1,
   -1,   -1,  448,   -1,   -1,  451,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   94,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  486,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  503,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,
  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  575,
  576,  577,  578,  579,  580,  581,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,  298,  299,  300,
  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  638,  639,  640,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  650,   -1,  652,  653,  654,  655,
  656,  657,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  342,  343,   -1,   -1,   -1,   -1,  348,   37,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   37,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   63,   -1,  377,  641,  642,  643,
  644,  645,  646,  647,  648,   63,   -1,   -1,   -1,  390,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  425,   -1,  427,   -1,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  486,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  503,   -1,   -1,  506,  507,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   37,   -1,   40,   -1,   -1,   42,
   43,   45,   45,   -1,   47,  546,  547,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   63,  390,   -1,   -1,  393,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  575,  576,  577,  578,  579,  580,
  581,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   94,   -1,   -1,   -1,   -1,  425,   -1,  427,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,  448,
   -1,   -1,  451,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,  638,  639,  640,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  650,
   -1,  652,  653,  654,  655,  656,  657,  486,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   37,  503,   -1,   -1,  506,   42,   43,
   44,   45,   -1,   47,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  546,  547,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  575,  576,  577,  578,
  579,  580,  581,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,   -1,   37,   -1,  638,
  639,  640,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,  650,   -1,  652,  653,  654,  655,  656,  657,   -1,
   37,   -1,   -1,   63,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   94,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  390,   94,   -1,  393,
   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   37,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   63,  425,   37,  427,   -1,   -1,   41,   42,   43,   -1,
   45,   63,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  448,   40,   -1,  451,   63,   -1,
   45,   94,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   94,  641,  642,  643,  644,  645,  646,  647,
  648,   41,   42,   43,   -1,   45,   -1,   47,   -1,   94,
   37,   -1,  486,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,  503,
   40,   -1,  506,   -1,   -1,   45,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   -1,   -1,  546,  547,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  575,  576,  577,  578,  579,  580,  581,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  638,  639,  640,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  650,   -1,  652,  653,
  654,  655,  656,  657,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,   -1,  298,  299,  300,  301,  302,  303,  304,
  305,  390,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,   -1,  298,  299,
  300,  301,  302,  303,  304,  305,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,  641,  642,  643,
  644,  645,  646,  647,  648,   42,   43,   44,   45,   -1,
   47,   -1,   63,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,  486,   37,   -1,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   37,   -1,   94,  503,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   63,   -1,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
  390,   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   94,   -1,  546,  547,   -1,
   -1,   -1,   -1,  552,  553,   -1,   -1,   -1,   94,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  486,   -1,   -1,   -1,   -1,  575,  576,  577,  578,
  579,  580,  581,   -1,   40,   -1,  585,  586,  503,   45,
   94,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  352,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,  486,   -1,   -1,   -1,
   -1,  546,  547,  373,   -1,   -1,   -1,  552,  553,  638,
  639,  640,   37,  503,   -1,   -1,   -1,   42,   43,   -1,
   45,  650,   47,  652,  653,  654,  655,  656,  657,   -1,
  575,  576,  577,  578,  579,  580,  581,   40,   63,   -1,
  585,  586,   45,   -1,   -1,   -1,   -1,  537,  641,  642,
  643,  644,  645,  646,  647,  648,  546,  547,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   93,   94,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  575,  576,  577,  578,  579,
  580,  581,   40,  638,  639,  640,   -1,   45,   -1,   -1,
  470,   -1,   -1,   -1,   -1,  650,   -1,  652,  653,  654,
  655,  656,  657,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,  638,  639,
  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  650,   -1,  652,  653,  654,  655,  656,  657,   -1,   -1,
   -1,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
   -1,   -1,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,   -1,  298,  299,  300,  301,  302,
  303,  304,  305,   -1,  390,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,   -1,
  298,  299,  300,  301,  302,  303,  304,  305,   37,   -1,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   63,   -1,   37,  390,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   63,   -1,   -1,
  486,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   94,   -1,  503,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   94,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,  390,   94,   -1,   -1,   -1,   -1,   37,   -1,
   -1,  537,   41,   42,   43,   -1,   45,   -1,   47,   -1,
  546,  547,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   63,  641,  642,  643,  644,  645,
  646,  647,  648,  486,   -1,   -1,   -1,   -1,   -1,  575,
  576,  577,  578,  579,  580,  581,   40,   -1,   -1,   -1,
  503,   45,   -1,   -1,   -1,   94,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   37,   47,   -1,   -1,   41,   42,   43,  486,   45,
   -1,   47,   -1,  546,  547,   -1,   -1,   -1,   63,   -1,
   -1,   -1,  638,  639,  640,  503,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,  650,   -1,  652,  653,  654,  655,
  656,  657,  575,  576,  577,  578,  579,  580,  581,   94,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   94,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,  546,  547,
   37,   -1,   -1,   -1,   41,   42,   43,   63,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   63,  575,  576,  577,
  578,  579,  580,  581,   -1,  638,  639,  640,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  650,   -1,  652,
  653,  654,  655,  656,  657,   37,   -1,   94,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  638,  639,  640,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  650,   -1,  652,  653,  654,  655,  656,  657,
   -1,   -1,   94,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,   37,   -1,   -1,   -1,   41,   42,   43,   -1,
   45,   37,   47,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   37,   -1,   -1,   -1,   63,   42,
   43,   44,   45,   -1,   47,   37,   -1,   63,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   37,   -1,   -1,
   63,   41,   42,   43,   -1,   45,   -1,   47,   -1,   94,
   -1,   63,   -1,   -1,   37,   -1,   -1,   -1,   94,   42,
   43,   44,   45,   63,   47,   -1,   -1,   -1,   -1,   37,
   -1,   94,   -1,   41,   42,   43,  390,   45,   -1,   47,
   63,   37,   94,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   37,   -1,   94,   63,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   63,   -1,   37,
   -1,   94,   -1,   -1,   42,   43,   44,   45,   63,   47,
   -1,   -1,   37,   -1,   -1,   -1,   94,   42,   43,   44,
   45,   -1,   47,   -1,   37,   63,   -1,   -1,   94,   42,
   43,   44,   45,   -1,   47,   37,   -1,   -1,   63,   94,
   42,   43,   44,   45,   -1,   47,   -1,   37,   -1,   -1,
   63,   41,   42,   43,   -1,   45,   94,   47,   -1,   -1,
   -1,   63,  486,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,  503,
   -1,   94,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   94,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   94,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,  546,  547,   37,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   37,   47,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   63,  575,  576,  577,  578,  579,  580,  581,   -1,   63,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   94,   -1,   37,   -1,   -1,   63,   41,   42,   43,
   94,   45,   -1,   47,   -1,   -1,   -1,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   63,
   -1,   -1,   -1,   -1,  638,  639,  640,   94,   -1,   -1,
   -1,   -1,   -1,   63,   -1,   -1,  650,   -1,  652,  653,
  654,  655,  656,  657,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   94,  641,  642,  643,  644,  645,
  646,  647,  648,   37,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   37,   -1,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   37,   -1,   63,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   63,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   93,   94,   -1,   37,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   94,   47,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   63,   -1,   37,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   63,   47,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   63,
   37,   -1,   94,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   37,   -1,   94,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   63,   -1,   37,   -1,
   94,   -1,   -1,   42,   43,   44,   45,   63,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   37,   94,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   94,   37,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   63,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   63,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   94,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   94,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   37,
   -1,   -1,   -1,   -1,   42,   43,   -1,   45,   37,   47,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   37,   -1,   -1,   63,   -1,   42,   43,   44,   45,
   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   93,   94,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   63,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   -1,   94,   42,   43,
   44,   45,   -1,   47,  641,  642,  643,  644,  645,  646,
  647,  648,   37,   -1,   -1,   -1,   41,   42,   43,   63,
   45,   -1,   47,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   63,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   37,
   94,   -1,   -1,   41,   42,   43,   -1,   45,   37,   47,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   94,
   -1,   37,   -1,   -1,   -1,   63,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   -1,   63,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   94,  641,  642,  643,
  644,  645,  646,  647,  648,   94,   -1,   -1,   -1,   63,
  641,  642,  643,  644,  645,  646,  647,  648,   94,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   94,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   37,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   63,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   37,   94,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   63,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   37,   47,   -1,   -1,   41,   42,   43,   -1,   45,   94,
   47,   -1,   -1,   37,   -1,   -1,   -1,   63,   42,   43,
   44,   45,   -1,   47,   37,   -1,   63,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   37,   -1,   -1,   -1,   63,
   42,   43,   44,   45,   -1,   47,   37,   -1,   94,   -1,
   63,   42,   43,   44,   45,   -1,   47,   94,   37,   -1,
   -1,   63,   -1,   42,   43,   -1,   45,   -1,   47,   37,
   94,   -1,   63,   -1,   42,   43,   44,   45,   -1,   47,
   37,   94,   -1,   -1,   63,   42,   43,   44,   45,   -1,
   47,   37,   94,   -1,   -1,   63,   42,   43,   44,   45,
   -1,   47,   37,   94,   -1,   -1,   63,   42,   43,   -1,
   45,   -1,   47,   -1,   93,   94,   -1,   63,   -1,   37,
   -1,   -1,   -1,   41,   42,   43,   94,   45,   63,   47,
   -1,   -1,   -1,   -1,   37,   -1,   -1,   94,   41,   42,
   43,   -1,   45,   -1,   47,   63,   37,   -1,   94,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   93,   94,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   94,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   37,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   63,   37,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   63,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   63,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   94,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   63,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   37,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   94,   47,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   37,   -1,   -1,   63,
   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   37,   -1,
   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,   -1,
   94,   63,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   37,   -1,   -1,   94,   -1,   42,   43,   44,   45,   -1,
   47,   93,   94,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   37,   47,   -1,   94,   63,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   41,   42,   43,   63,
   45,   -1,   47,   -1,   -1,   37,   -1,   -1,   63,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   94,   63,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   37,   -1,
   94,   63,   -1,   42,   43,   44,   45,   37,   47,   94,
   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,   94,
   -1,   41,   42,   43,   63,   45,   -1,   47,   -1,   -1,
   -1,   93,   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   63,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   37,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   37,   47,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   41,
   42,   43,   -1,   45,   63,   47,   -1,   -1,   -1,   -1,
   37,   -1,   -1,   63,   -1,   42,   43,   -1,   45,   -1,
   47,   63,   37,   -1,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   94,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   94,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   94,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   94,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   41,   42,   43,   -1,   45,   63,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   63,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   94,   63,   -1,
   41,   42,   43,   -1,   45,   94,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   41,   42,   43,   -1,   45,   94,
   47,   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   63,   42,   43,   44,
   45,   -1,   47,   94,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   63,  641,
  642,  643,  644,  645,  646,  647,  648,   94,   -1,  529,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   94,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   63,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   63,   -1,   -1,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   94,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   94,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   63,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   41,   42,
   43,   94,   45,   -1,   47,   -1,   41,   42,   43,   -1,
   45,   63,   47,   -1,   -1,   41,   42,   43,   -1,   45,
   63,   47,   -1,   41,   42,   43,   -1,   45,   63,   47,
   -1,   -1,   41,   42,   43,   -1,   45,   63,   47,   -1,
   -1,   -1,   94,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   63,   -1,   41,   42,   43,   94,
   45,   -1,   47,   -1,   -1,   41,   42,   43,   94,   45,
   -1,   47,   -1,   41,   42,   43,   94,   45,   63,   47,
   -1,   -1,   41,   42,   43,   94,   45,   63,   47,   -1,
   41,   42,   43,   -1,   45,   63,   47,   -1,   -1,   41,
   42,   43,   -1,   45,   63,   47,   -1,   -1,   -1,   94,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   63,   -1,   41,   42,   43,   94,   45,   -1,   47,
   -1,   -1,   41,   42,   43,   94,   45,   -1,   47,   -1,
   41,   42,   43,   94,   45,   63,   47,   -1,   -1,   41,
   42,   43,   94,   45,   63,   47,   -1,   41,   42,   43,
   -1,   45,   63,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   94,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   94,   41,   42,   43,   -1,
   45,   -1,   47,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   94,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   94,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,  352,  641,  642,  643,  644,
  645,  646,  647,  648,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  373,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   63,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,  641,  642,  643,  644,  645,  646,  647,  648,
   94,  641,  642,  643,  644,  645,  646,  647,  648,   94,
   42,   43,   44,   45,   -1,   47,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   42,   43,   44,
   45,   63,   47,  470,   -1,   -1,   -1,   -1,   -1,   -1,
  641,  642,  643,  644,  645,  646,  647,  648,   63,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   94,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   63,   42,   43,   44,   45,   -1,   47,   94,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   63,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   -1,
   -1,  641,  642,  643,  644,  645,  646,  647,  648,   94,
   -1,   -1,   -1,   -1,   -1,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,  608,  609,  610,  611,  612,  613,  614,  615,  616,
  617,  618,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  639,   -1,   -1,   -1,   -1,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,  641,  642,
  643,  644,  645,  646,  647,  648,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,  641,  642,  643,  644,  645,
  646,  647,  648,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,  647,
  648,   -1,  641,  642,  643,  644,  645,  646,  647,  648,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  281,   -1,  283,  284,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  641,  642,  643,  644,  645,  646,
  647,  648,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  313,   -1,  641,  642,  643,
  644,  645,  646,  647,  648,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,  336,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  333,  334,  335,   -1,
  348,   -1,   -1,   -1,   -1,   -1,  354,  344,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  641,
  642,  643,  644,  645,  646,  647,  648,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,   -1,   -1,   -1,  407,
  317,   -1,  319,   -1,   -1,   -1,   -1,   -1,   -1,  406,
  641,  642,  643,  644,  645,  646,  647,  648,   -1,  427,
   -1,   -1,   -1,   -1,   -1,   -1,  343,  435,   -1,   -1,
  438,  348,  641,  642,  643,  644,  645,  646,  647,  648,
  448,  449,  450,  451,  452,   -1,  454,   -1,   -1,   -1,
  447,   -1,   -1,   -1,   -1,   -1,  641,  642,  643,  644,
  645,  646,  647,  648,   -1,   -1,  383,   -1,  385,   -1,
   -1,   -1,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  397,   -1,   -1,   -1,   -1,  482,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  414,  506,   -1,
  417,   -1,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  537,
   -1,  448,   -1,   -1,  451,  452,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  471,  472,   -1,  554,  555,  556,
  557,   -1,  559,  560,  561,  562,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,   -1,  348,
  349,   -1,   -1,   -1,   -1,   -1,  348,  349,  505,   -1,
  507,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  371,  520,  521,   -1,   -1,  524,  377,  371,
   -1,   -1,   -1,   -1,  383,  377,  385,   -1,   -1,   -1,
  537,  383,   -1,  385,  541,   -1,   -1,   -1,   -1,   -1,
   -1,  639,   -1,   -1,   -1,  404,   -1,   -1,   -1,  348,
  349,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  425,   -1,  427,   -1,
   -1,   -1,  371,  425,   -1,  427,   -1,   -1,  377,   -1,
  439,   -1,   -1,   -1,  383,   -1,  385,  439,   -1,  448,
   -1,   -1,  451,   -1,   -1,   -1,  448,   -1,   -1,  451,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,  471,   -1,   -1,   -1,   -1,   -1,   -1,  471,
   -1,   -1,   -1,   -1,   -1,   -1,  425,   -1,  427,   -1,
   -1,   -1,  639,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  439,   -1,   -1,   -1,   -1,   -1,   -1,  506,  507,  448,
   -1,   -1,  451,   -1,  506,  507,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
   -1,   -1,  471,   -1,   -1,   -1,  528,   -1,  537,   -1,
   -1,   -1,   -1,   -1,   -1,  537,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  506,  507,   -1,
   -1,   -1,  571,   -1,   -1,   -1,   -1,   -1,   -1,  571,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  537,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  571,
};
#define YYFINAL 169
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 657
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,
0,0,0,0,0,"':'",0,0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ABS","ACOS","ASIN","ATAN","ATAN2","CEIL","COS",
"DEG","DX","DY","ERF","ERFC","EXP","FLOOR","HYPOT","INDEX","INT","INVN","INVT",
"IRAND","JDAY","JDAY0","LGAMMA","LN","LOG","LOGISTIC","MAXP","MINP","MOD",
"NORM","NORMP","PI","RAD","RAND","RNORM","SETNO","SIN","SQR","SQRT","TAN",
"INUM","VX1","VX2","VY1","VY2","WX1","WX2","WY1","WY2","DELAYP","DOUBLEBUFFER",
"DOWN","ABSOLUTE","ABORT","ACTIVATE","ACTIVE","ALT","ALTERNATE","ALTXAXIS",
"ALTYAXIS","ANGLE","ANNOTATE","APPEND","AREA","ARRANGE","ARROW","ASCENDING",
"AUTO","AUTOSCALE","AUTOTICKS","AVG","AXIS","AXES","BACKBUFFER","BACKGROUND",
"BAR","BATCH","BLOCK","BIN","BOTH","BOTTOM","BOX","BOXPLOT","CD","CELLS",
"CENTER","CHAR","CHRSTR","CLEAR","CLICK","CMAP","COLOR","COMMENT","COPY",
"CYCLE","DECIMAL","DEF","DEFAULT","DELETE","DEVICE","DESCENDING","DFT",
"DIFFERENCE","DISK","DRAW2","DROP","DXDX","DXP","DYDY","DYP","ECHO","EDIT",
"ELSE","END","ERRORBAR","EXIT","EXPONENTIAL","FALSEP","FFT","FILEP","FILL",
"FIND","FIXEDPOINT","FLUSH","FOCUS","FOLLOWS","FONTP","FOREGROUND","FORMAT",
"FRONTBUFFER","FRAMEP","GETP","GRAPH","GRAPHNO","GRAPHS","GRAPHTYPE","GRID",
"HARDCOPY","HBAR","HBOXPLOT","HGAP","HIDDEN","HORIZONTAL","HPGLL","HPGLP",
"HISTO","IF","IGNORE","IHL","IMAGE","IN","INIT","INOUT","INTEGRATE","INTERP",
"INVDFT","INVFFT","JUST","KILL","LABEL","LAYOUT","LEAVE","LEFT","LEGEND",
"LENGTH","LEVEL","LEVELS","LINE","LINESTYLE","LINETO","LINEWIDTH","LINK","LOAD",
"LOCATOR","LOCTYPE","LOGX","LOGY","LOGXY","MAJOR","MIFL","MIFP","MINOR",
"MISSINGP","MOVE","MOVE2","MOVETO","NEGATE","NO","NONE","NORMAL","NXY","OFF",
"OFFSETX","OFFSETY","ON","OP","ORIENT","OUT","PAGE","PARA","PARALLEL",
"PARAMETERS","PARAMS","PATTERN","PERIMETER","PERP","PERPENDICULAR","PIE","PIPE",
"PLACE","POINT","POLAR","POLY","POWER","PREC","PREPEND","PRINT","PS","PSCOLORP",
"PSMONOP","PSCOLORL","PSMONOL","PUSH","POP","PUTP","RAWSPICE","READ","REDRAW",
"REGRESS","REGNUM","REGIONS","RENDER","REVERSE","RIGHT","RISER","ROT","RUNAVG",
"RUNMED","RUNSTD","RUNMIN","RUNMAX","SAMPLE","SAVEALL","SCALE","SCIENTIFIC",
"SET","SETNUM","SETS","SIGN","SIZE","SKIP","SLEEP","SLICE","SMITH","SORT",
"SOURCE","SPEC","SPECIFIED","SPECTRUM","STACK","STACKEDBAR","STACKEDHBAR",
"STACKEDLINE","STAGGER","START","STARTTYPE","STATUS","STOP","STRING","SUBTITLE",
"SWAPBUFFER","SYMBOL","TICKP","TICKLABEL","TICKMARKS","TIME","TITLE","TO","TOP",
"TRUEP","TYPE","UP","VELOCITY","VERTICAL","VGAP","VIEW","WITH","WORLD","WRITE",
"X","X0","X1","XAXES","XAXIS","XCOR","XMAX","XMIN","XY","XYARC","XYBOX",
"XYBOXPLOT","XYFIXED","XYHILO","XYRT","XYSEG","XYSTRING","XYDX","XYDY","XYDXDX",
"XYDYDY","XYDXDY","XYX2Y2","XYXX","XYYY","XYZ","XYZW","XYUV","TSV","Y","Y0",
"Y1","Y2","Y3","Y4","Y5","YAXES","YAXIS","YES","YMAX","YMIN","ZEROXAXIS",
"ZEROYAXIS","ABOVE","BELOW","POLYI","POLYO","GENERAL","DDMMYY","YYMMDD",
"MMDDYY","MMYY","MMDD","MONTHDAY","DAYMONTH","MONTHS","MONTHSY","MONTHL",
"DAYOFWEEKS","DAYOFWEEKL","DAYOFYEAR","HMS","MMDDHMS","MMDDYYHMS","YYMMDDHMS",
"DEGREESLON","DEGREESMMLON","DEGREESMMSSLON","MMSSLON","DEGREESLAT",
"DEGREESMMLAT","DEGREESMMSSLAT","MMSSLAT","DOT","STAR","PLUS","CROSS","CIRCLE",
"SQUARE","DIAMOND","TRIANGLE1","TRIANGLE2","TRIANGLE3","TRIANGLE4","SPLINE",
"LANDSCAPE","PORTRAIT","FREE","FIXED","STATUSBAR","LOCATORBAR","TOOLBAR","VAR",
"NUMBER","FITPARM","OR","AND","GT","LT","LE","GE","EQ","NE","UMINUS","NOT",
"ELLIPSE","ACOSH","ASINH","ATANH","COSH","SINH","TANH",
};
char *yyrule[] = {
"$accept : list",
"list :",
"list : asgn '\\n'",
"list : vasgn '\\n'",
"list : rasgn '\\n'",
"list : expr '\\n'",
"list : vexpr '\\n'",
"list : parmset '\\n'",
"list : regionset '\\n'",
"list : setaxis '\\n'",
"list : setvelocity '\\n'",
"list : set_setprop '\\n'",
"list : setprint '\\n'",
"list : error '\\n'",
"setprint : PRINT printer CHRSTR",
"setprint : PRINT TO printer CHRSTR",
"setprint : PRINT TO printer",
"setprint : DEVICE NUMBER",
"setprint : HARDCOPY DEVICE NUMBER",
"setprint : HARDCOPY",
"setprint : PS LINEWIDTH NUMBER",
"printer : PSMONOP",
"printer : PSMONOL",
"printer : MIFP",
"printer : MIFL",
"printer : HPGLP",
"printer : HPGLL",
"printer : HARDCOPY",
"printer : FILEP",
"regionset : REGNUM onoff",
"regionset : REGNUM TYPE regiontype",
"regionset : REGNUM COLOR NUMBER",
"regionset : REGNUM LINESTYLE NUMBER",
"regionset : REGNUM LINEWIDTH NUMBER",
"regionset : REGNUM LINE expr ',' expr ',' expr ',' expr",
"regionset : REGNUM XY expr ',' expr",
"regionset : LINK REGNUM TO GRAPHNO",
"parmset : REDRAW",
"parmset : AUTO REDRAW onoff",
"parmset : CD CHRSTR",
"parmset : ECHO CHRSTR",
"parmset : STATUS",
"parmset : BACKGROUND COLOR NUMBER",
"parmset : CMAP NUMBER ',' NUMBER ',' NUMBER ',' NUMBER",
"parmset : EXIT",
"parmset : PAGE LAYOUT pagelayout",
"parmset : STATUSBAR onoff",
"parmset : TOOLBAR onoff",
"parmset : LOCATORBAR onoff",
"parmset : DRAW2 expr ',' expr",
"parmset : MOVE2 expr ',' expr",
"parmset : SYMBOL expr ',' expr ',' NUMBER",
"parmset : COLOR NUMBER",
"parmset : LINEWIDTH NUMBER",
"parmset : LINESTYLE NUMBER",
"parmset : WRITE STRING expr ',' expr ',' CHRSTR",
"parmset : PAGE direction",
"parmset : PAGE NUMBER",
"parmset : PAGE INOUT NUMBER",
"parmset : LINK PAGE onoff",
"parmset : DOUBLEBUFFER torf",
"parmset : FRONTBUFFER torf",
"parmset : BACKBUFFER torf",
"parmset : SWAPBUFFER",
"parmset : SLEEP NUMBER",
"parmset : DELAYP NUMBER",
"parmset : ABORT torf",
"parmset : GETP CHRSTR",
"parmset : PUTP CHRSTR",
"parmset : WITH GRAPHNO",
"parmset : WITH SETNUM",
"parmset : SETNUM LINK sourcetype CHRSTR",
"parmset : GRAPHNO '.' SETNUM LINK sourcetype CHRSTR",
"parmset : SETNUM LINK onoff",
"parmset : GRAPHNO '.' SETNUM LINK onoff",
"parmset : ACTIVATE SETNUM NUMBER",
"parmset : ACTIVATE GRAPHNO '.' SETNUM NUMBER",
"parmset : SETNUM LENGTH NUMBER",
"parmset : GRAPHNO '.' SETNUM LENGTH NUMBER",
"parmset : SETNUM POINT expr ',' expr",
"parmset : GRAPHNO '.' SETNUM POINT expr ',' expr",
"parmset : SETNUM DROP NUMBER ',' NUMBER",
"parmset : GRAPHNO '.' SETNUM DROP NUMBER ',' NUMBER",
"parmset : SORT SETNUM sorton sortdir",
"parmset : COPY SETNUM TO SETNUM",
"parmset : COPY GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : MOVE SETNUM TO SETNUM",
"parmset : MOVE GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : KILL SETNUM",
"parmset : KILL SETS",
"parmset : KILL SETNUM SAVEALL",
"parmset : KILL SETS SAVEALL",
"parmset : KILL GRAPHNO",
"parmset : KILL GRAPHS",
"parmset : FLUSH",
"parmset : ARRANGE NUMBER ',' NUMBER",
"parmset : LOAD VAR NUMBER ',' expr ',' expr",
"parmset : REGRESS '(' SETNUM ',' NUMBER ')'",
"parmset : runtype '(' SETNUM ',' NUMBER ')'",
"parmset : ffttype '(' SETNUM ',' NUMBER ')'",
"parmset : SPLINE '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : HISTO '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : DIFFERENCE '(' SETNUM ',' NUMBER ')'",
"parmset : INT '(' SETNUM ')'",
"parmset : AUTOSCALE",
"parmset : AUTOSCALE XAXES",
"parmset : AUTOSCALE YAXES",
"parmset : AUTOSCALE SETNUM",
"parmset : LOCATOR onoff",
"parmset : FOCUS GRAPHNO",
"parmset : FOCUS onoff",
"parmset : FOCUS SET",
"parmset : FOCUS FOLLOWS",
"parmset : FOCUS CLICK",
"parmset : SOURCE sourcetype",
"parmset : TYPE xytype",
"parmset : FORMAT formatchoice",
"parmset : READ CHRSTR",
"parmset : READ BATCH CHRSTR",
"parmset : READ BLOCK CHRSTR",
"parmset : READ BLOCK sourcetype CHRSTR",
"parmset : BLOCK xytype CHRSTR",
"parmset : READ xytype CHRSTR",
"parmset : READ xytype sourcetype CHRSTR",
"parmset : READ IMAGE CHRSTR",
"parmset : WRITE IMAGE CHRSTR",
"parmset : IMAGE XY NUMBER ',' NUMBER",
"parmset : WRITE SETNUM",
"parmset : WRITE SETNUM FORMAT CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR FORMAT CHRSTR",
"parmset : SAVEALL CHRSTR",
"parmset : PUSH",
"parmset : POP",
"parmset : CYCLE",
"parmset : STACK NUMBER",
"parmset : STACK WORLD expr ',' expr ',' expr ',' expr TICKP expr ',' expr ',' expr ',' expr",
"parmset : CLEAR STACK",
"parmset : CLEAR BOX",
"parmset : WITH BOX",
"parmset : WITH BOX NUMBER",
"parmset : BOX onoff",
"parmset : BOX GRAPHNO",
"parmset : BOX expr ',' expr ',' expr ',' expr",
"parmset : BOX LOCTYPE worldview",
"parmset : BOX LINESTYLE NUMBER",
"parmset : BOX LINEWIDTH NUMBER",
"parmset : BOX COLOR NUMBER",
"parmset : BOX FILL filltype",
"parmset : BOX FILL COLOR NUMBER",
"parmset : BOX FILL PATTERN NUMBER",
"parmset : BOX DEF",
"parmset : CLEAR ELLIPSE",
"parmset : WITH ELLIPSE",
"parmset : WITH ELLIPSE NUMBER",
"parmset : ELLIPSE onoff",
"parmset : ELLIPSE GRAPHNO",
"parmset : ELLIPSE expr ',' expr ',' expr ',' expr",
"parmset : ELLIPSE LOCTYPE worldview",
"parmset : ELLIPSE LINESTYLE NUMBER",
"parmset : ELLIPSE LINEWIDTH NUMBER",
"parmset : ELLIPSE COLOR NUMBER",
"parmset : ELLIPSE FILL filltype",
"parmset : ELLIPSE FILL COLOR NUMBER",
"parmset : ELLIPSE FILL PATTERN NUMBER",
"parmset : ELLIPSE DEF",
"parmset : WITH LINE",
"parmset : WITH LINE NUMBER",
"parmset : CLEAR LINE",
"parmset : LINE onoff",
"parmset : LINE GRAPHNO",
"parmset : LINE expr ',' expr ',' expr ',' expr",
"parmset : LINE LOCTYPE worldview",
"parmset : LINE LINEWIDTH NUMBER",
"parmset : LINE LINESTYLE NUMBER",
"parmset : LINE COLOR NUMBER",
"parmset : LINE ARROW NUMBER",
"parmset : LINE ARROW SIZE NUMBER",
"parmset : LINE ARROW TYPE NUMBER",
"parmset : LINE DEF",
"parmset : CLEAR STRING",
"parmset : WITH STRING",
"parmset : WITH STRING NUMBER",
"parmset : STRING onoff",
"parmset : STRING GRAPHNO",
"parmset : STRING expr ',' expr",
"parmset : STRING LOCTYPE worldview",
"parmset : STRING LINEWIDTH NUMBER",
"parmset : STRING COLOR NUMBER",
"parmset : STRING ROT NUMBER",
"parmset : STRING FONTP NUMBER",
"parmset : STRING JUST NUMBER",
"parmset : STRING CHAR SIZE NUMBER",
"parmset : STRING DEF CHRSTR",
"parmset : TIME STRING onoff",
"parmset : TIME STRING FONTP NUMBER",
"parmset : TIME STRING CHAR SIZE NUMBER",
"parmset : TIME STRING COLOR NUMBER",
"parmset : TIME STRING LINEWIDTH NUMBER",
"parmset : TIME STRING NUMBER ',' NUMBER",
"parmset : DEFAULT LINESTYLE NUMBER",
"parmset : DEFAULT LINEWIDTH NUMBER",
"parmset : DEFAULT COLOR NUMBER",
"parmset : DEFAULT CHAR SIZE NUMBER",
"parmset : DEFAULT FONTP NUMBER",
"parmset : DEFAULT FONTP SOURCE NUMBER",
"parmset : DEFAULT SYMBOL SIZE NUMBER",
"parmset : WORLD expr ',' expr ',' expr ',' expr",
"parmset : WORLD XMIN expr",
"parmset : WORLD XMAX expr",
"parmset : WORLD YMIN expr",
"parmset : WORLD YMAX expr",
"parmset : POLAR WORLD expr ',' expr",
"parmset : VIEW expr ',' expr ',' expr ',' expr",
"parmset : VIEW XMIN NUMBER",
"parmset : VIEW XMAX NUMBER",
"parmset : VIEW YMIN NUMBER",
"parmset : VIEW YMAX NUMBER",
"parmset : TITLE CHRSTR",
"parmset : TITLE FONTP NUMBER",
"parmset : TITLE SIZE NUMBER",
"parmset : TITLE COLOR NUMBER",
"parmset : TITLE LINEWIDTH NUMBER",
"parmset : SUBTITLE CHRSTR",
"parmset : SUBTITLE FONTP NUMBER",
"parmset : SUBTITLE SIZE NUMBER",
"parmset : SUBTITLE COLOR NUMBER",
"parmset : SUBTITLE LINEWIDTH NUMBER",
"parmset : GRAPHS MAXP SETS NUMBER",
"parmset : LEGEND onoff",
"parmset : LEGEND LOCTYPE worldview",
"parmset : LEGEND LAYOUT NUMBER",
"parmset : LEGEND VGAP NUMBER",
"parmset : LEGEND HGAP NUMBER",
"parmset : LEGEND LENGTH NUMBER",
"parmset : LEGEND BOX onoff",
"parmset : LEGEND BOX FILL onoff",
"parmset : LEGEND BOX FILL WITH colpat",
"parmset : LEGEND BOX FILL colpat NUMBER",
"parmset : LEGEND BOX COLOR NUMBER",
"parmset : LEGEND BOX LINESTYLE NUMBER",
"parmset : LEGEND BOX LINEWIDTH NUMBER",
"parmset : LEGEND expr ',' expr",
"parmset : LEGEND X1 expr",
"parmset : LEGEND Y1 expr",
"parmset : LEGEND CHAR SIZE NUMBER",
"parmset : LEGEND FONTP NUMBER",
"parmset : LEGEND LINESTYLE NUMBER",
"parmset : LEGEND LINEWIDTH NUMBER",
"parmset : LEGEND COLOR NUMBER",
"parmset : LEGEND STRING NUMBER CHRSTR",
"parmset : FRAMEP onoff",
"parmset : FRAMEP TYPE NUMBER",
"parmset : FRAMEP LINESTYLE NUMBER",
"parmset : FRAMEP LINEWIDTH NUMBER",
"parmset : FRAMEP COLOR NUMBER",
"parmset : FRAMEP FILL onoff",
"parmset : FRAMEP BACKGROUND COLOR NUMBER",
"parmset : GRAPHNO onoff",
"parmset : GRAPHNO LABEL onoff",
"parmset : GRAPHNO AUTOSCALE TYPE AUTO",
"parmset : GRAPHNO AUTOSCALE TYPE SPEC",
"parmset : GRAPHNO AUTOSCALE torf",
"parmset : GRAPHNO HIDDEN torf",
"parmset : GRAPHNO TYPE graphtype",
"parmset : GRAPHNO BAR SIZE NUMBER",
"parmset : GRAPHNO STACKEDBAR SIZE NUMBER",
"parmset : GRAPHNO FIXEDPOINT onoff",
"parmset : GRAPHNO FIXEDPOINT FORMAT formatchoice formatchoice",
"parmset : GRAPHNO FIXEDPOINT PREC NUMBER ',' NUMBER",
"parmset : GRAPHNO FIXEDPOINT XY expr ',' expr",
"parmset : GRAPHNO FIXEDPOINT TYPE NUMBER",
"parmset : GRAPHNO MAXP SETS NUMBER",
"setvelocity : VELOCITY SCALE NUMBER",
"setvelocity : VELOCITY LEGEND onoff",
"setvelocity : VELOCITY LINEWIDTH NUMBER",
"setvelocity : VELOCITY LINESTYLE NUMBER",
"setvelocity : VELOCITY COLOR NUMBER",
"setvelocity : VELOCITY LOCTYPE worldview",
"setvelocity : VELOCITY ARROW TYPE NUMBER",
"xytype : XY",
"xytype : XYARC",
"xytype : XYBOX",
"xytype : XYBOXPLOT",
"xytype : XYHILO",
"xytype : XYRT",
"xytype : XYSEG",
"xytype : XYSTRING",
"xytype : XYDX",
"xytype : XYDY",
"xytype : XYDXDX",
"xytype : XYDYDY",
"xytype : XYDXDY",
"xytype : XYX2Y2",
"xytype : XYXX",
"xytype : XYYY",
"xytype : XYZ",
"xytype : XYZW",
"xytype : XYUV",
"xytype : TSV",
"xytype : NXY",
"xytype : BIN",
"xytype : POLY",
"xytype : RAWSPICE",
"graphtype : XY",
"graphtype : LOGX",
"graphtype : LOGY",
"graphtype : LOGXY",
"graphtype : BAR",
"graphtype : HBAR",
"graphtype : STACKEDBAR",
"graphtype : STACKEDHBAR",
"graphtype : POLAR",
"graphtype : XYFIXED",
"graphtype : BOXPLOT",
"graphtype : HBOXPLOT",
"graphtype : SMITH",
"pagelayout : FREE",
"pagelayout : LANDSCAPE",
"pagelayout : PORTRAIT",
"pagelayout : FIXED",
"regiontype : ABOVE",
"regiontype : BELOW",
"regiontype : LEFT",
"regiontype : RIGHT",
"regiontype : POLYI",
"regiontype : POLYO",
"set_setprop : selectsets setprop",
"setprop : onoff",
"setprop : IGNORE",
"setprop : TYPE xytype",
"setprop : MISSINGP expr",
"setprop : PREC NUMBER",
"setprop : FORMAT formatchoice",
"setprop : SYMBOL expr",
"setprop : SYMBOL FILL NUMBER",
"setprop : SYMBOL CENTER torf",
"setprop : SYMBOL SIZE expr",
"setprop : SYMBOL CHAR NUMBER",
"setprop : SYMBOL SKIP NUMBER",
"setprop : SYMBOL COLOR expr",
"setprop : SYMBOL LINEWIDTH NUMBER",
"setprop : SYMBOL LINESTYLE NUMBER",
"setprop : prop NUMBER",
"setprop : FILL NUMBER",
"setprop : FILL WITH colpat",
"setprop : FILL colpat NUMBER",
"setprop : SKIP NUMBER",
"setprop : ERRORBAR LENGTH NUMBER",
"setprop : ERRORBAR TYPE opchoice",
"setprop : ERRORBAR LINEWIDTH NUMBER",
"setprop : ERRORBAR LINESTYLE NUMBER",
"setprop : ERRORBAR RISER onoff",
"setprop : ERRORBAR RISER LINEWIDTH NUMBER",
"setprop : ERRORBAR RISER LINESTYLE NUMBER",
"setprop : XYZ expr ',' expr",
"setprop : COMMENT CHRSTR",
"setaxis : axis",
"setaxis : axis axisfeature",
"setaxis : allaxes",
"setaxis : GRAPHS axis",
"setaxis : GRAPHS axis axisfeature",
"setaxis : GRAPHS allaxes",
"axis : XAXIS",
"axis : YAXIS",
"axis : ALTXAXIS",
"axis : ALTYAXIS",
"axis : ZEROXAXIS",
"axis : ZEROYAXIS",
"allaxes : AXES axesprops",
"allaxes : XAXES axesprops",
"allaxes : YAXES axesprops",
"axesprops : onoff",
"axesprops : COLOR NUMBER",
"axesprops : LINEWIDTH NUMBER",
"axesprops : LINESTYLE NUMBER",
"axesprops : FONTP NUMBER",
"axesprops : CHAR SIZE NUMBER",
"axesprops : GRID onoff",
"axisfeature : TICKP tickdesc",
"axisfeature : TICKLABEL ticklabeldesc",
"axisfeature : LABEL axislabeldesc",
"axisfeature : BAR axisbardesc",
"axisfeature : onoff",
"tickdesc : tickattr",
"tickdesc : tickdesc tickattr",
"tickattr : onoff",
"tickattr : MAJOR onoff",
"tickattr : MINOR onoff",
"tickattr : MAJOR expr",
"tickattr : MINOR expr",
"tickattr : OFFSETX expr",
"tickattr : OFFSETY expr",
"tickattr : ALT onoff",
"tickattr : MINP expr",
"tickattr : MAXP expr",
"tickattr : DEFAULT NUMBER",
"tickattr : inoutchoice",
"tickattr : LOG onoff",
"tickattr : SIZE NUMBER",
"tickattr : MAJOR SIZE NUMBER",
"tickattr : MINOR SIZE NUMBER",
"tickattr : COLOR NUMBER",
"tickattr : LINEWIDTH NUMBER",
"tickattr : MAJOR COLOR NUMBER",
"tickattr : MINOR COLOR NUMBER",
"tickattr : MAJOR LINEWIDTH NUMBER",
"tickattr : MINOR LINEWIDTH NUMBER",
"tickattr : MAJOR LINESTYLE NUMBER",
"tickattr : MINOR LINESTYLE NUMBER",
"tickattr : MAJOR GRID onoff",
"tickattr : MINOR GRID onoff",
"tickattr : OP opchoice",
"tickattr : TYPE AUTO",
"tickattr : TYPE SPEC",
"tickattr : SPEC NUMBER",
"tickattr : NUMBER ',' expr",
"ticklabeldesc : ticklabelattr",
"ticklabeldesc : ticklabeldesc ticklabelattr",
"ticklabelattr : onoff",
"ticklabelattr : TYPE AUTO",
"ticklabelattr : TYPE SPEC",
"ticklabelattr : PREC NUMBER",
"ticklabelattr : FORMAT formatchoice",
"ticklabelattr : FORMAT NUMBER",
"ticklabelattr : APPEND CHRSTR",
"ticklabelattr : PREPEND CHRSTR",
"ticklabelattr : LAYOUT HORIZONTAL",
"ticklabelattr : LAYOUT VERTICAL",
"ticklabelattr : LAYOUT SPEC",
"ticklabelattr : LOCTYPE ON",
"ticklabelattr : LOCTYPE CENTER",
"ticklabelattr : LOCTYPE LEFT",
"ticklabelattr : LOCTYPE RIGHT",
"ticklabelattr : ANGLE NUMBER",
"ticklabelattr : JUST justchoice",
"ticklabelattr : SKIP NUMBER",
"ticklabelattr : STAGGER NUMBER",
"ticklabelattr : OP opchoice",
"ticklabelattr : SIGN signchoice",
"ticklabelattr : START expr",
"ticklabelattr : STOP expr",
"ticklabelattr : START TYPE SPEC",
"ticklabelattr : START TYPE AUTO",
"ticklabelattr : STOP TYPE SPEC",
"ticklabelattr : STOP TYPE AUTO",
"ticklabelattr : VGAP NUMBER",
"ticklabelattr : HGAP NUMBER",
"ticklabelattr : CHAR SIZE NUMBER",
"ticklabelattr : FONTP NUMBER",
"ticklabelattr : COLOR NUMBER",
"ticklabelattr : LINEWIDTH NUMBER",
"ticklabelattr : NUMBER ',' CHRSTR",
"axislabeldesc : CHRSTR",
"axislabeldesc : LAYOUT PERP",
"axislabeldesc : LAYOUT PARA",
"axislabeldesc : PLACE AUTO",
"axislabeldesc : PLACE SPEC",
"axislabeldesc : PLACE NUMBER ',' NUMBER",
"axislabeldesc : JUST justchoice",
"axislabeldesc : CHAR SIZE NUMBER",
"axislabeldesc : FONTP NUMBER",
"axislabeldesc : COLOR NUMBER",
"axislabeldesc : LINEWIDTH NUMBER",
"axisbardesc : onoff",
"axisbardesc : COLOR NUMBER",
"axisbardesc : LINESTYLE NUMBER",
"axisbardesc : LINEWIDTH NUMBER",
"selectsets : GRAPHNO '.' SETNUM",
"selectsets : SETNUM",
"selectsets : SETS",
"selectsets : GRAPHNO SETS",
"selectsets : GRAPHS SETS",
"selectsets : GRAPHS SETNUM",
"prop : LINESTYLE",
"prop : LINEWIDTH",
"prop : FONTP",
"prop : COLOR",
"prop : SIZE",
"onoff : ON",
"onoff : OFF",
"colpat : COLOR",
"colpat : PATTERN",
"runtype : RUNAVG",
"runtype : RUNSTD",
"runtype : RUNMED",
"runtype : RUNMAX",
"runtype : RUNMIN",
"ffttype : DFT",
"ffttype : FFT",
"ffttype : INVDFT",
"ffttype : INVFFT",
"sourcetype : DISK",
"sourcetype : PIPE",
"filltype : PATTERN",
"filltype : COLOR",
"filltype : NONE",
"opchoice : TOP",
"opchoice : BOTTOM",
"opchoice : LEFT",
"opchoice : RIGHT",
"opchoice : BOTH",
"justchoice : RIGHT",
"justchoice : LEFT",
"justchoice : CENTER",
"extremetype : MINP",
"extremetype : MAXP",
"torf : TRUEP",
"torf : FALSEP",
"inoutchoice : IN",
"inoutchoice : OUT",
"inoutchoice : BOTH",
"formatchoice : DECIMAL",
"formatchoice : EXPONENTIAL",
"formatchoice : POWER",
"formatchoice : GENERAL",
"formatchoice : DDMMYY",
"formatchoice : MMDDYY",
"formatchoice : YYMMDD",
"formatchoice : MMYY",
"formatchoice : MMDD",
"formatchoice : MONTHDAY",
"formatchoice : DAYMONTH",
"formatchoice : MONTHS",
"formatchoice : MONTHSY",
"formatchoice : MONTHL",
"formatchoice : DAYOFWEEKS",
"formatchoice : DAYOFWEEKL",
"formatchoice : DAYOFYEAR",
"formatchoice : HMS",
"formatchoice : MMDDHMS",
"formatchoice : MMDDYYHMS",
"formatchoice : YYMMDDHMS",
"formatchoice : DEGREESLON",
"formatchoice : DEGREESMMLON",
"formatchoice : DEGREESMMSSLON",
"formatchoice : MMSSLON",
"formatchoice : DEGREESLAT",
"formatchoice : DEGREESMMLAT",
"formatchoice : DEGREESMMSSLAT",
"formatchoice : MMSSLAT",
"signchoice : NORMAL",
"signchoice : ABSOLUTE",
"signchoice : NEGATE",
"direction : UP",
"direction : DOWN",
"direction : RIGHT",
"direction : LEFT",
"direction : IN",
"direction : OUT",
"worldview : WORLD",
"worldview : VIEW",
"sortdir : ASCENDING",
"sortdir : DESCENDING",
"sorton : X",
"sorton : Y",
"vector : X",
"vector : Y",
"vector : X0",
"vector : Y0",
"vector : Y1",
"vector : Y2",
"vector : Y3",
"vector : Y4",
"vector : Y5",
"asgn : VAR '[' expr ']' '=' expr",
"asgn : vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' SYMBOL '=' expr",
"asgn : GRAPHNO '.' SETNUM '.' vector '[' expr ']' '=' expr",
"rasgn : REGNUM '.' vector '=' expr",
"vasgn : VAR '=' vexpr",
"vasgn : vector '=' vexpr",
"vasgn : SETNUM '=' SETNUM",
"vasgn : GRAPHNO '.' SETNUM '=' SETNUM",
"vasgn : SETNUM '=' GRAPHNO '.' SETNUM",
"vasgn : GRAPHNO '.' SETNUM '=' GRAPHNO '.' SETNUM",
"vasgn : SETNUM '.' vector '=' vexpr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' vexpr",
"vasgn : VAR '=' expr",
"vasgn : vector '=' expr",
"vasgn : SETNUM '.' vector '=' expr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' expr",
"vexpr : VAR",
"vexpr : vector",
"vexpr : SETNUM '.' vector",
"vexpr : GRAPHNO '.' SETNUM '.' vector",
"vexpr : expr",
"vexpr : expr '+' expr",
"vexpr : vexpr '+' vexpr",
"vexpr : expr '+' vexpr",
"vexpr : vexpr '+' expr",
"vexpr : expr '-' expr",
"vexpr : vexpr '-' vexpr",
"vexpr : expr '-' vexpr",
"vexpr : vexpr '-' expr",
"vexpr : expr '*' expr",
"vexpr : vexpr '*' vexpr",
"vexpr : expr '*' vexpr",
"vexpr : vexpr '*' expr",
"vexpr : expr '/' expr",
"vexpr : vexpr '/' vexpr",
"vexpr : expr '/' vexpr",
"vexpr : vexpr '/' expr",
"vexpr : expr '^' expr",
"vexpr : expr '^' vexpr",
"vexpr : vexpr '^' expr",
"vexpr : vexpr '^' vexpr",
"vexpr : ABS '(' expr ')'",
"vexpr : ABS '(' vexpr ')'",
"vexpr : ACOS '(' vexpr ')'",
"vexpr : ACOSH '(' vexpr ')'",
"vexpr : ASIN '(' vexpr ')'",
"vexpr : ASINH '(' vexpr ')'",
"vexpr : ATAN '(' vexpr ')'",
"vexpr : ATANH '(' vexpr ')'",
"vexpr : ATAN2 '(' vexpr ',' vexpr ')'",
"vexpr : CEIL '(' vexpr ')'",
"vexpr : COS '(' vexpr ')'",
"vexpr : COSH '(' vexpr ')'",
"vexpr : DEG",
"vexpr : ERF '(' vexpr ')'",
"vexpr : ERFC '(' vexpr ')'",
"vexpr : EXP '(' vexpr ')'",
"vexpr : FLOOR '(' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' vexpr ')'",
"vexpr : HYPOT '(' expr ',' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' expr ')'",
"vexpr : HYPOT '(' expr ',' expr ')'",
"vexpr : INDEX",
"vexpr : SETNO",
"vexpr : INT '(' vexpr ')'",
"vexpr : INVN '(' vexpr ')'",
"vexpr : INVT '(' expr ',' NUMBER ')'",
"vexpr : INVT '(' vexpr ',' NUMBER ')'",
"vexpr : IRAND '(' NUMBER ')'",
"vexpr : LGAMMA '(' vexpr ')'",
"vexpr : LN '(' vexpr ')'",
"vexpr : LOG '(' vexpr ')'",
"vexpr : LOGISTIC '(' vexpr ',' expr ',' expr ')'",
"vexpr : MAXP '(' vexpr ',' vexpr ')'",
"vexpr : MINP '(' vexpr ',' vexpr ')'",
"vexpr : MOD '(' vexpr ',' vexpr ')'",
"vexpr : NORM '(' vexpr ')'",
"vexpr : NORMP '(' vexpr ')'",
"vexpr : PI",
"vexpr : RAD",
"vexpr : RAND",
"vexpr : RNORM '(' vexpr ',' vexpr ')'",
"vexpr : RNORM '(' expr ',' vexpr ')'",
"vexpr : RNORM '(' vexpr ',' expr ')'",
"vexpr : RNORM '(' expr ',' expr ')'",
"vexpr : SIN '(' vexpr ')'",
"vexpr : SINH '(' vexpr ')'",
"vexpr : SQR '(' vexpr ')'",
"vexpr : SQRT '(' vexpr ')'",
"vexpr : TAN '(' vexpr ')'",
"vexpr : TANH '(' vexpr ')'",
"vexpr : vexpr '?' vexpr ':' vexpr",
"vexpr : vexpr GT vexpr",
"vexpr : vexpr LT vexpr",
"vexpr : vexpr LE vexpr",
"vexpr : vexpr GE vexpr",
"vexpr : vexpr EQ vexpr",
"vexpr : vexpr NE vexpr",
"vexpr : vexpr AND vexpr",
"vexpr : vexpr OR vexpr",
"vexpr : NOT vexpr",
"vexpr : '(' vexpr ')'",
"vexpr : '-' vexpr",
"expr : NUMBER",
"expr : FITPARM",
"expr : VAR '[' expr ']'",
"expr : REGNUM '.' vector",
"expr : vector '[' expr ']'",
"expr : SETNUM '.' vector '[' expr ']'",
"expr : GRAPHNO '.' SETNUM '.' vector '[' expr ']'",
"expr : SETNUM '.' vector '.' extremetype",
"expr : GRAPHNO '.' SETNUM '.' vector '.' extremetype",
"expr : SETNUM '.' LENGTH",
"expr : SETNUM '.' vector '.' AVG",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '^' expr",
"expr : ABS '(' expr ')'",
"expr : ACOS '(' expr ')'",
"expr : ACOSH '(' expr ')'",
"expr : ASIN '(' expr ')'",
"expr : ASINH '(' expr ')'",
"expr : ATAN '(' expr ')'",
"expr : ATANH '(' expr ')'",
"expr : ATAN2 '(' expr ',' expr ')'",
"expr : CEIL '(' expr ')'",
"expr : COS '(' expr ')'",
"expr : COSH '(' expr ')'",
"expr : DEG",
"expr : ERF '(' expr ')'",
"expr : ERFC '(' expr ')'",
"expr : EXP '(' expr ')'",
"expr : FLOOR '(' expr ')'",
"expr : HYPOT '(' expr ',' expr ')'",
"expr : GRAPHNO '.' VX1",
"expr : GRAPHNO '.' VX2",
"expr : GRAPHNO '.' VY1",
"expr : GRAPHNO '.' VY2",
"expr : GRAPHNO '.' WX1",
"expr : GRAPHNO '.' WX2",
"expr : GRAPHNO '.' WY1",
"expr : GRAPHNO '.' WY2",
"expr : VX1",
"expr : VX2",
"expr : VY1",
"expr : VY2",
"expr : WX1",
"expr : WX2",
"expr : WY1",
"expr : WY2",
"expr : DX",
"expr : DY",
"expr : INDEX",
"expr : SETNO",
"expr : INT '(' expr ')'",
"expr : INVN '(' expr ')'",
"expr : INVT '(' expr ',' NUMBER ')'",
"expr : IRAND '(' NUMBER ')'",
"expr : JDAY '(' NUMBER ',' NUMBER ',' NUMBER ')'",
"expr : JDAY0 '(' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ',' NUMBER ')'",
"expr : LGAMMA '(' expr ')'",
"expr : LN '(' expr ')'",
"expr : LOG '(' expr ')'",
"expr : LOGISTIC '(' expr ',' expr ',' expr ')'",
"expr : MAXP '(' expr ',' expr ')'",
"expr : MINP '(' expr ',' expr ')'",
"expr : MOD '(' expr ',' expr ')'",
"expr : NORM '(' expr ')'",
"expr : NORMP '(' expr ')'",
"expr : PI",
"expr : RAD",
"expr : RAND",
"expr : RNORM '(' expr ',' expr ')'",
"expr : SIN '(' expr ')'",
"expr : SINH '(' expr ')'",
"expr : SQR '(' expr ')'",
"expr : SQRT '(' expr ')'",
"expr : TAN '(' expr ')'",
"expr : TANH '(' expr ')'",
"expr : expr '?' expr ':' expr",
"expr : expr GT expr",
"expr : expr LT expr",
"expr : expr LE expr",
"expr : expr GE expr",
"expr : expr EQ expr",
"expr : expr NE expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : NOT expr",
"expr : '(' expr ')'",
"expr : '-' expr",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 3780 "pars.yacc"

void fixupstr(char *val)
{
    int vl = strlen(val);
    lowtoupper(val);
    val[vl + 1] = 0;
    val[vl] = '\n';
}

void scanner(char *s, double *x, double *y, int len, double *a, double *b, double *c, double *d, int lenscr, int i, int setno, int *errpos)
{
    interr = 0;
    whichgraph = cg;
    whichset = setno;
    if (s[0] == '#') {
	return;
    }
    pos = 0;
    aa = a;
    bb = b;
    cc = c;
    dd = d;
    xx = x;
    yy = y;
    lxy = len;
    ls = lenscr;
    setindex = i + 1;
    curset = setsetno = setno;
    strcpy(f_string, s);
    fcnt = 0;
    log_results(s);
    yyparse();
    *errpos = interr;
    for (i = 0; i < fcnt; i++) {
	cfree(freelist[i]);
	freelist[i] = NULL;
    }
}

void runbatch(char *bfile)
{
    double x, y;
    int errpos;
    char stext[256];
    FILE *fp;
    if (strcmp("stdin", bfile)) {
	fp = fopen(bfile, "r");
    }
    else {
	fp = stdin;
    }
    if (fp == NULL) {
        fprintf(stderr, "Error opening batch file \"%s\"\n", bfile);
        exit(1);
    }
    while(fgets(stext, 255, fp) != NULL) {
        if (stext[0] == '#') {
            continue;
        }
	if (strlen(stext) == 0) {
	    continue;
	}
        lowtoupper(stext);
/* TODO check on 0, 0 here for index and setno */
        scanner(stext, &x, &y, 1, ax, bx, cx, dx, 1, 0, 0, &errpos);
        stext[0] = 0;
        if (gotparams && paramfile[0]) {
            if (!getparms(cg, paramfile)) {
            }
            gotparams = 0;
        } else if (gotread && readfile[0]) {
            if (getdata(cg, readfile, readsrc, readtype)) {
#ifndef GRBATCH
                drawgraph();
#endif
            }
            gotread = 0;
        }
    }
    if (fp != stdin) {
	fclose(fp);
    }
}

symtab_entry key[] = {
	"A", VAR,
	"A0", FITPARM,
	"A1", FITPARM,
	"A2", FITPARM,
	"A3", FITPARM,
	"A4", FITPARM,
	"A5", FITPARM,
	"A6", FITPARM,
	"A7", FITPARM,
	"A8", FITPARM,
	"A9", FITPARM,
	"ABORT", ABORT,
	"ABOVE", ABOVE,
	"ABS", ABS,
	"ABSOLUTE", ABSOLUTE,
	"ACOS", ACOS,
	"ACOSH", ACOSH,
	"ACTIVATE", ACTIVATE,
	"ACTIVE", ACTIVE,
	"ALT", ALT,
	"ALTERNATE", ALTERNATE,
	"ALTXAXIS", ALTXAXIS,
	"ALTYAXIS", ALTYAXIS,
	"AND", AND,
	"ANGLE", ANGLE,
	"ANNOTATE", ANNOTATE,
	"APPEND", APPEND,
	"AREA", AREA,
	"ARRANGE", ARRANGE,
	"ARROW", ARROW,
	"ASCENDING", ASCENDING,
	"ASIN", ASIN,
	"ASINH", ASINH,
	"ATAN", ATAN,
	"ATANH", ATANH,
	"ATAN2", ATAN2,
	"AUTO", AUTO,
	"AUTOSCALE", AUTOSCALE,
	"AUTOTICKS", AUTOTICKS,
	"AVG", AVG,
	"AXES", AXES,
	"AXIS", AXIS,
	"B", VAR,
	"BACKBUFFER", BACKBUFFER,
	"BACKGROUND", BACKGROUND,
	"BAR", BAR,
	"BATCH", BATCH,
	"BELOW", BELOW,
	"BIN", BIN,
	"BLOCK", BLOCK,
	"BOTH", BOTH,
	"BOTTOM", BOTTOM,
	"BOX", BOX,
	"BOXPLOT", BOXPLOT,
	"C", VAR,
	"CD", CD,
	"CEIL", CEIL,
	"CELLS", CELLS,
	"CENTER", CENTER,
	"CHAR", CHAR,
	"CHRSTR", CHRSTR,
	"CLEAR", CLEAR,
	"CLICK", CLICK,
	"CMAP", CMAP,
	"CO", COLOR,
	"COLOR", COLOR,
	"COMMENT", COMMENT,
	"COPY", COPY,
	"COS", COS,
	"COSH", COSH,
	"CYCLE", CYCLE,
	"D", VAR,
	"DAYMONTH", DAYMONTH,
	"DAYOFWEEKL", DAYOFWEEKL,
	"DAYOFWEEKS", DAYOFWEEKS,
	"DAYOFYEAR", DAYOFYEAR,
	"DDMMYY", DDMMYY,
	"DECIMAL", DECIMAL,
	"DEF", DEF,
	"DEFAULT", DEFAULT,
	"DEG", DEG,
	"DEGREESLAT", DEGREESLAT,
	"DEGREESLON", DEGREESLON,
	"DEGREESMMLAT", DEGREESMMLAT,
	"DEGREESMMLON", DEGREESMMLON,
	"DEGREESMMSSLAT", DEGREESMMSSLAT,
	"DEGREESMMSSLON", DEGREESMMSSLON,
	"DELAY", DELAYP,
	"DELETE", DELETE,
	"DESCENDING", DESCENDING,
	"DEVICE", DEVICE,
	"DFT", DFT,
	"DIFF", DIFFERENCE,
	"DIFFERENCE", DIFFERENCE,
	"DISK", DISK,
	"DOUBLEBUFFER", DOUBLEBUFFER,
	"DOWN", DOWN,
	"DRAW2", DRAW2,
	"DROP", DROP,
	"DX", DX,
	"DXDX", DXDX,
	"DY", DY,
	"DYDY", DYDY,
	"ECHO", ECHO,
	"EDIT", EDIT,
	"ELLIPSE", ELLIPSE,
	"ELSE", ELSE,
	"END", END,
	"EQ", EQ,
	"ER", ERRORBAR,
	"ERF", ERF,
	"ERFC", ERFC,
	"ERRORBAR", ERRORBAR,
	"EXIT", EXIT,
	"EXP", EXP,
	"EXPONENTIAL", EXPONENTIAL,
	"FALSE", FALSEP,
	"FFT", FFT,
	"FILE", FILEP,
	"FILL", FILL,
	"FIND", FIND,
	"FIXED", FIXED,
	"FIXEDPOINT", FIXEDPOINT,
	"FLOOR", FLOOR,
	"FLUSH", FLUSH,
	"FOCUS", FOCUS,
	"FOLLOWS", FOLLOWS,
	"FONT", FONTP,
	"FOREGROUND", FOREGROUND,
	"FORMAT", FORMAT,
	"FRAME", FRAMEP,
	"FREE", FREE,
	"FRONTBUFFER", FRONTBUFFER,
	"GE", GE,
	"GENERAL", GENERAL,
	"GETP", GETP,
	"GRAPH", GRAPH,
	"GRAPHS", GRAPHS,
	"GRAPHTYPE", GRAPHTYPE,
	"GRID", GRID,
	"GT", GT,
	"HARDCOPY", HARDCOPY,
	"HBAR", HBAR,
	"HBOXPLOT", HBOXPLOT,
	"HGAP", HGAP,
	"HIDDEN", HIDDEN,
	"HISTO", HISTO,
	"HMS", HMS,
	"HORIZONTAL", HORIZONTAL,
	"HPGLL", HPGLL,
	"HPGLP", HPGLP,
	"HYPOT", HYPOT,
	"IF", IF,
	"IGNORE", IGNORE,
	"IHL", IHL,
	"IMAGE", IMAGE,
	"IN", IN,
	"INDEX", INDEX,
	"INIT", INIT,
	"INOUT", INOUT,
	"INT", INT,
	"INTEGRATE", INT,
	"INTERP", INTERP,
	"INUM", INUM,
	"INVDFT", INVDFT,
	"INVFFT", INVFFT,
	"INVN", INVN,
	"INVT", INVT,
	"IRAND", IRAND,
	"JDAY", JDAY,
	"JDAY0", JDAY0,
	"JUST", JUST,
	"KILL", KILL,
	"LABEL", LABEL,
	"LANDSCAPE", LANDSCAPE,
	"LAYOUT", LAYOUT,
	"LE", LE,
	"LEAVE", LEAVE,
	"LEFT", LEFT,
	"LEGEND", LEGEND,
	"LENGTH", LENGTH,
	"LEVEL", LEVEL,
	"LEVELS", LEVELS,
	"LGAMMA", LGAMMA,
	"LINE", LINE,
	"LINESTYLE", LINESTYLE,
	"LINETO", LINETO,
	"LINEWIDTH", LINEWIDTH,
	"LINK", LINK,
	"LN", LN,
	"LOAD", LOAD,
	"LOCATOR", LOCATOR,
	"LOCATORBAR", LOCATORBAR,
	"LOCTYPE", LOCTYPE,
	"LOG", LOG,
	"LOGISTIC", LOGISTIC,
	"LOGX", LOGX,
	"LOGXY", LOGXY,
	"LOGY", LOGY,
	"LS", LINESTYLE,
	"LT", LT,
	"LW", LINEWIDTH,
	"MAJOR", MAJOR,
	"MAX", MAXP,
	"MIFL", MIFL,
	"MIFP", MIFP,
	"MIN", MINP,
	"MINOR", MINOR,
	"MISSING", MISSINGP,
	"MMDD", MMDD,
	"MMDDHMS", MMDDHMS,
	"MMDDYY", MMDDYY,
	"MMDDYYHMS", MMDDYYHMS,
	"MMSSLAT", MMSSLAT,
	"MMSSLON", MMSSLON,
	"MMYY", MMYY,
	"MOD", MOD,
	"MONTHDAY", MONTHDAY,
	"MONTHL", MONTHL,
	"MONTHS", MONTHS,
	"MONTHSY", MONTHSY,
	"MOVE", MOVE,
	"MOVE2", MOVE2,
	"MOVETO", MOVETO,
	"NE", NE,
	"NEGATE", NEGATE,
	"NO", NO,
	"NONE", NONE,
	"NORM", NORM,
	"NORMAL", NORMAL,
	"NORMP", NORMP,
	"NOT", NOT,
	"NUMBER", NUMBER,
	"NXY", NXY,
	"OFF", OFF,
	"OFFSETX", OFFSETX,
	"OFFSETY", OFFSETY,
	"ON", ON,
	"OP", OP,
	"OR", OR,
	"ORIENT", ORIENT,
	"OUT", OUT,
	"PAGE", PAGE,
	"PARA", PARA,
	"PARALLEL", PARALLEL,
	"PARAMETERS", PARAMETERS,
	"PARAMS", PARAMS,
	"PATTERN", PATTERN,
	"PERIMETER", PERIMETER,
	"PERP", PERP,
	"PERPENDICULAR", PERPENDICULAR,
	"PI", PI,
	"PIE", PIE,
	"PIPE", PIPE,
	"PLACE", PLACE,
	"POINT", POINT,
	"POLAR", POLAR,
	"POLY", POLY,
	"POLYI", POLYI,
	"POLYO", POLYO,
	"POP", POP,
	"PORTRAIT", PORTRAIT,
	"POWER", POWER,
	"PREC", PREC,
	"PREPEND", PREPEND,
	"PRINT", PRINT,
	"PS", PS,
	"PSCOLORL", PSCOLORL,
	"PSCOLORP", PSCOLORP,
	"PSMONOL", PSMONOL,
	"PSMONOP", PSMONOP,
	"PUSH", PUSH,
	"PUTP", PUTP,
	"RAD", RAD,
	"RAND", RAND,
	"RAWSPICE", RAWSPICE,
	"READ", READ,
	"REDRAW", REDRAW,
	"REGRESS", REGRESS,
	"RENDER", RENDER,
	"REVERSE", REVERSE,
	"RIGHT", RIGHT,
	"RISER", RISER,
	"RNORM", RNORM,
	"ROT", ROT,
	"RUNAVG", RUNAVG,
	"RUNMAX", RUNMAX,
	"RUNMED", RUNMED,
	"RUNMIN", RUNMIN,
	"RUNSTD", RUNSTD,
	"SAMPLE", SAMPLE,
	"SAVEALL", SAVEALL,
	"SCALE", SCALE,
	"SCIENTIFIC", SCIENTIFIC,
	"SET", SET,
	"SETNO", SETNO,
	"SETS", SETS,
	"SIGN", SIGN,
	"SIN", SIN,
	"SINH", SINH,
	"SIZE", SIZE,
	"SKIP", SKIP,
	"SLEEP", SLEEP,
	"SLICE", SLICE,
	"SORT", SORT,
	"SOURCE", SOURCE,
	"SPEC", SPEC,
	"SPECIFIED", SPECIFIED,
	"SPECTRUM", SPECTRUM,
	"SPLINE", SPLINE,
	"SQR", SQR,
	"SQRT", SQRT,
	"STACK", STACK,
	"STACKEDBAR", STACKEDBAR,
	"STACKEDHBAR", STACKEDHBAR,
	"STACKEDLINE", STACKEDLINE,
	"STAGGER", STAGGER,
	"START", START,
	"STARTTYPE", STARTTYPE,
	"STATUS", STATUS,
	"STATUSBAR", STATUSBAR,
	"STOP", STOP,
	"STRING", STRING,
	"SUBTITLE", SUBTITLE,
	"SWAPBUFFER", SWAPBUFFER,
	"SYMBOL", SYMBOL,
	"TAN", TAN,
	"TANH", TANH,
	"TICK", TICKP,
	"TICKLABEL", TICKLABEL,
	"TICKMARKS", TICKMARKS,
	"TIME", TIME,
	"TITLE", TITLE,
	"TO", TO,
	"TOOLBAR", TOOLBAR,
	"TOP", TOP,
	"TRUE", TRUEP,
	"TSV", TSV,
	"TYPE", TYPE,
	"UP", UP,
	"VAR", VAR,
	"VELOCITY", VELOCITY,
	"VERTICAL", VERTICAL,
	"VGAP", VGAP,
	"VIEW", VIEW,
	"VX1", VX1,
	"VX2", VX2,
	"VY1", VY1,
	"VY2", VY2,
	"WITH", WITH,
	"WORLD", WORLD,
	"WRITE", WRITE,
	"WX1", WX1,
	"WX2", WX2,
	"WY1", WY1,
	"WY2", WY2,
	"X", X,
	"X0", X0,
	"X1", X1,
	"XAXES", XAXES,
	"XAXIS", XAXIS,
	"XCOR", XCOR,
	"XMAX", XMAX,
	"XMIN", XMIN,
	"XY", XY,
	"XYARC", XYARC,
	"XYBOX", XYBOX,
	"XYBOXPLOT", XYBOXPLOT,
	"XYDX", XYDX,
	"XYDXDX", XYDXDX,
	"XYDXDY", XYDXDY,
	"XYDY", XYDY,
	"XYDYDY", XYDYDY,
	"XYFIXED", XYFIXED,
	"XYHILO", XYHILO,
	"XYRT", XYRT,
	"XYSEG", XYSEG,
	"XYSTRING", XYSTRING,
	"XYUV", XYUV,
	"XYX2Y2", XYX2Y2,
	"XYXX", XYXX,
	"XYYY", XYYY,
	"XYZ", XYZ,
	"XYZW", XYZW,
	"Y", Y,
	"Y0", Y0,
	"Y1", Y1,
	"Y2", Y2,
	"Y3", Y3,
	"Y4", Y4,
	"Y5", Y5,
	"YAXES", YAXES,
	"YAXIS", YAXIS,
	"YES", YES,
	"YMAX", YMAX,
	"YMIN", YMIN,
	"YYMMDD", YYMMDD,
	"YYMMDDHMS", YYMMDDHMS,
	"ZEROXAXIS", ZEROXAXIS,
	"ZEROYAXIS", ZEROYAXIS,
};

int maxparms = sizeof(key) / sizeof(symtab_entry);
int maxfunc = sizeof(key) / sizeof(symtab_entry);

int findf(symtab_entry *key, char *s, int tlen)
{

    int low, high, mid;

    low = 0;
    high = tlen - 1;
    while (low <= high) {
	mid = (low + high) / 2;
	if (strcmp(s, key[mid].s) < 0) {
	    high = mid - 1;
	} else {
	    if (strcmp(s, key[mid].s) > 0) {
		low = mid + 1;
	    } else {
		return (mid);
	    }
	}
    }
    return (-1);
}

int getcharstr(void)
{
    if (pos >= strlen(f_string))
	 return EOF;
    return (f_string[pos++]);
}

void ungetchstr(void)
{
    if (pos > 0)
	pos--;
}

int yylex(void)
{
    int c, i;
    int found;
    static char s[256];
    char sbuf[256];
    char *str;

    while ((c = getcharstr()) == ' ' || c == '\t');
    if (c == EOF) {
	return (0);
    }
    if (c == '"') {
	i = 0;
	while ((c = getcharstr()) != '"' && c != EOF) {
	    if (c == '\\') {
		int ctmp;
		ctmp = getcharstr();
		if (ctmp != '"') {
		    ungetchstr();
		}
		else {
		    c = ctmp;
		}
	    }
	    s[i] = c;
	    i++;
	}
	if (c == EOF) {
	    yyerror("Nonterminating string");
	    return 0;
	}
	s[i] = '\0';
	str = (char *) malloc(strlen(s) + 1);
	strcpy(str, s);
	yylval.str = str;
	return CHRSTR;
    }
    if (c == '.' || isdigit(c)) {
	char stmp[80];
	double d;
	int i, gotdot = 0;

	i = 0;
	while (c == '.' || isdigit(c)) {
	    if (c == '.') {
		if (gotdot) {
		    yyerror("Reading number, too many dots");
	    	    return 0;
		} else {
		    gotdot = 1;
		}
	    }
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (c == 'E' || c == 'e') {
	    stmp[i++] = c;
	    c = getcharstr();
	    if (c == '+' || c == '-') {
		stmp[i++] = c;
		c = getcharstr();
	    }
	    while (isdigit(c)) {
		stmp[i++] = c;
		c = getcharstr();
	    }
	}
	if (gotdot && i == 1) {
	    ungetchstr();
	    return '.';
	}
	stmp[i] = '\0';
	ungetchstr();
	sscanf(stmp, "%lf", &d);
	yylval.val = d;
	return NUMBER;
    }
/* graphs, sets, regions resp. */
    if (c == 'G' || c == 'S' || c == 'R') {
	char stmp[80];
	int i = 0, ctmp = c, gn, sn, rn;
	c = getcharstr();
	while (isdigit(c)) {
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (i == 0) {
	    c = ctmp;
	    ungetchstr();
	} else {
	    ungetchstr();
	    if (ctmp == 'G') {
	        stmp[i] = '\0';
		gn = atoi(stmp);
		if (gn >= 0 && gn < maxgraph) {
		    yylval.ival = gn;
		    whichgraph = gn;
		    return GRAPHNO;
		}
	    } else if (ctmp == 'S') {
	        stmp[i] = '\0';
		sn = atoi(stmp);
		if (sn >= 0 && sn < g[cg].maxplot) {
		    lxy = getsetlength(cg, sn);
		    yylval.ival = sn;
		    whichset = sn;
		    return SETNUM;
		}
	    } else if (ctmp == 'R') {
	        stmp[i] = '\0';
		rn = atoi(stmp);
		if (rn >= 0 && rn < MAXREGION) {
		    yylval.ival = rn;
		    return REGNUM;
		}
	    }
	}
    }
    if (isalpha(c)) {
	char *p = sbuf;

	do {
	    *p++ = c;
	} while ((c = getcharstr()) != EOF && isalnum(c));
	ungetchstr();
	*p = '\0';
        if (debuglevel == 2) {
	    printf("->%s<-\n", sbuf);
	}
	if ((found = findf(key, sbuf, maxfunc)) >= 0) {
	    if (key[found].type == VAR) {
		switch (sbuf[0]) {
		case 'A':
		    yylval.ptr = aa;
		    return VAR;
		case 'B':
		    yylval.ptr = bb;
		    return VAR;
		case 'C':
		    yylval.ptr = cc;
		    return VAR;
		case 'D':
		    yylval.ptr = dd;
		    return VAR;
		}
	    }
	    else if (key[found].type == FITPARM) {
		int index = sbuf[1] - '0';
		yylval.val = nonl_parms[index];
		return FITPARM;
	    }
	    else { /* set up special cases */
		switch (key[found].type) {
		case XAXIS:
		    naxis = 0;
		    break;
		case YAXIS:
		    naxis = 1;
		    break;
		case ZEROXAXIS:
		    naxis = 2;
		    break;
		case ZEROYAXIS:
		    naxis = 3;
		    break;
		case ALTXAXIS:
		    naxis = 4;
		    break;
		case ALTYAXIS:
		    naxis = 5;
		    break;
		case AXES:
		    naxis = 6;
		    break;
		case XAXES:
		    naxis = 7;
		    break;
		case YAXES:
		    naxis = 8;
		    break;
		case GRAPHS:
		    yylval.ival = -1;
		    whichgraph = -1;
		    return GRAPHS;
		    break;
		case SETS:
		    yylval.ival = -1;
		    whichset = -1;
		    return SETS;
		    break;
		default:
		    break;
		}
	    }
	    yylval.func = key[found].type;
	    return key[found].type;
	} else {
	    strcat(sbuf, ": No such function or variable");
	    yyerror(sbuf);
	    return 0;
	}
    }
    switch (c) {
    case '>':
	return follow('=', GE, GT);
    case '<':
	return follow('=', LE, LT);
    case '=':
	return follow('=', EQ, '=');
    case '!':
	return follow('=', NE, NOT);
    case '|':
	return follow('|', OR, '|');
    case '&':
	return follow('&', AND, '&');
    case '\n':
	return '\n';
    default:
	return c;
    }
}

int follow(int expect, int ifyes, int ifno)
{
    int c = getcharstr();

    if (c == expect) {
	return ifyes;
    }
    ungetchstr();
    return ifno;
}

void yyerror(char *s)
{
    int i;
    char buf[256];
    sprintf(buf, "%s: %s", s, f_string);
    i = strlen(buf);
    buf[i - 1] = 0;
    errmsg(buf);
    interr = 1;
}

#define C1 0.1978977093962766
#define C2 0.1352915131768107

double rnorm(double mean, double sdev)
{
    double u = drand48();

    return mean + sdev * (pow(u, C2) - pow(1.0 - u, C2)) / C1;
}

double fx(double x)
{
    return 1.0 / sqrt(2.0 * M_PI) * exp(-x * x * 0.5);
}

double normp(double b, double *s)
{
    double sum, dx, a = -8.0, fx(double x);
    int i, n = 48;

    sum = fx(a) + fx(b);
    dx = (b - a) / n;
    for (i = 1; i <= ((n - 1) / 2); i++)
	sum = sum + 4.0 * fx(a + (2.0 * i - 1.0) * dx) + 2.0 * fx(a + 2.0 * i * dx);
    sum = sum + 4.0 * fx(b - dx);
    *s = fx(b);
    return sum * dx / 3.0;
}

double invnorm(double p)
{
    double s, x, z, normp(double b, double *s);

    if (p > 0.5)
	x = 1.0 - p;
    else
	x = p;
    s = sqrt(-2.0 * log(x));
    x = ((-7.49101 * s - 448.047) * s - 1266.846);
    x = x / (((s + 109.8371) * s + 748.189) * s + 498.003) + s;
    if (p < 0.5)
	x = -x;
    z = p - normp(x, &s);
    z = z / s;
    s = x * x;
    return (((((((((720.0 * s + 2556.0) * s + 1740.0) * s + 127.0) * z / 7.0 +
		 ((120.0 * s + 326.0) * s + 127.0) * x) * z / 6.0 + (24 * s + 46.0) * s + 7.0) * z / 40.0 +
	       (0.75 * s + 0.875) * x) * z + s + 0.5) * z / 3.0 + x * 0.5) * z + 1.0) * z + x + 0.832e-24 * x;
}

double invt(double p, int n)
{
    double sign, temp, a, b, c, d, x, y;

    sign = 1.0;
    if (p < 0.5) {
	p = 1.0 - p;
	sign = -1.0;
    }
    p = (1 - p) * 2;
    if (n == 2) {
	temp = sqrt(2.0 / (p * (2.0 - p)) - 2.0);
	temp = sign * temp;
	return temp;
    } else if (n == 1) {
	p = p * M_PI / 2.0;
	return sign * cos(p) / sin(p);
    } else {
	a = 1.0 / (n - 0.5);
	b = 48.0 / (a * a);
	c = ((20700 * a / b - 98.0) * a - 16.0) * a + 96.36;
	d = ((94.5 / (b + c) - 3.0) / b + 1.0) * sqrt(a * M_PI / 2.0) * n;
	x = d * p;
	y = exp((2.0 / n) * log(x));
	if (y > (0.05 + a)) {
	    x = invnorm(p * 0.5);
	    y = x * x;
	    if (n < 5)
		c = c + 0.3 * (n - 4.5) * (x + 0.6);
	    c = (((0.05 * d * x - 5.0) * x - 7.0) * x - 2.0) * x + b + c;
	    y = (((((0.4 * y + 6.3) * y + 36.0) * y + 94.5) / c - y - 3.0) / b + 1.0) * x;
	    y = a * y * y;
	    if (y > 0.002)
		y = exp(y) - 1.0;
	    else
		y = 0.5 * y * y + y;
	} else
	    y = ((1.0 / (((n + 0.6) / (n * y) - 0.089 * d - 0.822) * (n + 2.0) * 3.0) + 0.5 / (n + 4.0)) * y - 1.0) * (n + 1.0) / (n + 2.0) + 1.0 / y;
	return sign * sqrt(n * y);
    }
}

/*
 * return a pointer to the array given by v
 */
double *getvptr(int gno, int setno, int v)
{
    switch (v) {
    case X:
    case X0:
	return g[gno].p[setno].ex[0];
	break;
    case Y:
    case Y0:
	return g[gno].p[setno].ex[1];
	break;
    case Y1:
	return g[gno].p[setno].ex[2];
	break;
    case Y2:
	return g[gno].p[setno].ex[3];
	break;
    case Y3:
	return g[gno].p[setno].ex[4];
	break;
    case Y4:
	return g[gno].p[setno].ex[5];
	break;
    case Y5:
	return g[gno].p[setno].ex[6];
	break;
    }
    return NULL;
}
#line 5660 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 529 "pars.yacc"
{
	    result = yyvsp[-1].val;
	}
break;
case 6:
#line 532 "pars.yacc"
{
	    result = *yyvsp[-1].ptr;
	}
break;
case 13:
#line 541 "pars.yacc"
{
	    return 1;
	}
break;
case 14:
#line 547 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, (char *) yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 15:
#line 556 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, (char *) yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 16:
#line 565 "pars.yacc"
{
	    if (yyvsp[0].pset == FILEP) {
		set_printer(FILEP, NULL);
	    }
	    else {
		set_printer(yyvsp[0].pset, NULL);
	    }
	}
break;
case 17:
#line 573 "pars.yacc"
{
	    tdevice = (int) yyvsp[0].val;
	}
break;
case 18:
#line 576 "pars.yacc"
{
	    hdevice = (int) yyvsp[0].val;
	}
break;
case 19:
#line 579 "pars.yacc"
{
	    do_hardcopy();
	}
break;
case 20:
#line 583 "pars.yacc"
{ 
	    extern int pslwfactor; /* fudge factor for linewidths in the PS driver */
	    pslwfactor = yyvsp[0].val; 
	}
break;
case 21:
#line 590 "pars.yacc"
{ yyval.pset = GR_PS_P; }
break;
case 22:
#line 591 "pars.yacc"
{ yyval.pset = GR_PS_L; }
break;
case 23:
#line 592 "pars.yacc"
{ yyval.pset = GR_MIF_P; }
break;
case 24:
#line 593 "pars.yacc"
{ yyval.pset = GR_MIF_L; }
break;
case 25:
#line 594 "pars.yacc"
{ yyval.pset = GR_HPGL_P; }
break;
case 26:
#line 595 "pars.yacc"
{ yyval.pset = GR_HPGL_L; }
break;
case 27:
#line 596 "pars.yacc"
{ yyval.pset = hdevice; }
break;
case 28:
#line 597 "pars.yacc"
{ yyval.pset = FILEP; }
break;
case 29:
#line 601 "pars.yacc"
{
	    rg[yyvsp[-1].pset].active = yyvsp[0].pset;
	}
break;
case 30:
#line 604 "pars.yacc"
{
	    rg[yyvsp[-2].pset].type = yyvsp[0].pset;
	}
break;
case 31:
#line 607 "pars.yacc"
{
	    rg[yyvsp[-2].pset].color = checkon(COLOR, rg[yyvsp[-2].pset].color, (int) yyvsp[0].val);
	}
break;
case 32:
#line 610 "pars.yacc"
{
	    rg[yyvsp[-2].pset].lines = checkon(LINESTYLE, rg[yyvsp[-2].pset].lines, (int) yyvsp[0].val);
	}
break;
case 33:
#line 613 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linew = checkon(LINEWIDTH, rg[yyvsp[-2].pset].linew, (int) yyvsp[0].val);
	}
break;
case 34:
#line 617 "pars.yacc"
{
	    rg[yyvsp[-8].pset].x1 = yyvsp[-6].val;
	    rg[yyvsp[-8].pset].y1 = yyvsp[-4].val;
	    rg[yyvsp[-8].pset].x2 = yyvsp[-2].val;
	    rg[yyvsp[-8].pset].y2 = yyvsp[0].val;
	}
break;
case 35:
#line 624 "pars.yacc"
{
	    if (rg[yyvsp[-4].pset].x == NULL || rg[yyvsp[-4].pset].n == 0) {
		rg[yyvsp[-4].pset].n = 0;
		rg[yyvsp[-4].pset].x = (double *) calloc(1, sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) calloc(1, sizeof(double));
	    } else {
		rg[yyvsp[-4].pset].x = (double *) realloc(rg[yyvsp[-4].pset].x, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) realloc(rg[yyvsp[-4].pset].y, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
	    }
	    rg[yyvsp[-4].pset].x[rg[yyvsp[-4].pset].n] = yyvsp[-2].val;
	    rg[yyvsp[-4].pset].y[rg[yyvsp[-4].pset].n] = yyvsp[0].val;
	    rg[yyvsp[-4].pset].n++;
	}
break;
case 36:
#line 637 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linkto[yyvsp[0].pset] = TRUE;
	}
break;
case 37:
#line 643 "pars.yacc"
{
#ifndef GRBATCH
	    drawgraph();
#endif
	}
break;
case 38:
#line 648 "pars.yacc"
{
	    auto_redraw = (yyvsp[0].pset == ON);
	}
break;
case 39:
#line 651 "pars.yacc"
{
	    char buf[MAXPATHLEN];
	    strcpy(buf, (char *) yyvsp[0].pset);
	    expand_tilde(buf); 
	    if (chdir(buf) >= 0) {
		strcpy(workingdir, buf);
	    	if (inwin) {
#ifndef GRBATCH
		    set_title(workingdir);
#endif
	        }
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 40:
#line 665 "pars.yacc"
{
	    if (inwin) {
#ifndef GRBATCH
		set_left_footer((char *) yyvsp[0].pset);
#endif
	    }
	    else {
		printf("%s\n", (char *) yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 41:
#line 676 "pars.yacc"
{
#ifndef GRBATCH
	    update_stuff_status();
#endif
	}
break;
case 42:
#line 681 "pars.yacc"
{
	    setbgcolor((int) yyvsp[0].val);
	}
break;
case 43:
#line 684 "pars.yacc"
{
#ifndef GRBATCH
	    xlibsetcmap((int) yyvsp[-6].val, (int) yyvsp[-4].val, (int) yyvsp[-2].val, (int) yyvsp[0].val);
#endif
	}
break;
case 44:
#line 689 "pars.yacc"
{
	    exit(0);
	}
break;
case 45:
#line 693 "pars.yacc"
{
#ifndef GRBATCH
            set_pagelayout(yyvsp[0].pset);
#endif
        }
break;
case 46:
#line 699 "pars.yacc"
{
#ifndef GRBATCH
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
#endif
        }
break;
case 47:
#line 705 "pars.yacc"
{
#ifndef GRBATCH
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
#endif
        }
break;
case 48:
#line 711 "pars.yacc"
{
#ifndef GRBATCH
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
#endif
        }
break;
case 49:
#line 717 "pars.yacc"
{
	    if (inwin) {
		my_draw2((double) yyvsp[-2].val, (double) yyvsp[0].val);
#ifndef GRBATCH
		flush_pending();
#endif
	    }
	}
break;
case 50:
#line 725 "pars.yacc"
{
	    if (inwin) {
		my_move2((double) yyvsp[-2].val, (double) yyvsp[0].val);
	    }
	}
break;
case 51:
#line 730 "pars.yacc"
{
	    if (inwin) {
		double x = (double) yyvsp[-4].val;
		double y = (double) yyvsp[-2].val;
		drawpolysym(&x, &y, 1, (int) yyvsp[0].val, 0, 0, 1.0);
#ifndef GRBATCH
		flush_pending();
#endif
	    }
	}
break;
case 52:
#line 740 "pars.yacc"
{
	    if (inwin) {
		setcolor((int) yyvsp[0].val);
	    }
	}
break;
case 53:
#line 745 "pars.yacc"
{
	    if (inwin) {
		setlinewidth((int) yyvsp[0].val);
	    }
	}
break;
case 54:
#line 750 "pars.yacc"
{
	    if (inwin) {
		setlinestyle((int) yyvsp[0].val);
	    }
	}
break;
case 55:
#line 755 "pars.yacc"
{
	}
break;
case 56:
#line 759 "pars.yacc"
{
	    switch (yyvsp[0].pset) {
	    case UP:
		gwindup_proc();
		break;
	    case DOWN:
		gwinddown_proc();
		break;
	    case RIGHT:
		gwindright_proc();
		break;
	    case LEFT:
		gwindleft_proc();
		break;
	    case IN:
		gwindshrink_proc();
		break;
	    case OUT:
		gwindexpand_proc();
		break;
	    }
	}
break;
case 57:
#line 781 "pars.yacc"
{
	    scroll_proc((int) yyvsp[0].val);
	}
break;
case 58:
#line 784 "pars.yacc"
{
	    scrollinout_proc((int) yyvsp[0].val);
	}
break;
case 59:
#line 787 "pars.yacc"
{
	    scrolling_islinked = yyvsp[0].pset == ON;
	}
break;
case 60:
#line 790 "pars.yacc"
{
#ifndef GRBATCH
	    my_doublebuffer(yyvsp[0].pset == TRUEP);
#endif
	}
break;
case 61:
#line 795 "pars.yacc"
{
#ifndef GRBATCH
	    my_frontbuffer(yyvsp[0].pset == TRUEP);
#endif
	}
break;
case 62:
#line 800 "pars.yacc"
{
#ifndef GRBATCH
	    my_backbuffer(yyvsp[0].pset == TRUEP);
#endif
	}
break;
case 63:
#line 805 "pars.yacc"
{
#ifndef GRBATCH
	    my_swapbuffer();
#endif
	}
break;
case 64:
#line 810 "pars.yacc"
{
	    sleep((int) yyvsp[0].val);
	}
break;
case 65:
#line 813 "pars.yacc"
{	/* TODO add delay function */
	}
break;
case 66:
#line 815 "pars.yacc"
{		/* TODO add abort flag and function */
	}
break;
case 67:
#line 818 "pars.yacc"
{
	    gotparams = TRUE;
	    strcpy(paramfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 68:
#line 824 "pars.yacc"
{
	    if (!fexists((char *) yyvsp[0].pset)) {
		FILE *pp = fopen((char *) yyvsp[0].pset, "w");
		if (pp != NULL) {
		    putparms(cg, pp, 0);
		    fclose(pp);
		} else {
		    errmsg("Unable to write parameter file");
		}
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 69:
#line 836 "pars.yacc"
{
	    cg = (int) yyvsp[0].pset;
	    g[cg].parmsread = TRUE;
	    change_gno = cg;
	}
break;
case 70:
#line 841 "pars.yacc"
{
	    curset = (int) yyvsp[0].pset;
	}
break;
case 71:
#line 846 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 72:
#line 850 "pars.yacc"
{
	    set_hotlink(yyvsp[-5].pset, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 73:
#line 854 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL, 0);
	}
break;
case 74:
#line 857 "pars.yacc"
{
	    set_hotlink(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL, 0);
	}
break;
case 75:
#line 860 "pars.yacc"
{
	    do_activateset(cg, yyvsp[-1].pset, (int) yyvsp[0].val);
	}
break;
case 76:
#line 863 "pars.yacc"
{
	    do_activateset(yyvsp[-3].pset, yyvsp[-1].pset, (int) yyvsp[0].val);
	}
break;
case 77:
#line 866 "pars.yacc"
{
	    setlength(cg, yyvsp[-2].pset, (int) yyvsp[0].val);
	    updatesetminmax(cg, yyvsp[-2].pset);
#ifndef GRBATCH
	    update_set_status(cg, yyvsp[-2].pset);
#endif
	}
break;
case 78:
#line 873 "pars.yacc"
{
	    setlength(yyvsp[-4].pset, yyvsp[-2].pset, (int) yyvsp[0].val);
	    updatesetminmax(yyvsp[-4].pset, yyvsp[-2].pset);
#ifndef GRBATCH
	    update_set_status(yyvsp[-4].pset, yyvsp[-2].pset);
#endif
	}
break;
case 79:
#line 880 "pars.yacc"
{
	    add_point(cg, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 80:
#line 883 "pars.yacc"
{
	    add_point(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 81:
#line 887 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(cg, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 82:
#line 895 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(yyvsp[-6].pset, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 83:
#line 903 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[-2].pset)) {
	        sortset(cg, yyvsp[-2].pset, yyvsp[-1].pset, yyvsp[0].pset == ASCENDING ? 0 : 1);
	    } else {
		errmsg("Set not active!");
	    }
	}
break;
case 84:
#line 910 "pars.yacc"
{
	    do_copyset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset);
	}
break;
case 85:
#line 913 "pars.yacc"
{
	    do_copyset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 86:
#line 916 "pars.yacc"
{
	    do_moveset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset);
	}
break;
case 87:
#line 919 "pars.yacc"
{
	    do_moveset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 88:
#line 923 "pars.yacc"
{
	    killset(cg, yyvsp[0].pset);
	}
break;
case 89:
#line 927 "pars.yacc"
{
	    int i;
	    for (i = 0; i < g[cg].maxplot; i++) {
		killset(cg, i);
	    }
	}
break;
case 90:
#line 933 "pars.yacc"
{ softkillset(cg, yyvsp[-1].pset); }
break;
case 91:
#line 935 "pars.yacc"
{
	    int i;
	    for (i = 0; i < g[cg].maxplot; i++) {
		softkillset(cg, i);
	    }
	}
break;
case 92:
#line 941 "pars.yacc"
{ kill_graph(yyvsp[0].pset); }
break;
case 93:
#line 942 "pars.yacc"
{ kill_graph(maxgraph); }
break;
case 94:
#line 943 "pars.yacc"
{ wipeout(0); }
break;
case 95:
#line 944 "pars.yacc"
{ arrange_graphs((int) yyvsp[-2].val, (int) yyvsp[0].val); }
break;
case 96:
#line 946 "pars.yacc"
{
	    int i, ilen = (int) yyvsp[-4].val;
	    if (ilen < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (ilen > maxarr) {
		maxarr = ilen;
		init_scratch_arrays(ilen);
	    }
	    for (i = 0; i < ilen; i++) {
		yyvsp[-5].ptr[i] = yyvsp[-2].val + yyvsp[0].val * i;
	    }
	}
break;
case 97:
#line 960 "pars.yacc"
{
	    int setno = yyvsp[-3].pset, ideg = (int) yyvsp[-1].val;
	    do_regress(setno, ideg, 0, -1, 0);
	}
break;
case 98:
#line 965 "pars.yacc"
{
	    do_running_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 99:
#line 969 "pars.yacc"
{
	    do_fourier_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 100:
#line 973 "pars.yacc"
{
	    do_spline(yyvsp[-7].pset, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 101:
#line 977 "pars.yacc"
{
	    do_histo_command(yyvsp[-7].pset, -1, -1, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 102:
#line 981 "pars.yacc"
{
	    do_differ(yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 103:
#line 985 "pars.yacc"
{
	    do_int(yyvsp[-1].pset, 0);
	}
break;
case 104:
#line 989 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultgraph(cg);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
#ifndef GRBATCH
		update_world(cg);
		drawgraph();
#endif
	    } else {
		errmsg("No active sets!");
	    }
	}
break;
case 105:
#line 1005 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultx(cg, -1);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
#ifndef GRBATCH
		update_world(cg);
#endif
#ifndef GRBATCH
		drawgraph();
#endif
	    } else {
		errmsg("No active sets!");
	    }
	}
break;
case 106:
#line 1021 "pars.yacc"
{
	    if (activeset(cg)) {
		defaulty(cg, -1);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
#ifndef GRBATCH
		update_world(cg);
		drawgraph();
#endif
	    } else {
		errmsg("No active sets!");
	    }
	}
break;
case 107:
#line 1035 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
		defaultsetgraph(cg, yyvsp[0].pset);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
#ifndef GRBATCH
		update_world(cg);
		drawgraph();
#endif
	    } else {
		errmsg("Set not active");
	    }
	}
break;
case 108:
#line 1051 "pars.yacc"
{
#ifndef GRBATCH
	    extern int go_locateflag;
	    go_locateflag = (yyvsp[0].pset == ON);
#endif
	}
break;
case 109:
#line 1058 "pars.yacc"
{
#ifndef GRBATCH
	    draw_focus(cg);
#endif
	    cg = (int) yyvsp[0].pset;
	    defineworld(g[cg].w.xg1, g[cg].w.yg1, g[cg].w.xg2, g[cg].w.yg2, 
			islogx(cg), islogy(cg));
	    viewport(g[cg].v.xv1, g[cg].v.yv1, g[cg].v.xv2, g[cg].v.yv2);
#ifndef GRBATCH
	    draw_focus(cg);
#endif
	    update_all(cg);
	}
break;
case 110:
#line 1071 "pars.yacc"
{
#ifndef GRBATCH
	    draw_focus_flag = yyvsp[0].pset;
#endif
	}
break;
case 111:
#line 1076 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 112:
#line 1079 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 113:
#line 1082 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 114:
#line 1085 "pars.yacc"
{
	    cursource = yyvsp[0].pset;
	}
break;
case 115:
#line 1088 "pars.yacc"
{
	    curtype = yyvsp[0].pset;
	    change_type = curtype;
	}
break;
case 116:
#line 1093 "pars.yacc"
{
	    readxformat = yyvsp[0].pset;
	}
break;
case 117:
#line 1097 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = curtype;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 118:
#line 1105 "pars.yacc"
{
	    gotbatch = TRUE;
	    strcpy(batchfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 119:
#line 1111 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, DISK, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 120:
#line 1116 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, yyvsp[-1].pset, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 121:
#line 1121 "pars.yacc"
{
	    create_set_fromblock(cg, yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 122:
#line 1126 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = yyvsp[-1].pset;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 123:
#line 1134 "pars.yacc"
{
	    gotread = TRUE;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    readtype = yyvsp[-2].pset;
	    readsrc = yyvsp[-1].pset;
	    free((char *) yyvsp[0].pset);
	}
break;
case 124:
#line 1142 "pars.yacc"
{
#ifndef GRBATCH
	    read_image((char *) yyvsp[0].pset);
#endif
	    free((char *) yyvsp[0].pset);
	}
break;
case 125:
#line 1149 "pars.yacc"
{
#ifndef GRBATCH
	    write_image((char *) yyvsp[0].pset);
#endif
	    free((char *) yyvsp[0].pset);
	}
break;
case 126:
#line 1156 "pars.yacc"
{
	    imagex = (int) yyvsp[-2].val;
	    imagey = (int) yyvsp[0].val;
	}
break;
case 127:
#line 1161 "pars.yacc"
{
	    outputset(cg, yyvsp[0].pset, (char *) NULL, (char *) NULL);
	}
break;
case 128:
#line 1165 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) NULL, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 129:
#line 1170 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) yyvsp[0].pset, (char *) NULL);
	    free((char *) yyvsp[0].pset);
	}
break;
case 130:
#line 1175 "pars.yacc"
{
	    outputset(cg, yyvsp[-4].pset, (char *) yyvsp[-2].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[-2].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 131:
#line 1181 "pars.yacc"
{
            extern char sformat[];
            do_writesets(maxgraph, -1, 1, (char *) yyvsp[0].pset, sformat);
            free((char *) yyvsp[0].pset);
        }
break;
case 132:
#line 1186 "pars.yacc"
{
	    push_world();
	}
break;
case 133:
#line 1189 "pars.yacc"
{
	    pop_world();
	}
break;
case 134:
#line 1192 "pars.yacc"
{
	    cycle_world_stack();
	}
break;
case 135:
#line 1195 "pars.yacc"
{
	    if ((int) yyvsp[0].val > 0)
		show_world_stack((int) yyvsp[0].val - 1);
	}
break;
case 136:
#line 1200 "pars.yacc"
{
	    add_world(cg, yyvsp[-14].val, yyvsp[-12].val, yyvsp[-10].val, yyvsp[-8].val, yyvsp[-6].val, yyvsp[-4].val, yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 137:
#line 1203 "pars.yacc"
{
	    clear_world_stack();
	}
break;
case 138:
#line 1206 "pars.yacc"
{
	    do_clear_boxes();
	}
break;
case 139:
#line 1209 "pars.yacc"
{
	    curbox = next_box();
	}
break;
case 140:
#line 1212 "pars.yacc"
{
	    curbox = (int) yyvsp[0].val;
	}
break;
case 141:
#line 1215 "pars.yacc"
{
	    boxes[curbox].active = yyvsp[0].pset;
	}
break;
case 142:
#line 1218 "pars.yacc"
{
	    boxes[curbox].gno = yyvsp[0].pset;
	}
break;
case 143:
#line 1222 "pars.yacc"
{
	    if (curbox >= 0 && curbox < maxboxes) {
		boxes[curbox].x1 = yyvsp[-6].val;
		boxes[curbox].y1 = yyvsp[-4].val;
		boxes[curbox].x2 = yyvsp[-2].val;
		boxes[curbox].y2 = yyvsp[0].val;
	    }
	}
break;
case 144:
#line 1230 "pars.yacc"
{
	    box_loctype = yyvsp[0].pset;
	}
break;
case 145:
#line 1233 "pars.yacc"
{
	    box_lines = checkon(LINESTYLE, box_lines, (int) yyvsp[0].val);
	}
break;
case 146:
#line 1236 "pars.yacc"
{
	    box_linew = checkon(LINEWIDTH, box_linew, (int) yyvsp[0].val);
	}
break;
case 147:
#line 1239 "pars.yacc"
{
	    box_color = checkon(COLOR, box_color, (int) yyvsp[0].val);
	}
break;
case 148:
#line 1242 "pars.yacc"
{
	    box_fill = yyvsp[0].pset;
	}
break;
case 149:
#line 1245 "pars.yacc"
{
	    box_fillcolor = checkon(COLOR, box_fillcolor, (int) yyvsp[0].val);
	}
break;
case 150:
#line 1248 "pars.yacc"
{
	    box_fillpat = checkon(PATTERN, box_fillpat, (int) yyvsp[0].val);
	}
break;
case 151:
#line 1252 "pars.yacc"
{
	    if (curbox >= 0 && curbox < maxboxes) {
		boxes[curbox].lines = box_lines;
		boxes[curbox].linew = box_linew;
		boxes[curbox].color = box_color;
		boxes[curbox].fill = box_fill;
		boxes[curbox].fillcolor = box_fillcolor;
		boxes[curbox].fillpattern = box_fillpat;
		boxes[curbox].loctype = box_loctype;
	    }
	}
break;
case 152:
#line 1263 "pars.yacc"
{
	    do_clear_ellipses();
	}
break;
case 153:
#line 1266 "pars.yacc"
{
		curellipse = next_ellipse();
	}
break;
case 154:
#line 1269 "pars.yacc"
{
	    curellipse = (int) yyvsp[0].val;
	}
break;
case 155:
#line 1272 "pars.yacc"
{
	    ellip[curellipse].active = yyvsp[0].pset;
	}
break;
case 156:
#line 1275 "pars.yacc"
{
	    ellip[curellipse].gno = yyvsp[0].pset;
	}
break;
case 157:
#line 1279 "pars.yacc"
{
	    if (curellipse >= 0 && curellipse < maxellipses) {
		ellip[curellipse].x1 = yyvsp[-6].val;
		ellip[curellipse].y1 = yyvsp[-4].val;
		ellip[curellipse].x2 = yyvsp[-2].val;
		ellip[curellipse].y2 = yyvsp[0].val;
	    }
	}
break;
case 158:
#line 1287 "pars.yacc"
{
	    ellipse_loctype = yyvsp[0].pset;
	}
break;
case 159:
#line 1290 "pars.yacc"
{
	    ellipse_lines = checkon(LINESTYLE, ellipse_lines, (int) yyvsp[0].val);
	}
break;
case 160:
#line 1293 "pars.yacc"
{
	    ellipse_linew = checkon(LINEWIDTH, ellipse_linew, (int) yyvsp[0].val);
	}
break;
case 161:
#line 1296 "pars.yacc"
{
	    ellipse_color = checkon(COLOR, ellipse_color, (int) yyvsp[0].val);
	}
break;
case 162:
#line 1299 "pars.yacc"
{
	    ellipse_fill = yyvsp[0].pset;
	}
break;
case 163:
#line 1302 "pars.yacc"
{
	    ellipse_fillcolor = checkon(COLOR, ellipse_fillcolor, (int) yyvsp[0].val);
	}
break;
case 164:
#line 1305 "pars.yacc"
{
	    ellipse_fillpat = checkon(PATTERN, ellipse_fillpat, (int) yyvsp[0].val);
	}
break;
case 165:
#line 1309 "pars.yacc"
{
	    if (curellipse >= 0 && curellipse < maxellipses) {
		ellip[curellipse].lines = ellipse_lines;
		ellip[curellipse].linew = ellipse_linew;
		ellip[curellipse].color = ellipse_color;
		ellip[curellipse].fill = ellipse_fill;
		ellip[curellipse].fillcolor = ellipse_fillcolor;
		ellip[curellipse].fillpattern = ellipse_fillpat;
		ellip[curellipse].loctype = ellipse_loctype;
	    }
	}
break;
case 166:
#line 1320 "pars.yacc"
{
	    curline = next_line();
	}
break;
case 167:
#line 1323 "pars.yacc"
{
	    curline = (int) yyvsp[0].val;
	}
break;
case 168:
#line 1326 "pars.yacc"
{
	    do_clear_lines();
	}
break;
case 169:
#line 1329 "pars.yacc"
{
	    lines[curline].active = yyvsp[0].pset;
	}
break;
case 170:
#line 1332 "pars.yacc"
{
	    lines[curline].gno = yyvsp[0].pset;
	}
break;
case 171:
#line 1336 "pars.yacc"
{
	    lines[curline].x1 = yyvsp[-6].val;
	    lines[curline].y1 = yyvsp[-4].val;
	    lines[curline].x2 = yyvsp[-2].val;
	    lines[curline].y2 = yyvsp[0].val;
	}
break;
case 172:
#line 1342 "pars.yacc"
{
	    line_loctype = yyvsp[0].pset;
	}
break;
case 173:
#line 1345 "pars.yacc"
{
	    line_linew = checkon(LINEWIDTH, line_linew, (int) yyvsp[0].val);
	}
break;
case 174:
#line 1348 "pars.yacc"
{
	    line_lines = checkon(LINESTYLE, line_lines, (int) yyvsp[0].val);
	}
break;
case 175:
#line 1351 "pars.yacc"
{
	    line_color = checkon(COLOR, line_color, (int) yyvsp[0].val);
	}
break;
case 176:
#line 1354 "pars.yacc"
{
	    line_arrow = checkon(ARROW, line_arrow, (int) yyvsp[0].val);
	}
break;
case 177:
#line 1357 "pars.yacc"
{
	    line_asize = yyvsp[0].val;
	}
break;
case 178:
#line 1360 "pars.yacc"
{
	    line_atype = (int) yyvsp[0].val;
	}
break;
case 179:
#line 1364 "pars.yacc"
{
	    if (curline >= 0 && curline < maxlines) {
		lines[curline].lines = line_lines;
		lines[curline].linew = line_linew;
		lines[curline].color = line_color;
		lines[curline].arrow = line_arrow;
		lines[curline].asize = line_asize;
		lines[curline].atype = line_atype;
		lines[curline].loctype = line_loctype;
	    }
	}
break;
case 180:
#line 1375 "pars.yacc"
{
	    do_clear_text();
	}
break;
case 181:
#line 1378 "pars.yacc"
{ curstring = next_string(); }
break;
case 182:
#line 1379 "pars.yacc"
{ curstring = (int) yyvsp[0].val; }
break;
case 183:
#line 1380 "pars.yacc"
{ pstr[curstring].active = yyvsp[0].pset; }
break;
case 184:
#line 1381 "pars.yacc"
{ pstr[curstring].gno = yyvsp[0].pset; }
break;
case 185:
#line 1383 "pars.yacc"
{
	    pstr[curstring].x = yyvsp[-2].val;
	    pstr[curstring].y = yyvsp[0].val;
	}
break;
case 186:
#line 1387 "pars.yacc"
{ string_loctype = yyvsp[0].pset; }
break;
case 187:
#line 1388 "pars.yacc"
{ string_linew = checkon(LINEWIDTH, string_linew, (int) yyvsp[0].val); }
break;
case 188:
#line 1389 "pars.yacc"
{ string_color = checkon(COLOR, string_color, (int) yyvsp[0].val); }
break;
case 189:
#line 1390 "pars.yacc"
{ string_rot = (int) yyvsp[0].val; }
break;
case 190:
#line 1391 "pars.yacc"
{ string_font = checkon(FONTP, string_font, (int) yyvsp[0].val); }
break;
case 191:
#line 1392 "pars.yacc"
{ string_just = checkon(JUST, string_just, (int) yyvsp[0].val); }
break;
case 192:
#line 1393 "pars.yacc"
{ string_size = yyvsp[0].val; }
break;
case 193:
#line 1395 "pars.yacc"
{
	    set_plotstr_string(&pstr[curstring], (char *) yyvsp[0].pset);
	    pstr[curstring].linew = string_linew;
	    pstr[curstring].color = string_color;
	    pstr[curstring].font = string_font;
	    pstr[curstring].just = string_just;
	    pstr[curstring].loctype = string_loctype;
	    pstr[curstring].rot = string_rot;
	    pstr[curstring].charsize = string_size;
	    free((char *) yyvsp[0].pset);
	}
break;
case 194:
#line 1406 "pars.yacc"
{ timestamp.active = yyvsp[0].pset; }
break;
case 195:
#line 1407 "pars.yacc"
{ timestamp.font = checkon(FONTP, timestamp.font, (int) yyvsp[0].val); }
break;
case 196:
#line 1408 "pars.yacc"
{ timestamp.charsize = yyvsp[0].val; }
break;
case 197:
#line 1409 "pars.yacc"
{ timestamp.color = checkon(COLOR, timestamp.color, (int) yyvsp[0].val); }
break;
case 198:
#line 1410 "pars.yacc"
{ timestamp.linew = checkon(LINEWIDTH, timestamp.linew, (int) yyvsp[-1].pset); }
break;
case 199:
#line 1412 "pars.yacc"
{
	    timestamp.x = yyvsp[-2].val;
	    timestamp.y = yyvsp[0].val;
	}
break;
case 200:
#line 1416 "pars.yacc"
{
	    grdefaults.lines = (int) yyvsp[0].val;
	}
break;
case 201:
#line 1419 "pars.yacc"
{
	    grdefaults.linew = (int) yyvsp[0].val;
	}
break;
case 202:
#line 1422 "pars.yacc"
{
	    grdefaults.color = (int) yyvsp[0].val;
	}
break;
case 203:
#line 1425 "pars.yacc"
{
	    grdefaults.charsize = yyvsp[0].val;
	}
break;
case 204:
#line 1428 "pars.yacc"
{
	    grdefaults.font = (int) yyvsp[0].val;
	}
break;
case 205:
#line 1431 "pars.yacc"
{
	    grdefaults.fontsrc = (int) yyvsp[0].val;
	}
break;
case 206:
#line 1434 "pars.yacc"
{
	    grdefaults.symsize = yyvsp[0].val;
	}
break;
case 207:
#line 1438 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[-6].val;
	    g[cg].w.yg1 = yyvsp[-4].val;
	    g[cg].w.xg2 = yyvsp[-2].val;
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 208:
#line 1444 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[0].val;
	}
break;
case 209:
#line 1447 "pars.yacc"
{
	    g[cg].w.xg2 = yyvsp[0].val;
	}
break;
case 210:
#line 1450 "pars.yacc"
{
	    g[cg].w.yg1 = yyvsp[0].val;
	}
break;
case 211:
#line 1453 "pars.yacc"
{
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 212:
#line 1457 "pars.yacc"
{
            g[cg].rt.xg1 = yyvsp[-2].val;
            g[cg].rt.yg1 = yyvsp[0].val;
        }
break;
case 213:
#line 1462 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[-6].val;
	    g[cg].v.yv1 = yyvsp[-4].val;
	    g[cg].v.xv2 = yyvsp[-2].val;
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 214:
#line 1468 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[0].val;
	}
break;
case 215:
#line 1471 "pars.yacc"
{
	    g[cg].v.xv2 = yyvsp[0].val;
	}
break;
case 216:
#line 1474 "pars.yacc"
{
	    g[cg].v.yv1 = yyvsp[0].val;
	}
break;
case 217:
#line 1477 "pars.yacc"
{
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 218:
#line 1480 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.title, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 219:
#line 1484 "pars.yacc"
{
	    g[cg].labs.title.font = checkon(FONTP, g[cg].labs.title.font, (int) yyvsp[0].val);
	}
break;
case 220:
#line 1487 "pars.yacc"
{
	    g[cg].labs.title.charsize = yyvsp[0].val;
	}
break;
case 221:
#line 1490 "pars.yacc"
{
	    g[cg].labs.title.color = checkon(COLOR, g[cg].labs.title.color, (int) yyvsp[0].val);
	}
break;
case 222:
#line 1494 "pars.yacc"
{
	    g[cg].labs.title.linew = checkon(LINEWIDTH, g[cg].labs.title.linew, (int) yyvsp[0].val);
	}
break;
case 223:
#line 1497 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.stitle, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 224:
#line 1502 "pars.yacc"
{
	    g[cg].labs.stitle.font = checkon(FONTP, g[cg].labs.stitle.font, (int) yyvsp[0].val);
	}
break;
case 225:
#line 1505 "pars.yacc"
{
	    g[cg].labs.stitle.charsize = yyvsp[0].val;
	}
break;
case 226:
#line 1509 "pars.yacc"
{
	    g[cg].labs.stitle.color = checkon(COLOR, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 227:
#line 1513 "pars.yacc"
{
	    g[cg].labs.stitle.linew = checkon(LINEWIDTH, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 228:
#line 1516 "pars.yacc"
{
	    realloc_plots((int) yyvsp[0].val);
	}
break;
case 229:
#line 1519 "pars.yacc"
{
	    g[cg].l.active = yyvsp[0].pset;
	}
break;
case 230:
#line 1522 "pars.yacc"
{
	    g[cg].l.loctype = yyvsp[0].pset;
	}
break;
case 231:
#line 1525 "pars.yacc"
{
	    g[cg].l.layout = (int) yyvsp[0].val;
	}
break;
case 232:
#line 1528 "pars.yacc"
{
	    g[cg].l.vgap = (int) yyvsp[0].val;
	}
break;
case 233:
#line 1531 "pars.yacc"
{
	    g[cg].l.hgap = (int) yyvsp[0].val;
	}
break;
case 234:
#line 1534 "pars.yacc"
{
	    g[cg].l.len = (int) yyvsp[0].val;
	}
break;
case 235:
#line 1537 "pars.yacc"
{
	    g[cg].l.box = yyvsp[0].pset;
	}
break;
case 236:
#line 1540 "pars.yacc"
{
	    g[cg].l.boxfill = yyvsp[0].pset;
	}
break;
case 237:
#line 1543 "pars.yacc"
{
	    g[cg].l.boxfillusing = yyvsp[0].pset;
	}
break;
case 238:
#line 1547 "pars.yacc"
{
	    if (yyvsp[-1].pset == COLOR) {
		g[cg].l.boxfillcolor = (int) yyvsp[0].val;
	    } else {
		g[cg].l.boxfillpat = (int) yyvsp[0].val;
	    }
	}
break;
case 239:
#line 1554 "pars.yacc"
{
	    g[cg].l.boxlcolor = checkon(COLOR, g[cg].l.boxlcolor, (int) yyvsp[0].val);
	}
break;
case 240:
#line 1557 "pars.yacc"
{
	    g[cg].l.boxlines = checkon(LINESTYLE, g[cg].l.boxlines, (int) yyvsp[0].val);
	}
break;
case 241:
#line 1560 "pars.yacc"
{
	    g[cg].l.boxlinew = checkon(LINEWIDTH, g[cg].l.boxlinew, (int) yyvsp[0].val);
	}
break;
case 242:
#line 1563 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[-2].val;
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 243:
#line 1567 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[0].val;
	}
break;
case 244:
#line 1570 "pars.yacc"
{
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 245:
#line 1573 "pars.yacc"
{
	    g[cg].l.charsize = yyvsp[0].val;
	}
break;
case 246:
#line 1576 "pars.yacc"
{
	    g[cg].l.font = checkon(FONTP, g[cg].l.font, (int) yyvsp[0].val);
	}
break;
case 247:
#line 1579 "pars.yacc"
{
	    g[cg].l.lines = checkon(LINESTYLE, g[cg].l.lines, (int) yyvsp[0].val);
	}
break;
case 248:
#line 1582 "pars.yacc"
{
	    g[cg].l.linew = checkon(LINEWIDTH, g[cg].l.linew, (int) yyvsp[0].val);
	}
break;
case 249:
#line 1585 "pars.yacc"
{
	    g[cg].l.color = checkon(COLOR, g[cg].l.color, (int) yyvsp[0].val);
	}
break;
case 250:
#line 1588 "pars.yacc"
{
	    strcpy(g[cg].p[(int) yyvsp[-1].val].lstr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 251:
#line 1592 "pars.yacc"
{
	    g[cg].f.active = yyvsp[0].pset;
	}
break;
case 252:
#line 1595 "pars.yacc"
{
	    g[cg].f.type = (int) yyvsp[0].val;
	}
break;
case 253:
#line 1598 "pars.yacc"
{
	    g[cg].f.lines = checkon(LINESTYLE, g[cg].f.lines, (int) yyvsp[0].val);
	}
break;
case 254:
#line 1601 "pars.yacc"
{
	    g[cg].f.linew = checkon(LINEWIDTH, g[cg].f.linew, (int) yyvsp[0].val);
	}
break;
case 255:
#line 1604 "pars.yacc"
{
	    g[cg].f.color = checkon(COLOR, g[cg].f.color, (int) yyvsp[0].val);
	}
break;
case 256:
#line 1607 "pars.yacc"
{ g[cg].f.fillbg = yyvsp[0].pset; }
break;
case 257:
#line 1608 "pars.yacc"
{ g[cg].f.bgcolor = (int) yyvsp[0].val; }
break;
case 258:
#line 1609 "pars.yacc"
{ g[yyvsp[-1].pset].active = yyvsp[0].pset; }
break;
case 259:
#line 1610 "pars.yacc"
{ g[yyvsp[-2].pset].label = yyvsp[0].pset; }
break;
case 260:
#line 1611 "pars.yacc"
{ g[yyvsp[-3].pset].auto_type = yyvsp[0].pset; }
break;
case 261:
#line 1612 "pars.yacc"
{ g[yyvsp[-3].pset].auto_type = yyvsp[0].pset; }
break;
case 262:
#line 1613 "pars.yacc"
{ g[yyvsp[-2].pset].parmsread = (yyvsp[0].pset == FALSEP); }
break;
case 263:
#line 1614 "pars.yacc"
{ g[yyvsp[-2].pset].hidden = (yyvsp[0].pset == TRUEP); }
break;
case 264:
#line 1615 "pars.yacc"
{ g[yyvsp[-2].pset].type = yyvsp[0].pset; }
break;
case 265:
#line 1616 "pars.yacc"
{ g[yyvsp[-3].pset].barwid = yyvsp[0].val; }
break;
case 266:
#line 1617 "pars.yacc"
{ g[yyvsp[-3].pset].sbarwid = yyvsp[0].val; }
break;
case 267:
#line 1618 "pars.yacc"
{ g[yyvsp[-2].pset].pointset = (yyvsp[0].pset == ON); }
break;
case 268:
#line 1620 "pars.yacc"
{
	    g[yyvsp[-4].pset].fx = yyvsp[-1].pset;
	    g[yyvsp[-4].pset].fy = yyvsp[0].pset;
	}
break;
case 269:
#line 1625 "pars.yacc"
{
	    g[yyvsp[-5].pset].px = yyvsp[-2].val;
	    g[yyvsp[-5].pset].py = yyvsp[0].val;
	}
break;
case 270:
#line 1630 "pars.yacc"
{
	    g[yyvsp[-5].pset].dsx = yyvsp[-2].val;
	    g[yyvsp[-5].pset].dsy = yyvsp[0].val;
	}
break;
case 271:
#line 1634 "pars.yacc"
{ g[yyvsp[-3].pset].pt_type = (int) yyvsp[0].val; }
break;
case 272:
#line 1635 "pars.yacc"
{ realloc_graph_plots(yyvsp[-3].pset, (int) yyvsp[0].val); }
break;
case 273:
#line 1639 "pars.yacc"
{ g[cg].vp.vscale = yyvsp[0].val; }
break;
case 274:
#line 1640 "pars.yacc"
{ g[cg].vp.active = yyvsp[0].pset; }
break;
case 275:
#line 1641 "pars.yacc"
{ g[cg].vp.linew = (int) yyvsp[0].val; }
break;
case 276:
#line 1642 "pars.yacc"
{ g[cg].vp.lines = (int) yyvsp[0].val; }
break;
case 277:
#line 1643 "pars.yacc"
{ g[cg].vp.color = (int) yyvsp[0].val; }
break;
case 278:
#line 1644 "pars.yacc"
{ g[cg].vp.loctype = yyvsp[0].pset; }
break;
case 279:
#line 1645 "pars.yacc"
{ g[cg].vp.arrowtype = (int) yyvsp[0].val; }
break;
case 280:
#line 1649 "pars.yacc"
{ yyval.pset = XY; }
break;
case 281:
#line 1650 "pars.yacc"
{ yyval.pset = XYARC; }
break;
case 282:
#line 1651 "pars.yacc"
{ yyval.pset = XYBOX; }
break;
case 283:
#line 1652 "pars.yacc"
{ yyval.pset = XYBOXPLOT; }
break;
case 284:
#line 1653 "pars.yacc"
{ yyval.pset = XYHILO; }
break;
case 285:
#line 1654 "pars.yacc"
{ yyval.pset = XYRT; }
break;
case 286:
#line 1655 "pars.yacc"
{ yyval.pset = XYSEG; }
break;
case 287:
#line 1656 "pars.yacc"
{ yyval.pset = XYSTRING; }
break;
case 288:
#line 1657 "pars.yacc"
{ yyval.pset = XYDX; }
break;
case 289:
#line 1658 "pars.yacc"
{ yyval.pset = XYDY; }
break;
case 290:
#line 1659 "pars.yacc"
{ yyval.pset = XYDXDX; }
break;
case 291:
#line 1660 "pars.yacc"
{ yyval.pset = XYDYDY; }
break;
case 292:
#line 1661 "pars.yacc"
{ yyval.pset = XYDXDY; }
break;
case 293:
#line 1662 "pars.yacc"
{ yyval.pset = XYX2Y2; }
break;
case 294:
#line 1663 "pars.yacc"
{ yyval.pset = XYXX; }
break;
case 295:
#line 1664 "pars.yacc"
{ yyval.pset = XYYY; }
break;
case 296:
#line 1665 "pars.yacc"
{ yyval.pset = XYZ; }
break;
case 297:
#line 1666 "pars.yacc"
{ yyval.pset = XYZW; }
break;
case 298:
#line 1667 "pars.yacc"
{ yyval.pset = XYUV; }
break;
case 299:
#line 1668 "pars.yacc"
{ yyval.pset = TSV; }
break;
case 300:
#line 1669 "pars.yacc"
{ yyval.pset = NXY; }
break;
case 301:
#line 1670 "pars.yacc"
{ yyval.pset = BIN; }
break;
case 302:
#line 1671 "pars.yacc"
{ yyval.pset = POLY; }
break;
case 303:
#line 1672 "pars.yacc"
{ yyval.pset = RAWSPICE; }
break;
case 304:
#line 1676 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 305:
#line 1677 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 306:
#line 1678 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 307:
#line 1679 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 308:
#line 1680 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 309:
#line 1681 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 310:
#line 1682 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 311:
#line 1683 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 312:
#line 1684 "pars.yacc"
{ yyval.pset = XY;		/* not active */ }
break;
case 313:
#line 1685 "pars.yacc"
{ yyval.pset = XY;		/* not active */ }
break;
case 314:
#line 1686 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 315:
#line 1687 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 316:
#line 1688 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 317:
#line 1692 "pars.yacc"
{ yyval.pset = FREE; }
break;
case 318:
#line 1693 "pars.yacc"
{ yyval.pset = LANDSCAPE; }
break;
case 319:
#line 1694 "pars.yacc"
{ yyval.pset = PORTRAIT; }
break;
case 320:
#line 1695 "pars.yacc"
{ yyval.pset = FIXED; }
break;
case 328:
#line 1723 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 329:
#line 1726 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 330:
#line 1729 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, TYPE, yyvsp[0].pset, 0);
	}
break;
case 331:
#line 1732 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, MISSINGP, yyvsp[0].val, 0);
	}
break;
case 332:
#line 1735 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, PREC, (int) yyvsp[0].val, 0);
	}
break;
case 333:
#line 1738 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FORMAT, yyvsp[0].pset, 0);
	}
break;
case 334:
#line 1741 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 335:
#line 1744 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, FILL, (int) yyvsp[0].val, 0);
	}
break;
case 336:
#line 1747 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CENTER, (yyvsp[0].pset == TRUEP), 0);
	}
break;
case 337:
#line 1750 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SIZE, yyvsp[0].val, 0);
	}
break;
case 338:
#line 1753 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CHAR, (int) yyvsp[0].val, 0);
	}
break;
case 339:
#line 1756 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 340:
#line 1759 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, COLOR, (int) yyvsp[0].val, 0);
	}
break;
case 341:
#line 1762 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 342:
#line 1765 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 343:
#line 1768 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 344:
#line 1771 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 345:
#line 1774 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, WITH, yyvsp[0].pset, 0);
	}
break;
case 346:
#line 1777 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 347:
#line 1780 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 348:
#line 1783 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LENGTH, yyvsp[0].val, 0);
	}
break;
case 349:
#line 1786 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, TYPE, yyvsp[0].pset, 0);
	}
break;
case 350:
#line 1789 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 351:
#line 1792 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 352:
#line 1795 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 353:
#line 1798 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 354:
#line 1801 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 355:
#line 1804 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, XYZ, yyvsp[-2].val, yyvsp[0].val, 0);
	}
break;
case 356:
#line 1807 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, COMMENT, (char *) yyvsp[0].pset, 0);
	    free((char *) yyvsp[0].pset);
	}
break;
case 372:
#line 1838 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[0].pset, 0.0);
	}
break;
case 373:
#line 1841 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 374:
#line 1844 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 375:
#line 1847 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 376:
#line 1850 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 377:
#line 1853 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-2].pset, yyvsp[0].val);
	}
break;
case 378:
#line 1856 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].pset);
	}
break;
case 383:
#line 1866 "pars.yacc"
{
	    g[cg].t[naxis].active = yyvsp[0].pset;
	}
break;
case 386:
#line 1878 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 387:
#line 1882 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	}
break;
case 388:
#line 1885 "pars.yacc"
{
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 389:
#line 1888 "pars.yacc"
{
	    g[cg].t[naxis].tmajor = yyvsp[0].val;
	}
break;
case 390:
#line 1891 "pars.yacc"
{
	    g[cg].t[naxis].tminor = yyvsp[0].val;
	}
break;
case 391:
#line 1894 "pars.yacc"
{
	    g[cg].t[naxis].offsx = yyvsp[0].val;
	}
break;
case 392:
#line 1897 "pars.yacc"
{
	    g[cg].t[naxis].offsy = yyvsp[0].val;
	}
break;
case 393:
#line 1900 "pars.yacc"
{
	    g[cg].t[naxis].alt = yyvsp[0].pset;
	}
break;
case 394:
#line 1903 "pars.yacc"
{
	    g[cg].t[naxis].tmin = yyvsp[0].val;
	}
break;
case 395:
#line 1906 "pars.yacc"
{
	    g[cg].t[naxis].tmax = yyvsp[0].val;
	}
break;
case 396:
#line 1909 "pars.yacc"
{
	    g[cg].t[naxis].t_num = (int) yyvsp[0].val;
	}
break;
case 397:
#line 1912 "pars.yacc"
{
	    g[cg].t[naxis].t_inout = yyvsp[0].pset;
	}
break;
case 398:
#line 1915 "pars.yacc"
{
	    g[cg].t[naxis].t_log = yyvsp[0].pset;
	}
break;
case 399:
#line 1918 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 400:
#line 1921 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 401:
#line 1924 "pars.yacc"
{
	    g[cg].t[naxis].t_msize = yyvsp[0].val;
	}
break;
case 402:
#line 1927 "pars.yacc"
{
	    g[cg].t[naxis].t_color = g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 403:
#line 1930 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 404:
#line 1933 "pars.yacc"
{
	    g[cg].t[naxis].t_color = (int) yyvsp[0].val;
	}
break;
case 405:
#line 1936 "pars.yacc"
{
	    g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 406:
#line 1939 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = (int) yyvsp[0].val;
	}
break;
case 407:
#line 1942 "pars.yacc"
{
	    g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 408:
#line 1945 "pars.yacc"
{
	    g[cg].t[naxis].t_lines = (int) yyvsp[0].val;
	}
break;
case 409:
#line 1948 "pars.yacc"
{
	    g[cg].t[naxis].t_mlines = (int) yyvsp[0].val;
	}
break;
case 410:
#line 1951 "pars.yacc"
{
	    g[cg].t[naxis].t_gridflag = yyvsp[0].pset;
	}
break;
case 411:
#line 1954 "pars.yacc"
{
	    g[cg].t[naxis].t_mgridflag = yyvsp[0].pset;
	}
break;
case 412:
#line 1957 "pars.yacc"
{
	    g[cg].t[naxis].t_op = yyvsp[0].pset;
	}
break;
case 413:
#line 1960 "pars.yacc"
{
	    g[cg].t[naxis].t_type = AUTO;
	}
break;
case 414:
#line 1963 "pars.yacc"
{
	    g[cg].t[naxis].t_type = SPEC;
	}
break;
case 415:
#line 1966 "pars.yacc"
{
	    g[cg].t[naxis].t_spec = (int) yyvsp[0].val;
	}
break;
case 416:
#line 1969 "pars.yacc"
{
	    g[cg].t[naxis].t_specloc[(int) yyvsp[-2].val] = yyvsp[0].val;
	}
break;
case 419:
#line 1980 "pars.yacc"
{
	    g[cg].t[naxis].tl_flag = yyvsp[0].pset;
	}
break;
case 420:
#line 1983 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = AUTO;
	}
break;
case 421:
#line 1986 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = SPEC;
	}
break;
case 422:
#line 1989 "pars.yacc"
{
	    g[cg].t[naxis].tl_prec = (int) yyvsp[0].val;
	}
break;
case 423:
#line 1992 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].pset;
	}
break;
case 424:
#line 1995 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].val;
	}
break;
case 425:
#line 1998 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_appstr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 426:
#line 2002 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_prestr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 427:
#line 2006 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = HORIZONTAL;
	}
break;
case 428:
#line 2009 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = VERTICAL;
	}
break;
case 429:
#line 2012 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = SPEC;
	}
break;
case 430:
#line 2015 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = ON;
	}
break;
case 431:
#line 2018 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = CENTER;
	}
break;
case 432:
#line 2021 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = LEFT;
	}
break;
case 433:
#line 2024 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = RIGHT;
	}
break;
case 434:
#line 2027 "pars.yacc"
{
	    g[cg].t[naxis].tl_angle = (int) yyvsp[0].val;
	}
break;
case 435:
#line 2030 "pars.yacc"
{
	    g[cg].t[naxis].tl_just = (int) yyvsp[0].pset;
	}
break;
case 436:
#line 2033 "pars.yacc"
{
	    g[cg].t[naxis].tl_skip = (int) yyvsp[0].val;
	}
break;
case 437:
#line 2036 "pars.yacc"
{
	    g[cg].t[naxis].tl_staggered = (int) yyvsp[0].val;
	}
break;
case 438:
#line 2039 "pars.yacc"
{
	    g[cg].t[naxis].tl_op = yyvsp[0].pset;
	}
break;
case 439:
#line 2042 "pars.yacc"
{
	    g[cg].t[naxis].tl_sign = yyvsp[0].pset;
	}
break;
case 440:
#line 2045 "pars.yacc"
{
	    g[cg].t[naxis].tl_start = yyvsp[0].val;
	}
break;
case 441:
#line 2048 "pars.yacc"
{
	    g[cg].t[naxis].tl_stop = yyvsp[0].val;
	}
break;
case 442:
#line 2051 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 443:
#line 2054 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 444:
#line 2057 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 445:
#line 2060 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 446:
#line 2063 "pars.yacc"
{
	    g[cg].t[naxis].tl_vgap = yyvsp[0].val;
	}
break;
case 447:
#line 2066 "pars.yacc"
{
	    g[cg].t[naxis].tl_hgap = yyvsp[0].val;
	}
break;
case 448:
#line 2069 "pars.yacc"
{
	    g[cg].t[naxis].tl_charsize = yyvsp[0].val;
	}
break;
case 449:
#line 2072 "pars.yacc"
{
	    g[cg].t[naxis].tl_font = (int) yyvsp[0].val;
	}
break;
case 450:
#line 2075 "pars.yacc"
{
	    g[cg].t[naxis].tl_color = (int) yyvsp[0].val;
	}
break;
case 451:
#line 2078 "pars.yacc"
{
	    g[cg].t[naxis].tl_linew = (int) yyvsp[0].val;
	}
break;
case 452:
#line 2081 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].t_speclab[(int) yyvsp[-2].val], (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 453:
#line 2088 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].label, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 454:
#line 2092 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PERP;
	}
break;
case 455:
#line 2095 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PARA;
	}
break;
case 456:
#line 2098 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 457:
#line 2101 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 458:
#line 2104 "pars.yacc"
{
	    g[cg].t[naxis].label.x = yyvsp[-2].val;
	    g[cg].t[naxis].label.y = yyvsp[0].val;
	}
break;
case 459:
#line 2108 "pars.yacc"
{
	    g[cg].t[naxis].label.just = (int) yyvsp[0].pset;
	}
break;
case 460:
#line 2111 "pars.yacc"
{
	    g[cg].t[naxis].label.charsize = yyvsp[0].val;
	}
break;
case 461:
#line 2114 "pars.yacc"
{
	    g[cg].t[naxis].label.font = (int) yyvsp[0].val;
	}
break;
case 462:
#line 2117 "pars.yacc"
{
	    g[cg].t[naxis].label.color = (int) yyvsp[0].val;
	}
break;
case 463:
#line 2120 "pars.yacc"
{
	    g[cg].t[naxis].label.linew = (int) yyvsp[0].val;
	}
break;
case 464:
#line 2126 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbar = yyvsp[0].pset;
	}
break;
case 465:
#line 2129 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarcolor = (int) yyvsp[0].val;
	}
break;
case 466:
#line 2132 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlines = (int) yyvsp[0].val;
	}
break;
case 467:
#line 2135 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlinew = (int) yyvsp[0].val;
	}
break;
case 468:
#line 2142 "pars.yacc"
{
	    whichgraph = yyvsp[-2].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 469:
#line 2147 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 470:
#line 2152 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 471:
#line 2157 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 472:
#line 2162 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 473:
#line 2167 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 474:
#line 2173 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 475:
#line 2174 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 476:
#line 2175 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 477:
#line 2176 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 478:
#line 2177 "pars.yacc"
{ yyval.pset = yyvsp[0].pset; }
break;
case 479:
#line 2180 "pars.yacc"
{ yyval.pset = ON; }
break;
case 480:
#line 2181 "pars.yacc"
{ yyval.pset = OFF; }
break;
case 481:
#line 2184 "pars.yacc"
{ yyval.pset = COLOR; }
break;
case 482:
#line 2185 "pars.yacc"
{ yyval.pset = PATTERN; }
break;
case 483:
#line 2188 "pars.yacc"
{ yyval.pset = RUNAVG; }
break;
case 484:
#line 2189 "pars.yacc"
{ yyval.pset = RUNSTD; }
break;
case 485:
#line 2190 "pars.yacc"
{ yyval.pset = RUNMED; }
break;
case 486:
#line 2191 "pars.yacc"
{ yyval.pset = RUNMAX; }
break;
case 487:
#line 2192 "pars.yacc"
{ yyval.pset = RUNMIN; }
break;
case 488:
#line 2195 "pars.yacc"
{ yyval.pset = DFT; }
break;
case 489:
#line 2196 "pars.yacc"
{ yyval.pset = FFT; }
break;
case 490:
#line 2197 "pars.yacc"
{ yyval.pset = INVDFT; }
break;
case 491:
#line 2198 "pars.yacc"
{ yyval.pset = INVFFT; }
break;
case 492:
#line 2201 "pars.yacc"
{ yyval.pset = DISK; }
break;
case 493:
#line 2202 "pars.yacc"
{ yyval.pset = PIPE; }
break;
case 494:
#line 2205 "pars.yacc"
{ yyval.pset = PATTERN; }
break;
case 495:
#line 2206 "pars.yacc"
{ yyval.pset = COLOR; }
break;
case 496:
#line 2207 "pars.yacc"
{ yyval.pset = NONE; }
break;
case 497:
#line 2210 "pars.yacc"
{ yyval.pset = TOP; }
break;
case 498:
#line 2211 "pars.yacc"
{ yyval.pset = BOTTOM; }
break;
case 499:
#line 2212 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 500:
#line 2213 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 501:
#line 2214 "pars.yacc"
{ yyval.pset = BOTH; }
break;
case 502:
#line 2217 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 503:
#line 2218 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 504:
#line 2219 "pars.yacc"
{ yyval.pset = CENTER; }
break;
case 505:
#line 2222 "pars.yacc"
{ yyval.pset = MINP; }
break;
case 506:
#line 2223 "pars.yacc"
{ yyval.pset = MAXP; }
break;
case 507:
#line 2226 "pars.yacc"
{ yyval.pset = TRUEP; }
break;
case 508:
#line 2227 "pars.yacc"
{ yyval.pset = FALSEP; }
break;
case 509:
#line 2230 "pars.yacc"
{ yyval.pset = IN; }
break;
case 510:
#line 2231 "pars.yacc"
{ yyval.pset = OUT; }
break;
case 511:
#line 2232 "pars.yacc"
{ yyval.pset = BOTH; }
break;
case 512:
#line 2235 "pars.yacc"
{ yyval.pset = DECIMAL; }
break;
case 513:
#line 2236 "pars.yacc"
{ yyval.pset = EXPONENTIAL; }
break;
case 514:
#line 2237 "pars.yacc"
{ yyval.pset = POWER; }
break;
case 515:
#line 2238 "pars.yacc"
{ yyval.pset = GENERAL; }
break;
case 516:
#line 2239 "pars.yacc"
{ yyval.pset = DDMMYY; }
break;
case 517:
#line 2240 "pars.yacc"
{ yyval.pset = MMDDYY; }
break;
case 518:
#line 2241 "pars.yacc"
{ yyval.pset = YYMMDD; }
break;
case 519:
#line 2242 "pars.yacc"
{ yyval.pset = MMYY; }
break;
case 520:
#line 2243 "pars.yacc"
{ yyval.pset = MMDD; }
break;
case 521:
#line 2244 "pars.yacc"
{ yyval.pset = MONTHDAY; }
break;
case 522:
#line 2245 "pars.yacc"
{ yyval.pset = DAYMONTH; }
break;
case 523:
#line 2246 "pars.yacc"
{ yyval.pset = MONTHS; }
break;
case 524:
#line 2247 "pars.yacc"
{ yyval.pset = MONTHSY; }
break;
case 525:
#line 2248 "pars.yacc"
{ yyval.pset = MONTHL; }
break;
case 526:
#line 2249 "pars.yacc"
{ yyval.pset = DAYOFWEEKS; }
break;
case 527:
#line 2250 "pars.yacc"
{ yyval.pset = DAYOFWEEKL; }
break;
case 528:
#line 2251 "pars.yacc"
{ yyval.pset = DAYOFYEAR; }
break;
case 529:
#line 2252 "pars.yacc"
{ yyval.pset = HMS; }
break;
case 530:
#line 2253 "pars.yacc"
{ yyval.pset = MMDDHMS; }
break;
case 531:
#line 2254 "pars.yacc"
{ yyval.pset = MMDDYYHMS; }
break;
case 532:
#line 2255 "pars.yacc"
{ yyval.pset = YYMMDDHMS; }
break;
case 533:
#line 2256 "pars.yacc"
{ yyval.pset = DEGREESLON; }
break;
case 534:
#line 2257 "pars.yacc"
{ yyval.pset = DEGREESMMLON; }
break;
case 535:
#line 2258 "pars.yacc"
{ yyval.pset = DEGREESMMSSLON; }
break;
case 536:
#line 2259 "pars.yacc"
{ yyval.pset = MMSSLON; }
break;
case 537:
#line 2260 "pars.yacc"
{ yyval.pset = DEGREESLAT; }
break;
case 538:
#line 2261 "pars.yacc"
{ yyval.pset = DEGREESMMLAT; }
break;
case 539:
#line 2262 "pars.yacc"
{ yyval.pset = DEGREESMMSSLAT; }
break;
case 540:
#line 2263 "pars.yacc"
{ yyval.pset = MMSSLAT; }
break;
case 541:
#line 2266 "pars.yacc"
{ yyval.pset = NORMAL; }
break;
case 542:
#line 2267 "pars.yacc"
{ yyval.pset = ABSOLUTE; }
break;
case 543:
#line 2268 "pars.yacc"
{ yyval.pset = NEGATE; }
break;
case 544:
#line 2271 "pars.yacc"
{ yyval.pset = UP; }
break;
case 545:
#line 2272 "pars.yacc"
{ yyval.pset = DOWN; }
break;
case 546:
#line 2273 "pars.yacc"
{ yyval.pset = RIGHT; }
break;
case 547:
#line 2274 "pars.yacc"
{ yyval.pset = LEFT; }
break;
case 548:
#line 2275 "pars.yacc"
{ yyval.pset = IN; }
break;
case 549:
#line 2276 "pars.yacc"
{ yyval.pset = OUT; }
break;
case 550:
#line 2279 "pars.yacc"
{ yyval.pset = WORLD; }
break;
case 551:
#line 2280 "pars.yacc"
{ yyval.pset = VIEW; }
break;
case 552:
#line 2283 "pars.yacc"
{ yyval.pset = ASCENDING; }
break;
case 553:
#line 2284 "pars.yacc"
{ yyval.pset = DESCENDING; }
break;
case 554:
#line 2287 "pars.yacc"
{ yyval.pset = X; }
break;
case 555:
#line 2288 "pars.yacc"
{ yyval.pset = Y; }
break;
case 556:
#line 2291 "pars.yacc"
{ yyval.pset = X; }
break;
case 557:
#line 2292 "pars.yacc"
{ yyval.pset = Y; }
break;
case 558:
#line 2293 "pars.yacc"
{ yyval.pset = X0; }
break;
case 559:
#line 2294 "pars.yacc"
{ yyval.pset = Y0; }
break;
case 560:
#line 2295 "pars.yacc"
{ yyval.pset = Y1; }
break;
case 561:
#line 2296 "pars.yacc"
{ yyval.pset = Y2; }
break;
case 562:
#line 2297 "pars.yacc"
{ yyval.pset = Y3; }
break;
case 563:
#line 2298 "pars.yacc"
{ yyval.pset = Y4; }
break;
case 564:
#line 2299 "pars.yacc"
{ yyval.pset = Y5; }
break;
case 565:
#line 2304 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    if (itmp >= ls) {
		yyerror("Subscript out of range");
		return 1;
	    } else {
		yyvsp[-5].ptr[itmp] = yyvsp[0].val;
		result = yyvsp[0].val;
	    }
	}
break;
case 566:
#line 2315 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, curset, yyvsp[-3].val);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, curset);
#ifndef GRBATCH
	    update_set_status(cg, curset);
#endif
	}
break;
case 567:
#line 2332 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, yyvsp[-7].pset);
#ifndef GRBATCH
	    update_set_status(cg, yyvsp[-7].pset);
#endif
	}
break;
case 568:
#line 2349 "pars.yacc"
{
	    set_prop(cg, SET, SETNUM, yyvsp[-4].pset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	    result = 0;
	}
break;
case 569:
#line 2361 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(yyvsp[-9].pset, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(yyvsp[-9].pset, yyvsp[-7].pset);
#ifndef GRBATCH
	    update_set_status(yyvsp[-9].pset, yyvsp[-7].pset);
#endif
	}
break;
case 570:
#line 2381 "pars.yacc"
{
	    if (yyvsp[-2].pset == X) {
		*xx = yyvsp[0].val;
	    } else {
		*yy = yyvsp[0].val;
	    }
	}
break;
case 571:
#line 2392 "pars.yacc"
{
	    int i;
	    if (ls < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (ls > maxarr) {
		maxarr = ls;
		init_scratch_arrays(ls);
	    }
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].ptr[i];
	    }
	    result = yyvsp[0].ptr[0];
	}
break;
case 572:
#line 2407 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, curset);
#ifndef GRBATCH
	        update_set_status(cg, curset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 573:
#line 2432 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
	        do_copyset(cg, yyvsp[0].pset, cg, yyvsp[-2].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 574:
#line 2441 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
	        do_copyset(cg, yyvsp[0].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 575:
#line 2450 "pars.yacc"
{
	    if (isactive_set(yyvsp[-2].pset, yyvsp[0].pset)) {
	        do_copyset(yyvsp[-2].pset, yyvsp[0].pset, cg, yyvsp[-4].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 576:
#line 2459 "pars.yacc"
{
	    if (isactive_set(yyvsp[-2].pset, yyvsp[0].pset)) {
	        do_copyset(yyvsp[-2].pset, yyvsp[0].pset, yyvsp[-6].pset, yyvsp[-4].pset);
	    } else {
		yyerror("Right value set not active");
	    }
	    result = 0;
	}
break;
case 577:
#line 2467 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(cg, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 578:
#line 2492 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 579:
#line 2517 "pars.yacc"
{
	    int i;
	    if (lxy < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (lxy > maxarr) {
		maxarr = lxy;
		init_scratch_arrays(lxy);
	    }
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].val;
	    }
	    result = yyvsp[0].val;
	}
break;
case 580:
#line 2532 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, curset);
#ifndef GRBATCH
	        update_set_status(cg, curset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 581:
#line 2557 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(cg, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 582:
#line 2582 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
#ifndef GRBATCH
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
#endif
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 583:
#line 2610 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (lxy < 0) {
		yyerror("Length of array < 0");
		return 1;
	    } else if (lxy > maxarr) {
		maxarr = lxy;
		init_scratch_arrays(lxy);
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].ptr[i];
	    }
	}
break;
case 584:
#line 2626 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, curset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 585:
#line 2640 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 586:
#line 2654 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 587:
#line 2668 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].val;
	    }
	}
break;
case 588:
#line 2677 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].val;
	    }
	}
break;
case 589:
#line 2686 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].ptr[i];
	    }
	}
break;
case 590:
#line 2695 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].ptr[i];
	    }
	}
break;
case 591:
#line 2704 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].val;
	    }
	}
break;
case 592:
#line 2713 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].val;
	    }
	}
break;
case 593:
#line 2722 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].ptr[i];
	    }
	}
break;
case 594:
#line 2731 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].ptr[i];
	    }
	}
break;
case 595:
#line 2740 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].val;
	    }
	}
break;
case 596:
#line 2749 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].val;
	    }
	}
break;
case 597:
#line 2758 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].ptr[i];
	    }
	}
break;
case 598:
#line 2767 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].ptr[i];
	    }
	}
break;
case 599:
#line 2776 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].val;
	    }
	}
break;
case 600:
#line 2785 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].val;
	    }
	}
break;
case 601:
#line 2798 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].ptr[i];
	    }
	}
break;
case 602:
#line 2813 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].ptr[i];
	    }
	}
break;
case 603:
#line 2828 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].val;
	    }
	}
break;
case 604:
#line 2841 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].val);
	    }
	}
break;
case 605:
#line 2850 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].ptr[i]);
	    }
	}
break;
case 606:
#line 2859 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].val);
	    }
	}
break;
case 607:
#line 2868 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].ptr[i]);
	    }
	}
break;
case 608:
#line 2877 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].val);
	    }
	}
break;
case 609:
#line 2886 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 610:
#line 2895 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = acos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 611:
#line 2904 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = acosh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 612:
#line 2913 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = asin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 613:
#line 2922 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = asinh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 614:
#line 2931 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 615:
#line 2940 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atanh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 616:
#line 2949 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan2(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 617:
#line 2958 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ceil(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 618:
#line 2967 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = cos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 619:
#line 2976 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = cosh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 620:
#line 2985 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] *= M_PI / 180.0;
	    }
	}
break;
case 621:
#line 2994 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erf(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 622:
#line 3003 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erfc(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 623:
#line 3012 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = exp(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 624:
#line 3021 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = floor(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 625:
#line 3030 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 626:
#line 3039 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 627:
#line 3048 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 628:
#line 3057 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 629:
#line 3066 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = i + 1;
	    }
	}
break;
case 630:
#line 3075 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].func;
	    }
	}
break;
case 631:
#line 3084 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (int) yyvsp[-1].ptr[i];
	    }
	}
break;
case 632:
#line 3093 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invnorm(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 633:
#line 3102 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	    }
	}
break;
case 634:
#line 3111 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].ptr[i], (int) yyvsp[-1].val);
	    }
	}
break;
case 635:
#line 3120 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lrand48() % (long) (yyvsp[-1].val);
	    }
	}
break;
case 636:
#line 3129 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lgamma(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 637:
#line 3138 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 638:
#line 3147 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log10(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 639:
#line 3156 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = 1.0 / (1.0 + exp(-(yyvsp[-5].ptr[i] - yyvsp[-3].val)/ yyvsp[-1].val));
	    }
	}
break;
case 640:
#line 3165 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] >= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 641:
#line 3174 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] <= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 642:
#line 3183 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fmod(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 643:
#line 3192 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fx(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 644:
#line 3201 "pars.yacc"
{
	    int i;
	    double tmp;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = normp(yyvsp[-1].ptr[i], &tmp);
	    }
	}
break;
case 645:
#line 3211 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI;
	    }
	}
break;
case 646:
#line 3220 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI / 180.0;
	    }
	}
break;
case 647:
#line 3229 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (double) drand48();
	    }
	}
break;
case 648:
#line 3238 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 649:
#line 3247 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 650:
#line 3256 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 651:
#line 3265 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 652:
#line 3274 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 653:
#line 3283 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sinh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 654:
#line 3292 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i] * yyvsp[-1].ptr[i];
	    }
	}
break;
case 655:
#line 3301 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sqrt(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 656:
#line 3310 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = tan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 657:
#line 3319 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = tanh(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 658:
#line 3327 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
	        if ((int) yyvsp[-4].ptr[i]) {
		    yyval.ptr[i] = yyvsp[-2].ptr[i];
	        } else {
		    yyval.ptr[i] = yyvsp[0].ptr[i];
	        }
	    }
	}
break;
case 659:
#line 3340 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] > yyvsp[0].ptr[i];
	    }
	}
break;
case 660:
#line 3349 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] < yyvsp[0].ptr[i];
	    }
	}
break;
case 661:
#line 3358 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] <= yyvsp[0].ptr[i];
	    }
	}
break;
case 662:
#line 3367 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] >= yyvsp[0].ptr[i];
	    }
	}
break;
case 663:
#line 3376 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] == yyvsp[0].ptr[i];
	    }
	}
break;
case 664:
#line 3385 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] != yyvsp[0].ptr[i];
	    }
	}
break;
case 665:
#line 3394 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] && yyvsp[0].ptr[i];
	    }
	}
break;
case 666:
#line 3403 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] || yyvsp[0].ptr[i];
	    }
	}
break;
case 667:
#line 3412 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = !(yyvsp[0].ptr[i]);
	    }
	}
break;
case 668:
#line 3421 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i];
	    }
	}
break;
case 669:
#line 3429 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = -yyvsp[0].ptr[i];
	    }
	}
break;
case 671:
#line 3440 "pars.yacc"
{
	    yyval.val = yyvsp[0].val;
	}
break;
case 672:
#line 3443 "pars.yacc"
{
	    yyval.val = yyvsp[-3].ptr[(int) yyvsp[-1].val];
	}
break;
case 673:
#line 3446 "pars.yacc"
{
	    yyval.val = (yyvsp[0].pset == X) ? *xx : *yy;
	}
break;
case 674:
#line 3449 "pars.yacc"
{
	    double *ptr = getvptr(cg, curset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 675:
#line 3459 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 676:
#line 3469 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-7].pset, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 677:
#line 3479 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 678:
#line 3494 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 679:
#line 3509 "pars.yacc"
{
	    yyval.val = g[cg].p[yyvsp[-2].pset].len;
	}
break;
case 680:
#line 3513 "pars.yacc"
{
	    double bar, sd;
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
		stasum(ptr, getsetlength(cg, yyvsp[-4].pset), &bar, &sd, 0);
	        yyval.val = bar;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 681:
#line 3525 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val + yyvsp[0].val;
	}
break;
case 682:
#line 3528 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val - yyvsp[0].val;
	}
break;
case 683:
#line 3531 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val * yyvsp[0].val;
	}
break;
case 684:
#line 3535 "pars.yacc"
{
	    if (yyvsp[0].val != 0.0) {
		yyval.val = yyvsp[-2].val / yyvsp[0].val;
	    } else {
		yyerror("Divide by Zero");
		return 1;
	    }
	}
break;
case 685:
#line 3543 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 686:
#line 3546 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 687:
#line 3549 "pars.yacc"
{
	    yyval.val = fabs(yyvsp[-1].val);
	}
break;
case 688:
#line 3552 "pars.yacc"
{
	    yyval.val = acos(yyvsp[-1].val);
	}
break;
case 689:
#line 3555 "pars.yacc"
{
	    yyval.val = acosh(yyvsp[-1].val);
	}
break;
case 690:
#line 3558 "pars.yacc"
{
	    yyval.val = asin(yyvsp[-1].val);
	}
break;
case 691:
#line 3561 "pars.yacc"
{
	    yyval.val = asinh(yyvsp[-1].val);
	}
break;
case 692:
#line 3564 "pars.yacc"
{
	    yyval.val = atan(yyvsp[-1].val);
	}
break;
case 693:
#line 3567 "pars.yacc"
{
	    yyval.val = atanh(yyvsp[-1].val);
	}
break;
case 694:
#line 3570 "pars.yacc"
{
	    yyval.val = atan2(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 695:
#line 3573 "pars.yacc"
{
	    yyval.val = ceil(yyvsp[-1].val);
	}
break;
case 696:
#line 3576 "pars.yacc"
{
	    yyval.val = cos(yyvsp[-1].val);
	}
break;
case 697:
#line 3579 "pars.yacc"
{
	    yyval.val = cosh(yyvsp[-1].val);
	}
break;
case 698:
#line 3582 "pars.yacc"
{
	    yyval.val = 180.0 / M_PI;
	}
break;
case 699:
#line 3585 "pars.yacc"
{
	    yyval.val = erf(yyvsp[-1].val);
	}
break;
case 700:
#line 3588 "pars.yacc"
{
	    yyval.val = erfc(yyvsp[-1].val);
	}
break;
case 701:
#line 3591 "pars.yacc"
{
	    yyval.val = exp(yyvsp[-1].val);
	}
break;
case 702:
#line 3594 "pars.yacc"
{
	    yyval.val = floor(yyvsp[-1].val);
	}
break;
case 703:
#line 3597 "pars.yacc"
{
	    yyval.val = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 704:
#line 3600 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv1;
	}
break;
case 705:
#line 3603 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv2;
	}
break;
case 706:
#line 3606 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv1;
	}
break;
case 707:
#line 3609 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv2;
	}
break;
case 708:
#line 3612 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg1;
	}
break;
case 709:
#line 3615 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg2;
	}
break;
case 710:
#line 3618 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg1;
	}
break;
case 711:
#line 3621 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg2;
	}
break;
case 712:
#line 3624 "pars.yacc"
{
	    yyval.val = g[cg].v.xv1;
	}
break;
case 713:
#line 3627 "pars.yacc"
{
	    yyval.val = g[cg].v.xv2;
	}
break;
case 714:
#line 3630 "pars.yacc"
{
	    yyval.val = g[cg].v.yv1;
	}
break;
case 715:
#line 3633 "pars.yacc"
{
	    yyval.val = g[cg].v.yv2;
	}
break;
case 716:
#line 3636 "pars.yacc"
{
	    yyval.val = g[cg].w.xg1;
	}
break;
case 717:
#line 3639 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2;
	}
break;
case 718:
#line 3642 "pars.yacc"
{
	    yyval.val = g[cg].w.yg1;
	}
break;
case 719:
#line 3645 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2;
	}
break;
case 720:
#line 3648 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2 - g[cg].w.xg1;
	}
break;
case 721:
#line 3651 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2 - g[cg].w.yg1;
	}
break;
case 722:
#line 3654 "pars.yacc"
{
	    yyval.val = setindex;
	}
break;
case 723:
#line 3657 "pars.yacc"
{
	    yyval.val = setsetno;
	}
break;
case 724:
#line 3660 "pars.yacc"
{
	    yyval.val = (long) yyvsp[-1].val;
	}
break;
case 725:
#line 3663 "pars.yacc"
{
	    yyval.val = invnorm(yyvsp[-1].val);
	}
break;
case 726:
#line 3666 "pars.yacc"
{
	    yyval.val = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 727:
#line 3669 "pars.yacc"
{
	    yyval.val = lrand48() % (long) (yyvsp[-1].val);
	}
break;
case 728:
#line 3672 "pars.yacc"
{ /* yr, mo, day */
	    yyval.val = julday((int) yyvsp[-3].val, (int) yyvsp[-1].val, (int) yyvsp[-5].val, 12, 0, 0.0);
	}
break;
case 729:
#line 3676 "pars.yacc"
{ /* yr, mo, day, hr, min, sec */
	    yyval.val = julday((int) yyvsp[-9].val, (int) yyvsp[-7].val, (int) yyvsp[-11].val, (int) yyvsp[-5].val, (int) yyvsp[-3].val, (double) yyvsp[-1].val);
	}
break;
case 730:
#line 3679 "pars.yacc"
{
	    yyval.val = lgamma(yyvsp[-1].val);
	}
break;
case 731:
#line 3682 "pars.yacc"
{
	    yyval.val = log(yyvsp[-1].val);
	}
break;
case 732:
#line 3685 "pars.yacc"
{
	    yyval.val = log10(yyvsp[-1].val);
	}
break;
case 733:
#line 3689 "pars.yacc"
{
	    yyval.val = 1.0 / (1.0 + exp(-(yyvsp[-5].val - yyvsp[-3].val)/ yyvsp[-1].val));
	}
break;
case 734:
#line 3692 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val >= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 735:
#line 3695 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val <= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 736:
#line 3698 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 737:
#line 3701 "pars.yacc"
{
	    yyval.val = fx(yyvsp[-1].val);
	}
break;
case 738:
#line 3704 "pars.yacc"
{
	    double tmp;
	    yyval.val = normp(yyvsp[-1].val, &tmp);
	}
break;
case 739:
#line 3708 "pars.yacc"
{
	    yyval.val = M_PI;
	}
break;
case 740:
#line 3711 "pars.yacc"
{
	    yyval.val = M_PI / 180.0;
	}
break;
case 741:
#line 3714 "pars.yacc"
{
	    yyval.val = (double) drand48();
	}
break;
case 742:
#line 3717 "pars.yacc"
{
	    yyval.val = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 743:
#line 3720 "pars.yacc"
{
	    yyval.val = sin(yyvsp[-1].val);
	}
break;
case 744:
#line 3723 "pars.yacc"
{
	    yyval.val = sinh(yyvsp[-1].val);
	}
break;
case 745:
#line 3726 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-1].val, 2.0);
	}
break;
case 746:
#line 3729 "pars.yacc"
{
	    yyval.val = sqrt(yyvsp[-1].val);
	}
break;
case 747:
#line 3732 "pars.yacc"
{
	    yyval.val = tan(yyvsp[-1].val);
	}
break;
case 748:
#line 3735 "pars.yacc"
{
	    yyval.val = tanh(yyvsp[-1].val);
	}
break;
case 749:
#line 3738 "pars.yacc"
{
	    if ((int) yyvsp[-4].val) {
		yyval.val = yyvsp[-2].val;
	    } else {
		yyval.val = yyvsp[0].val;
	    }
	}
break;
case 750:
#line 3745 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val > yyvsp[0].val;
	}
break;
case 751:
#line 3748 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val < yyvsp[0].val;
	}
break;
case 752:
#line 3751 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val <= yyvsp[0].val;
	}
break;
case 753:
#line 3754 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val >= yyvsp[0].val;
	}
break;
case 754:
#line 3757 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val == yyvsp[0].val;
	}
break;
case 755:
#line 3760 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val != yyvsp[0].val;
	}
break;
case 756:
#line 3763 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val && yyvsp[0].val;
	}
break;
case 757:
#line 3766 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val || yyvsp[0].val;
	}
break;
case 758:
#line 3769 "pars.yacc"
{
	    yyval.val = !(yyvsp[0].val);
	}
break;
case 759:
#line 3772 "pars.yacc"
{
	    yyval.val = yyvsp[-1].val;
	}
break;
case 760:
#line 3775 "pars.yacc"
{
	    yyval.val = -yyvsp[0].val;
	}
break;
#line 10848 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
